//
//  AppCommonMethods.swift
//  globalfoods
//
//  Created by Apple on 29/10/20.
//

import Foundation
import UIKit
import SideMenuSwift

class AppCommonMethods: AppConstants{
    
    static func setIntialScreen(){
        if employeeData == nil{
            if userData == nil{
                if subCustomerData == nil{
                    if let VC = LoginVC.instance(){
                        let navc = UINavigationController.init(rootViewController: VC)
                        navc.isNavigationBarHidden = true
                        appDelegate.window?.rootViewController = navc
                    }
                }else{
                    if let VC = UIStoryboard.init(name: "SideMenu", bundle: nil).instantiateViewController(withIdentifier: "SideMenuController") as? SideMenuController{
                        setupSideView(VC)
                        appDelegate.window!.rootViewController = VC
                    }
                }
            }else{
                if selectedBranch == nil{
                    if let VC = SelectBranchVC.instance(){
                        appDelegate.window!.rootViewController = VC
                    }
                }else{
                    if let VC = UIStoryboard.init(name: "SideMenu", bundle: nil).instantiateViewController(withIdentifier: "SideMenuController") as? SideMenuController{
                        setupSideView(VC)
                        appDelegate.window!.rootViewController = VC
                    }
                }
            }
        }else{
            if printerIP == nil{
                if let VC = SelectBranchVC.instance(){
                    VC.isPrinterView = true
                    appDelegate.window!.rootViewController = VC
                }
            }else{
                if let VC = UIStoryboard.init(name: "SideMenu", bundle: nil).instantiateViewController(withIdentifier: "SideMenuController") as? SideMenuController{
                    setupSideView(VC)
                    appDelegate.window!.rootViewController = VC
                }
            }
        }
        
    }
    
    static func removefromUserDefault(withKey key:String){
        UserDefaults.standard.removeObject(forKey: key)
        UserDefaults.standard.synchronize()
    }
    
    static func readStringfromUserDefault(withKey key:String) -> String?{
        return UserDefaults.standard.string(forKey: key)
    }
    
    static func readObjfromUserDefault(withKey key:String) -> Any?{
        return UserDefaults.standard.object(forKey: key)
    }
    
    static func saveDataIntoUserDefault(value:Any?, withKey key:String){
        if value != nil{
            UserDefaults.standard.setValue(value, forKey: key)
            UserDefaults.standard.synchronize()
        }
    }
    
    static func setupSideView(_ sideMenuController:SideMenuController){
        if let VC = DashboardVC.instance(){
            let navc = UINavigationController.init(rootViewController: VC)
            navc.isNavigationBarHidden = true
            sideMenuController.cache(viewControllerGenerator: {navc}, with: "\(SideMenuCellType.kDashboard)")
        }
        if let VC = EmployeeDashboardVC.instance(){
            let navc = UINavigationController.init(rootViewController: VC)
            navc.isNavigationBarHidden = true
            sideMenuController.cache(viewControllerGenerator: {navc}, with: "\(SideMenuCellType.kEmployeeDashboard)")
        }
        if let VC = CreateOrderVC.instance(){
            let navc = UINavigationController.init(rootViewController: VC)
            navc.isNavigationBarHidden = true
            sideMenuController.cache(viewControllerGenerator: {navc}, with: "\(SideMenuCellType.kCreateOrder)")
        }
        if let VC = CreateOrderVC.instance(){
            VC.isSalesOrder = true
            let navc = UINavigationController.init(rootViewController: VC)
            navc.isNavigationBarHidden = true
            sideMenuController.cache(viewControllerGenerator: {navc}, with: "\(SideMenuCellType.kCreateSalesOrder)")
        }
        if let VC = SalesReportVC.instance(){
            let navc = UINavigationController.init(rootViewController: VC)
            navc.isNavigationBarHidden = true
            sideMenuController.cache(viewControllerGenerator: {navc}, with: "\(SideMenuCellType.kSalesReport)")
        }
        if let VC = OrderHistoryVC.instance(){
            let navc = UINavigationController.init(rootViewController: VC)
            navc.isNavigationBarHidden = true
            sideMenuController.cache(viewControllerGenerator: {navc}, with: "\(SideMenuCellType.kOrderHistory)")
        }
        if let VC = OrderHistoryVC.instance(){
            VC.isSalesOrder = true
            let navc = UINavigationController.init(rootViewController: VC)
            navc.isNavigationBarHidden = true
            sideMenuController.cache(viewControllerGenerator: {navc}, with: "\(SideMenuCellType.kSalesOrderHistory)")
        }
        if let VC = InvoiceVC.instance(){
            let navc = UINavigationController.init(rootViewController: VC)
            navc.isNavigationBarHidden = true
            sideMenuController.cache(viewControllerGenerator: {navc}, with: "\(SideMenuCellType.kInvoice)")
        }
        if let VC = CreditNoteVC.instance(){
            let navc = UINavigationController.init(rootViewController: VC)
            navc.isNavigationBarHidden = true
            sideMenuController.cache(viewControllerGenerator: {navc}, with: "\(SideMenuCellType.kCreateNote)")
        }
        if let VC = DeliveriesVC.instance(){
            let navc = UINavigationController.init(rootViewController: VC)
            navc.isNavigationBarHidden = true
            sideMenuController.cache(viewControllerGenerator: {navc}, with: "\(SideMenuCellType.kDeliveries)")
        }
        if let VC = PaymentListVC.instance(){
            let navc = UINavigationController.init(rootViewController: VC)
            navc.isNavigationBarHidden = true
            sideMenuController.cache(viewControllerGenerator: {navc}, with: "\(SideMenuCellType.kPayment)")
        }
        if let VC = DispatchesVC.instance(){
            let navc = UINavigationController.init(rootViewController: VC)
            navc.isNavigationBarHidden = true
            sideMenuController.cache(viewControllerGenerator: {navc}, with: "\(SideMenuCellType.kDispatches)")
        }
        if let VC = RepoVisitVC.instance(){
            let navc = UINavigationController.init(rootViewController: VC)
            navc.isNavigationBarHidden = true
            sideMenuController.cache(viewControllerGenerator: {navc}, with: "\(SideMenuCellType.kRepoVisits)")
        }
        if let VC = ChecklistVC.instance(){
            let navc = UINavigationController.init(rootViewController: VC)
            navc.isNavigationBarHidden = true
            sideMenuController.cache(viewControllerGenerator: {navc}, with: "\(SideMenuCellType.kChecklist)")
        }
        if let VC = SupportVC.instance(){
            let navc = UINavigationController.init(rootViewController: VC)
            navc.isNavigationBarHidden = true
            sideMenuController.cache(viewControllerGenerator: {navc}, with: "\(SideMenuCellType.kSupport)")
        }
        if let VC = AccountVC.instance(){
            let navc = UINavigationController.init(rootViewController: VC)
            navc.isNavigationBarHidden = true
            sideMenuController.cache(viewControllerGenerator: {navc}, with: "\(SideMenuCellType.kAccount)")
        }
        if let VC = NotificationsVC.instance(){
            let navc = UINavigationController.init(rootViewController: VC)
            navc.isNavigationBarHidden = true
            sideMenuController.cache(viewControllerGenerator: {navc}, with: "\(SideMenuCellType.kNotification)")
        }
        if let VC = ProfileVC.instance(){
            let navc = UINavigationController.init(rootViewController: VC)
            navc.isNavigationBarHidden = true
            sideMenuController.cache(viewControllerGenerator: {navc}, with: "\(SideMenuCellType.kProfile)")
        }
        if let VC = TermsConditionVC.instance(){
            let navc = UINavigationController.init(rootViewController: VC)
            navc.isNavigationBarHidden = true
            sideMenuController.cache(viewControllerGenerator: {navc}, with: "\(SideMenuCellType.kTermCondition)")
        }
        if let VC = ReturnOrderVC.instance(){
            let navc = UINavigationController.init(rootViewController: VC)
            navc.isNavigationBarHidden = true
            sideMenuController.cache(viewControllerGenerator: {navc}, with: "\(SideMenuCellType.kReturnOrder)")
        }
        if let VC = OrderLayawayVC.instance(){
            let navc = UINavigationController.init(rootViewController: VC)
            navc.isNavigationBarHidden = true
            sideMenuController.cache(viewControllerGenerator: {navc}, with: "\(SideMenuCellType.kLayAway)")
        }
        SideMenuController.preferences.basic.menuWidth = DeviceType.IS_IPAD ? 420 : 260
        SideMenuController.preferences.basic.direction = .left
        SideMenuController.preferences.basic.position = .above
        if employeeData != nil{
            sideMenuController.contentSegueID = "EmployeeDashboardContent"
        }else{
            sideMenuController.contentSegueID = "DashboardContent"
        }
        
        
    }
    
    static var LoaderParentView:UIView?
    
    static func startProgressBar(view:UIView? = nil, isWhiteBG:Bool = false, isInteractive:Bool = false)
    {
        if view == nil{
            if LoaderParentView != nil{
                stopProgressBar()
            }
            LoaderParentView = appDelegate.window
        }
        
        let width = UIScreen.main.bounds.width
        let height = UIScreen.main.bounds.height
        let viewLoader = UIViewX.init(frame: CGRect.init(x: (width-120)/2, y: (height-120)/2, width: 120, height: 120))
        viewLoader.backgroundColor = .clear
        
        let activityIndicator = UIActivityIndicatorView.init(style: .whiteLarge)
        activityIndicator.color = Colors.kAppMainThemeColor
        activityIndicator.frame = CGRect.init(x: (viewLoader.frame.width-37)/2, y: (viewLoader.frame.width-37)/2, width: 37, height: 37)
        activityIndicator.startAnimating()
        activityIndicator.transform = CGAffineTransform.init(scaleX: 2, y: 2)
        viewLoader.addSubview(activityIndicator)
        
        let viewBG = UIView.init(frame: CGRect.init(x: 0, y: 0, width: width, height: height))
        viewBG.tag = 10987
        viewBG.backgroundColor = isWhiteBG ? .white : .clear
        viewBG.addSubview(viewLoader)
        
        if isInteractive{
            viewBG.frame = CGRect.init(x: (width-120)/2, y: (height-120)/2, width: 120, height: 120)
            viewLoader.frame = CGRect.init(x: 0, y: 0, width: 120, height: 120)
        }
        
        if view == nil{
            LoaderParentView!.addSubview(viewBG)
        }else{
            view!.addSubview(viewBG)
        }
        
    }
    
    static func stopProgressBar(view:UIView? = nil)
    {
        if view != nil{
            for subView in (view!.subviews)
            {
                if subView.tag == 10987
                {
                    subView.isHidden = true
                    subView.removeFromSuperview()
                    break
                }
            }
        }else{
            if LoaderParentView != nil{
                for subView in (LoaderParentView!.subviews)
                {
                    if subView.tag == 10987
                    {
                        subView.isHidden = true
                        subView.removeFromSuperview()
                        break
                    }
                }
                LoaderParentView = nil
            }
        }
        
    }
    
    static func getjsonDataFromCodable<T: Codable>(object:T,isWithoutSlash:Bool = false)->Data? {
        let encoder = JSONEncoder()
        encoder.outputFormatting = [.prettyPrinted,.sortedKeys]
        if isWithoutSlash{
            if #available(iOS 13.0, *) {
                encoder.outputFormatting = [.withoutEscapingSlashes]
            }else{
                encoder.outputFormatting = [.sortedKeys]
            }
        }
        guard let jsonData = try? encoder.encode(object) else { return nil }
        return jsonData
    }
    
    static func convertToJson(object:Any)->Data?{
        do {
            let jsonData = try JSONSerialization.data(withJSONObject: object, options: .prettyPrinted)
            return jsonData
            
        } catch {
            print(error.localizedDescription)
            return nil
        }
    }
    
    static func convertJsontoString(json: Any, prettyPrinted: Bool = false) -> String{
        var options: JSONSerialization.WritingOptions = []
        if prettyPrinted {
            options = JSONSerialization.WritingOptions.prettyPrinted
        }
        
        do {
            let data = try JSONSerialization.data(withJSONObject: json, options: options)
            if let string = String(data: data, encoding: String.Encoding.utf8) {
                return string
            }
        } catch {
            print(error)
        }
        
        return ""
    }
    
    static func getCustomerDataAPI(userId:Int? = nil, Completed : @escaping (_ status: Bool) -> ()){
        if userData == nil && userId == nil{
            Completed(false)
            return
        }
        DispatchQueue.global(qos: .background).async {
            var param = [String:String]()
            param["key"] = commonConstant.kAPIKey
            param["s"] = "9"
            param["cuid"] = "\(userData?.id ?? (userId ?? 0))"
            WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: APIURLs.kServiceCustomerURL) { (message, response) in
                DispatchQueue.main.async {
                    if response != nil{
                        if isInDevlopmentMode{
                            print("Customer Data:",response!)
                        }
                        if let result = response!["result"] as? NSDictionary, response!.getIntValue("ack") ?? 0 == 1{
                            if let data = convertToJson(object: result){
                                let jsonDecoder = JSONDecoder()
                                if let aLoginData = try? jsonDecoder.decode(UserModel.self, from: data){
                                    if let encoded = getjsonDataFromCodable(object: aLoginData) {
                                        saveDataIntoUserDefault(value: encoded, withKey: userDefaultKey.kUserData)
                                        if selectedBranch != nil && aLoginData.arrBranchs != nil{
                                            let bModel = aLoginData.arrBranchs!.filter { (model) -> Bool in
                                                return selectedBranch?.id ?? 0 == model.id ?? 0
                                            }
                                            if bModel.count > 0{
                                                if let encodedBranch = getjsonDataFromCodable(object: bModel[0]) {
                                                    saveDataIntoUserDefault(value: encodedBranch, withKey: userDefaultKey.kSelectedBranch)
                                                }
                                            }
                                        }
                                        Completed(true)
                                        return
                                    }
                                }
                            }
                        }
                    }
                    Completed(false)
                }
            }
        }
    }
    
    static func getEmployeeDataAPI(Completed : @escaping (_ status: Bool) -> ()){
        if employeeData == nil{
            return
        }
        DispatchQueue.global(qos: .background).async {
            var param = [String:String]()
            param["key"] = commonConstant.kAPIKey
            param["s"] = "45"
            param["emp_id"] = "\(employeeData?.id ?? 0)"
            WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: APIURLs.kServiceEmployeeURL) { (message, response) in
                DispatchQueue.main.async {
                    if response != nil{
                        if isInDevlopmentMode{
                            print("Employee Data:",response!)
                        }
                        if let result = response!["result"] as? NSDictionary, response!.getIntValue("ack") ?? 0 == 1{
                            if let data = convertToJson(object: result){
                                let jsonDecoder = JSONDecoder()
                                if let aLoginData = try? jsonDecoder.decode(EmployeeModel.self, from: data){
                                    if let encoded = getjsonDataFromCodable(object: aLoginData) {
                                        saveDataIntoUserDefault(value: encoded, withKey: userDefaultKey.kEmployeeData)
                                        NotificationCenter.default.post(name: notifications.kEmployeeDataFetch, object: nil, userInfo: nil)
                                        Completed(true)
                                        return
                                    }
                                }
                            }
                        }
                    }
                    Completed(false)
                }
            }
        }
    }
    
    static func getGlobalFoodDataAPI(){
        DispatchQueue.global(qos: .background).async {
            var param = [String:String]()
            param["key"] = commonConstant.kAPIKey
            param["s"] = "126"
            WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: APIURLs.kServiceGeneralURL) { (message, response) in
                DispatchQueue.main.async {
                    if response != nil{
                        if isInDevlopmentMode{
                            print("Globl Food Info:",response!)
                        }
                        if let result = response!["result"] as? NSDictionary, response!.getIntValue("ack") ?? 0 == 1{
                            dictGlobalFoodInfo = result
                        }
                    }
                }
            }
        }
    }
    
    static func getUUID() -> String? {
        let keychain = KeychainAccess()
        let uuidKey = "com.globalfoods.unique_uuid"
        if let uuid = try? keychain.queryKeychainData(itemKey: uuidKey) {
            return uuid
        }
        guard let newId = UIDevice.current.identifierForVendor?.uuidString else {
            return nil
        }
        try? keychain.addKeychainData(itemKey: uuidKey, itemValue: newId)
        return newId
    }
    
    static func saveCartIntoLayAway(cart:UserCartModel){
        let index = arrLayAway.firstIndex { model in
            return model.cartId ?? 0 == cart.cartId ?? 0
        }
        if index != nil{
            arrLayAway[index!] = cart
        }else{
            arrLayAway.append(cart)
        }
        if let encoded = try? PropertyListEncoder().encode(arrLayAway){
            let paths = NSSearchPathForDirectoriesInDomains(.documentDirectory, .userDomainMask, true) as NSArray
            let documentDirectory = paths[0] as! String
            let path = documentDirectory.appending("cartLayaway_\(employeeData?.id ?? 0).plist")
            do {
                try encoded.write(to: URL.init(fileURLWithPath: path), options: .atomic)
            }catch (let err){
                print(err.localizedDescription)
            }
        }
    }
    
    static func getCartsFromLayAway(){
        let paths = NSSearchPathForDirectoriesInDomains(.documentDirectory, .userDomainMask, true) as NSArray
        let documentDirectory = paths[0] as! String
        let path = documentDirectory.appending("cartLayaway_\(employeeData?.id ?? 0).plist")
        print(path)
        let fileManager = FileManager.default
        arrLayAway.removeAll()
        if fileManager.fileExists(atPath: path) {
            if let data = try? Data.init(contentsOf: URL.init(fileURLWithPath: path)), let aData = try? PropertyListDecoder().decode([UserCartModel].self, from: data){
                arrLayAway = aData
            }
        }
    }
    
    static func deleteCartFromLayAway(cart:UserCartModel){
        let index = arrLayAway.firstIndex { model in
            return model.cartId ?? 0 == cart.cartId ?? 0
        }
        if index != nil{
            arrLayAway.remove(at: index!)
            if let encoded = try? PropertyListEncoder().encode(arrLayAway){
                let paths = NSSearchPathForDirectoriesInDomains(.documentDirectory, .userDomainMask, true) as NSArray
                let documentDirectory = paths[0] as! String
                let path = documentDirectory.appending("cartLayaway_\(employeeData?.id ?? 0).plist")
                do {
                    try encoded.write(to: URL.init(fileURLWithPath: path), options: .atomic)
                }catch (let err){
                    print(err.localizedDescription)
                }
            }
        }
    }
}

class KeychainAccess {
    
    func addKeychainData(itemKey: String, itemValue: String) throws {
        guard let valueData = itemValue.data(using: .utf8) else {
            print("Keychain: Unable to store data, invalid input - key: \(itemKey), value: \(itemValue)")
            return
        }
        
        let queryAdd: [String: AnyObject] = [
            kSecClass as String: kSecClassGenericPassword,
            kSecAttrAccount as String: itemKey as AnyObject,
            kSecValueData as String: valueData as AnyObject,
            kSecAttrAccessible as String: kSecAttrAccessibleWhenUnlocked
        ]
        let resultCode: OSStatus = SecItemAdd(queryAdd as CFDictionary, nil)
        
        if resultCode != 0 {
            print("Keychain: value not added - Error: \(resultCode)")
        } else {
            print("Keychain: value added successfully")
        }
    }
    
    func queryKeychainData (itemKey: String) throws -> String? {
        let queryLoad: [String: AnyObject] = [
            kSecClass as String: kSecClassGenericPassword,
            kSecAttrAccount as String: itemKey as AnyObject,
            kSecReturnData as String: kCFBooleanTrue,
            kSecMatchLimit as String: kSecMatchLimitOne
        ]
        var result: AnyObject?
        let resultCodeLoad = withUnsafeMutablePointer(to: &result) {
            SecItemCopyMatching(queryLoad as CFDictionary, UnsafeMutablePointer($0))
        }
        
        if resultCodeLoad != 0 {
            print("Keychain: unable to load data - \(resultCodeLoad)")
            return nil
        }
        
        guard let resultVal = result as? NSData, let keyValue = NSString(data: resultVal as Data, encoding: String.Encoding.utf8.rawValue) as String? else {
            print("Keychain: error parsing keychain result - \(resultCodeLoad)")
            return nil
        }
        return keyValue
    }
}

class InteractivePopRecognizer: NSObject, UIGestureRecognizerDelegate {
    
    var navigationController: UINavigationController
    
    init(controller: UINavigationController) {
        self.navigationController = controller
    }
    
    func gestureRecognizerShouldBegin(_ gestureRecognizer: UIGestureRecognizer) -> Bool {
        return navigationController.viewControllers.count > 1
    }
    
    func gestureRecognizer(_ gestureRecognizer: UIGestureRecognizer, shouldRecognizeSimultaneouslyWith otherGestureRecognizer: UIGestureRecognizer) -> Bool {
        return true
    }
}

class HeaderView:UIView{
    
    var title:String?
    var isBackEnbaled = false
    var controller:UIViewController!
    var lblName:UILabel?
    var lblCartCount:UILabelX?
    var cartCount = 0
    
    init(controller: UIViewController, title:String?, isBackEnbaled:Bool) {
        super.init(frame: CGRect.zero)
        self.isBackEnbaled = isBackEnbaled
        self.controller = controller
        self.title = title
        setHeaderView()
        NotificationCenter.default.addObserver(self, selector: #selector(branchChanged), name: AppConstants.notifications.kBranchChanged, object: nil)
        NotificationCenter.default.addObserver(self, selector: #selector(cartCountChanged(_:)), name: AppConstants.notifications.kUserCartChanged, object: nil)
        if lblCartCount != nil{
            callGetCountAPI()
        }
        NotificationCenter.default.addObserver(self, selector: #selector(setHeaderView), name: UIDevice.orientationDidChangeNotification, object: nil)
    }
    
    deinit {
        NotificationCenter.default.removeObserver(self)
    }
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    func callGetCountAPI(){
        if AppConstants.employeeData != nil{
            self.cartCount = AppConstants.employeeCart?.cartitems?.count ?? 0
            if self.cartCount != 0{
                self.lblCartCount?.isHidden = false
                self.lblCartCount?.text = "\(self.cartCount)"
            }
            return
        }
        var param = [String:String]()
        param["key"] = AppConstants.commonConstant.kAPIKey
        param["s"] = "39"
        if AppConstants.subCustomerData != nil{
            param["cuid"] = "\(AppConstants.subCustomerData?.cid ?? 0)"
            param["cbid"] = "\(AppConstants.subCustomerData?.cbid ?? 0)"
        }else{
            param["cuid"] = "\(AppConstants.userData?.id ?? 0)"
            param["cbid"] = "\(AppConstants.selectedBranch?.id ?? 0)"
        }
        
        WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: AppConstants.APIURLs.kServiceCartURL) { (message, response) in
            DispatchQueue.main.async {
                self.lblCartCount?.isHidden = true
                if response != nil{
                    if AppConstants.isInDevlopmentMode{
                        print("Count Data:",response!)
                    }
                    if response!.getIntValue("ack") ?? 0 == 1,let result = response!["result"] as? NSDictionary, let arr = result["cartitems"] as? [NSDictionary]{
                        if self.lblCartCount != nil{
                            self.cartCount = arr.count
                            if self.cartCount != 0{
                                self.lblCartCount?.isHidden = false
                                self.lblCartCount?.text = "\(self.cartCount)"
                            }
                        }
                    }
                }
            }
        }
    }
    
    @objc func cartCountChanged(_ notification:Notification){
        if self.lblCartCount != nil, let userInfo = notification.userInfo, let count = userInfo["userCartCount"] as? Int{
            self.cartCount = count
            if self.cartCount != 0{
                self.lblCartCount?.isHidden = false
                self.lblCartCount?.text = "\(self.cartCount)"
            }else{
                self.lblCartCount?.isHidden = true
            }
        }
    }
    
    @objc func branchChanged(){
        if self.lblName != nil{
            self.lblName!.text = AppConstants.selectedBranch?.name ?? ""
        }
    }
    
    @objc func setHeaderView(){
        self.subviews.forEach { view in
            view.removeFromSuperview()
        }
        
        let xLogo:CGFloat = (AppConstants.DeviceType.IS_IPAD ? 70 : 50)
        
        let btnBack = UIButton.init(frame: CGRect.init(x: 0, y: AppConstants.ScreenSize.topPadding, width: (AppConstants.DeviceType.IS_IPAD ? 60 : 50), height: (AppConstants.DeviceType.IS_IPAD ? 60 : 50)))
        btnBack.setImage(UIImage.init(named: isBackEnbaled ? "ic_back" : "menu"), for: .normal)
        btnBack.addTarget(self, action: #selector(btnBackAction), for: .touchUpInside)
        self.addSubview(btnBack)
        
        let viewProfile = UIViewX.init(frame: CGRect.init(x: UIScreen.main.bounds.size.width-(AppConstants.DeviceType.IS_IPAD ? 160 : 140), y: AppConstants.ScreenSize.topPadding+(AppConstants.DeviceType.IS_IPAD ? 10 : 8), width: (AppConstants.DeviceType.IS_IPAD ? 140 : 120), height: (AppConstants.DeviceType.IS_IPAD ? 40 : 34)))
        viewProfile.cornerRadius = 3
        viewProfile.backgroundColor = AppConstants.Colors.kAppDarkThemeColor
        
        self.lblName = UILabel.init(frame: CGRect.init(x: 5, y: 0, width: viewProfile.frame.width-10, height: viewProfile.frame.height))
        if AppConstants.userData != nil{
            self.lblName!.text = AppConstants.selectedBranch?.name ?? ""
        }else if AppConstants.employeeData != nil{
            self.lblName!.text = AppConstants.employeeData?.name ?? ""
        }else{
            self.lblName!.text = AppConstants.subCustomerData?.branchName ?? ""
        }
        self.lblName!.minimumScaleFactor = 0.5
        self.lblName!.textAlignment = .center
        self.lblName!.numberOfLines = 2
        self.lblName!.adjustsFontSizeToFitWidth = true
        self.lblName!.textColor = .white
        self.lblName!.font = AppConstants.GlobalFontConstants.kRegularFont(size: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
        viewProfile.addSubview(self.lblName!)
        
        let btnBranch = UIButton.init(frame: CGRect.init(x: 0, y: 0, width: viewProfile.frame.width, height: viewProfile.frame.height))
        btnBranch.addTarget(self, action: #selector(btnSelectBranchAction), for: .touchUpInside)
        viewProfile.addSubview(btnBranch)
        
        self.addSubview(viewProfile)
        
        if !(controller is UserCartVC){
            if AppConstants.userData != nil || AppConstants.employeeData?.rights?.order?.view ?? 0 == 1 || AppConstants.subCustomerData != nil{
                let viewCart = UIViewX.init(frame: CGRect.init(x: viewProfile.frame.origin.x - (AppConstants.DeviceType.IS_IPAD ? 65 : 55), y: AppConstants.ScreenSize.topPadding, width: (AppConstants.DeviceType.IS_IPAD ? 60 : 50), height: (AppConstants.DeviceType.IS_IPAD ? 60 : 50)))
                
                let imgCart = UIImageViewX.init(frame: CGRect.init(x: 14, y: 5, width: 22, height: 22))
                if AppConstants.DeviceType.IS_IPAD{
                    imgCart.frame = CGRect.init(x: 17, y: 5, width: 26, height: 26)
                }
                imgCart.contentMode = .scaleAspectFit
                imgCart.image = UIImage.init(named: "ic_cart")
                viewCart.addSubview(imgCart)
                
                let lblCart = UILabel.init(frame: CGRect.init(x: 0, y: (AppConstants.DeviceType.IS_IPAD ? 33 : 29), width: viewCart.frame.width, height: (AppConstants.DeviceType.IS_IPAD ? 22 : 18)))
                lblCart.text = "Cart"
                lblCart.minimumScaleFactor = 0.5
                lblCart.textAlignment = .center
                lblCart.textColor = .white
                lblCart.adjustsFontSizeToFitWidth = true
                lblCart.font = AppConstants.GlobalFontConstants.kMediumFont(size: (AppConstants.DeviceType.IS_IPAD ? 14 : 12))
                viewCart.addSubview(lblCart)
                
                let btnCart = UIButton.init(frame: CGRect.init(x: 0, y: 0, width: viewCart.frame.width, height: viewCart.frame.height))
                btnCart.addTarget(self, action: #selector(btnGoToCartAction), for: .touchUpInside)
                viewCart.addSubview(btnCart)
                
                self.addSubview(viewCart)
                
                lblCartCount = UILabelX.init(frame: CGRect.init(x: viewCart.frame.origin.x+28, y: viewCart.frame.origin.y-4, width: 22, height: 22))
                if AppConstants.DeviceType.IS_IPAD{
                    lblCartCount!.frame = CGRect.init(x: viewCart.frame.origin.x+32, y: viewCart.frame.origin.y-4, width: 24, height: 24)
                }
                
                lblCartCount!.minimumScaleFactor = 0.5
                lblCartCount!.textAlignment = .center
                lblCartCount!.textColor = .white
                lblCartCount!.backgroundColor = AppConstants.Colors.kAppRedColor
                lblCartCount?.cornerRadius = (AppConstants.DeviceType.IS_IPAD ? 12 : 11)
                lblCartCount?.clipsToBounds = true
                lblCartCount!.adjustsFontSizeToFitWidth = true
                lblCartCount!.font = AppConstants.GlobalFontConstants.kMediumFont(size: (AppConstants.DeviceType.IS_IPAD ? 14 : 12))
                lblCartCount?.isHidden = true
                self.addSubview(lblCartCount!)
            }
        }
        
        
        if title != nil{
            var width = viewProfile.frame.origin.x - (AppConstants.DeviceType.IS_IPAD ? 80 : 60)
            if lblCartCount != nil{
                width = viewProfile.frame.origin.x - (AppConstants.DeviceType.IS_IPAD ? 140 : 110)
            }
            let lblTitle = UILabel.init(frame: CGRect.init(x: xLogo, y: AppConstants.ScreenSize.topPadding, width: width, height: (AppConstants.DeviceType.IS_IPAD ? 60 : 50)))
            lblTitle.text = title!
            lblTitle.textAlignment = .left
            lblTitle.font = AppConstants.GlobalFontConstants.kMediumFont(size: (AppConstants.DeviceType.IS_IPAD ? 24 : 21))
            lblTitle.adjustsFontSizeToFitWidth = true
            lblTitle.minimumScaleFactor = 0.5
            lblTitle.numberOfLines = 2
            lblTitle.textColor = .white
            self.addSubview(lblTitle)
        }
        
        self.backgroundColor = AppConstants.Colors.kAppMainThemeColor
        controller.view.addSubview(self)
        
        self.frame = CGRect.init(x: 0, y: 0, width: UIScreen.main.bounds.size.width, height: (AppConstants.DeviceType.IS_IPAD ? 60 : 50) + AppConstants.ScreenSize.topPadding)
        
    }
    
    @IBAction func btnSelectBranchAction() {
        if AppConstants.userData != nil{
            if let VC = SelectBranchVC.instance(){
                VC.isBackEnabled = true
                self.controller.navigationController!.pushViewController(VC, animated: true)
            }
        }
    }
    
    @IBAction func btnGoToCartAction() {
        if cartCount == 0{
            var setting = BottomAlertSettings()
            setting.strMessage = AppConstants.GlobalAlert.ALERT_NO_CART
            AppValidation.shared.showBottomAlertView(settings: setting)
        }else{
            if let VC = UserCartVC.instance(){
                if controller is CreateOrderVC{
                    VC.delegate = (controller as! CreateOrderVC)
                }
                controller.navigationController?.pushViewController(VC, animated: true)
            }
        }
    }
    
    @IBAction func btnBackAction() {
        if isBackEnbaled{
            controller.navigationController?.popViewController(animated: true)
        }else{
            controller.sideMenuController?.revealMenu()
        }
    }
}

struct AppUtility {
    
    static func lockOrientation(_ orientation: UIInterfaceOrientationMask) {
        AppConstants.appDelegate.orientationLock = orientation
    }
    
    static func lockOrientation(_ orientation: UIInterfaceOrientationMask, andRotateTo rotateOrientation:UIInterfaceOrientation) {
        self.lockOrientation(orientation)
        UIDevice.current.setValue(rotateOrientation.rawValue, forKey: "orientation")
        UINavigationController.attemptRotationToDeviceOrientation()
    }
    
}

