//
//  AppConstants.swift
//  globalfoods
//
//  Created by Apple on 23/10/20.
//

import Foundation
import UIKit

class AppConstants {
    
    static var BASEURL = ""
    static var DEVICENAME = "iOS"
    static var isInDevlopmentMode = false
    static var dictGlobalFoodInfo = NSDictionary()
    
    static var isBranchChanged = false
    static var arrLayAway = [UserCartModel]()
    static var currencySign = "£"
    
    static var employeeCart:UserCartModel?
    
    static var printerIP : String? {
        return UserDefaults.standard.value(forKey: userDefaultKey.kPrinterIPAddress) as? String
    }
    
    static var deviceToken : String? {
        return UserDefaults.standard.value(forKey: userDefaultKey.kDeviceToken) as? String
    }
    
    static var selectedBranch: branchModel? {
        if let savedData = UserDefaults.standard.value(forKey: userDefaultKey.kSelectedBranch) as? Data {
            let decoder = JSONDecoder()
            if let loadedData = try? decoder.decode(branchModel.self, from: savedData) {
                return loadedData
            }
            else {
                return nil
            }
        }
        else {
            return nil
        }
    }
    
    static var employeeData: EmployeeModel? {
        if let savedLoginData = UserDefaults.standard.value(forKey: userDefaultKey.kEmployeeData) as? Data {
            let decoder = JSONDecoder()
            if let loadedData = try? decoder.decode(EmployeeModel.self, from: savedLoginData) {
                return loadedData
            }
            else {
                return nil
            }
        }
        else {
            return nil
        }
    }
    
    static var userData: UserModel? {
        if let savedLoginData = UserDefaults.standard.value(forKey: userDefaultKey.kUserData) as? Data {
            let decoder = JSONDecoder()
            if let loadedData = try? decoder.decode(UserModel.self, from: savedLoginData) {
                return loadedData
            }
            else {
                return nil
            }
        }
        else {
            return nil
        }
    }
    
    static var subCustomerData: SubCustomerModel? {
        if let savedLoginData = UserDefaults.standard.value(forKey: userDefaultKey.kSubCustomerData) as? Data {
            let decoder = JSONDecoder()
            if let loadedData = try? decoder.decode(SubCustomerModel.self, from: savedLoginData) {
                return loadedData
            }
            else {
                return nil
            }
        }
        else {
            return nil
        }
    }
    
    struct commonConstant {
        static let kAPIKey = "1226"
    }
    
    struct APIURLs {
        static let kBASEURL = "https://manager.globalfoodsltd.co.uk/rms/service/" //Live
//        static let kBASEURL = "http://global.smartmps.co.uk/rms/service/" //Stage
        static let kServiceCustomerURL = kBASEURL + "service_customer.php"
        static let kServiceCartURL = kBASEURL + "service_cart.php"
        static let kCreateOrderURL = kBASEURL + "service_genral.php"
        static let kServiceGeneralURL = kBASEURL + "service_general.php"
        static let kServiceOrderURL = kBASEURL + "service_order.php"
        static let kServiceChatURL = kBASEURL + "service_chat.php"
        static let kServiceEmployeeURL = kBASEURL + "service_employee.php"
    }
    
    static var appDelegate = UIApplication.shared.delegate as! AppDelegate
    
    struct GlobalAlert{
        // Alert Title
        static let ALERT_TITLE = "Global Foods"
        
        // Alert Button Titles
        static let ALERT_BTN_OK = "Ok"
        static let ALERT_BTN_NO = "NO"
        static let ALERT_BTN_YES = "YES"
        static let ALERT_BTN_CANCEL = "Cancel"
        
        static let kServerErrorMsg = "Sorry! Something went wrong. Please try again later"
        static let ALERT_EMPTY_EMAIL = "Please enter email address"
        static let ALERT_INVALID_EMAIL = "Please enter valid email address"
        static let ALERT_EMPTY_PASSWORD = "Please enter password"
        static let ALERT_EMPTY_CUSTOMERNAME = "Please enter customer name"
        static let ALERT_EMPTY_ADDRESS = "Please enter address"
        static let ALERT_EMPTY_PINCODE = "Please enter pincode"
        static let ALERT_EMPTY_CITY = "Please enter city"
        static let ALERT_EMPTY_PHONE = "Please enter phone number"
        
        static let ALERT_SELECT_DISPATCHDATE = "Please select dispatch date"
        static let ALERT_SELECT_DATE = "Please select date"
        static let ALERT_SELECT_INVOICEDATE = "Please select invoice date"
        static let ALERT_SELECT_DUEDATE = "Please select due date"
        static let ALERT_SELECT_PAYMENTTYPE = "Please select payment type"
        static let ALERT_SELECT_STORE = "Please select store"
        static let ALERT_SELECT_BRANCH = "Please select branch"
        static let ALERT_ADD_CARTITEM = "Please add atleast one item in your cart to proceed"
        static let ALERT_ITEM_NOT_ZERO = "Product quantity can not be zero"
        static let ALERT_ENTER_REMARK = "Please enter comment"
        static let ALERT_ENTER_AMOUNT = "Please enter amount"
        static let ALERT_AMOUNT_ZERO = "Amount can not be zero"
        static let ALERT_AMOUNT_GREATER_TOTAL = "Amount can not be greater than total order amount"
        static let ALERT_ENTER_CANCELREASON = "Please enter reason for cancellation"
        static let ALERT_ENTER_SUBJECT = "Please enter subject"
        static let ALERT_NO_CART = "Sorry!! It seems you have no items in your cart"
        
        static let ALERT_NO_ITEM = "Please select atleast one item"
        static let ALERT_NO_RETURN_ITEM = "Please select atleast one item for return"
        static let ALERT_NO_APPROVE_ITEM = "Please select atleast one item for approve order"
        static let QTY_BELOW_SELECTED_QTY = "Please enter quantity below purchased quantity"
        static let QTY_BELOW_RETURN_QTY = "Please enter quantity below return quantity"
        
        static let FailedChat = "Message failed to send do you want to resend message?"
        static let ALERT_SELECT_CUSTOMER = "Please select customer"
        static let ALERT_SELECT_DRIVER = "Please select driver"
        static let ALERT_SELECT_VEHICLE = "Please select vehicle"
        static let ALERT_NO_VEHICLE = "Sorry!! It seems there is no vehicle for selected driver, Please select different driver"
        static let ALERT_SELECT_DISPATCH = "Please select atleast one dispatch to proceed"
        static let ALERT_SELECT_PRINTER = "Please select printer"
        
        static let ALERT_CASHAMOUNT_NOT_GREATER = "Enter cash amount can not be greater than paid cash amount"
        static let ALERT_CARDAMOUNT_NOT_GREATER = "Enter card amount can not be greater than paid card amount"
        static let ALERT_CHEQUEAMOUNT_NOT_GREATER = "Enter cheque amount can not be greater than paid cheque amount"
        static let ALERT_AMOUNT_EQUAL_RETURN = "Total of cash and card amount must be equal to selected items amount"
        static let ALERT_CART_SAVE_LAYAWAY = "Your order has been saved as layaway"
    }
    
    struct Colors {
        static let kAppThemeTextColor = UIColor.init(named: "AppTextThemeColor")!
        static let kAppMainThemeColor = UIColor.init(named: "AppMainThemeColor")!
        static let kAppGrayThemeColor = UIColor.init(named: "AppGrayColor")!
        static let kAppLightGrayColor = UIColor.init(named: "AppLightGrayColor")!
        static let kAppRedColor = UIColor.init(named: "AppThemeRedColor")!
        static let kAppLightRedColor = UIColor.init(named: "AppThemeLightRedColor")!
        static let kAppDarkThemeColor = UIColor.init(named: "AppMainDarkThemeColor")!
        
    }
    
    struct GlobalFontConstants {
        static func kRegularFont(size:CGFloat)->UIFont{
            return UIFont.init(name: "Avenir-Roman", size: size) ?? UIFont.systemFont(ofSize: size)
        }
        
        static func kMediumFont(size:CGFloat)->UIFont{
            return UIFont.init(name: "Avenir-Medium", size: size) ?? UIFont.systemFont(ofSize: size)
        }
        
        static func kBoldFont(size:CGFloat)->UIFont{
            return UIFont.init(name: "Avenir-Heavy", size: size) ?? UIFont.boldSystemFont(ofSize: size)
        }
        
        static func kBookFont(size:CGFloat)->UIFont{
            return UIFont.init(name: "Avenir-Book", size: size) ?? UIFont.systemFont(ofSize: size)
        }
        
        static func kLightFont(size:CGFloat)->UIFont{
            return UIFont.init(name: "Avenir-Light", size: size) ?? UIFont.systemFont(ofSize: size)
        }
    }
    
    struct notifications {
        static let kBranchChanged = Notification.Name(rawValue: "branchChanged")
        static let kUserCartChanged = Notification.Name(rawValue: "userCartChanged")
        static let kEmployeeDataFetch = Notification.Name(rawValue: "employeeDataFetch")
    }
    
    struct userDefaultKey {
        static let kDeviceToken = "deviceToken"
        static let kUserData = "userData"
        static let kEmployeeData = "employeeData"
        static let kSubCustomerData = "subCustomerData"
        static let kSelectedBranch = "selectedBranch"
        static let kPrinterIPAddress = "printerIPAddress"
    }
    
    struct ScreenSize
    {
        static let SCREEN_WIDTH = UIScreen.main.bounds.size.width
        static let SCREEN_HEIGHT = UIScreen.main.bounds.size.height
        static let SAFEAREAHEIGHT = UIScreen.main.bounds.size.height-topPadding-bottomPadding
        static let SCREEN_MAX_LENGTH = max(ScreenSize.SCREEN_WIDTH, ScreenSize.SCREEN_HEIGHT)
        static let SCREEN_MIN_LENGTH = min(ScreenSize.SCREEN_WIDTH, ScreenSize.SCREEN_HEIGHT)
        static let topPadding = UIApplication.shared.keyWindow?.safeAreaInsets.top ?? 0
        static let bottomPadding = UIApplication.shared.keyWindow?.safeAreaInsets.bottom ?? 0
    }
    
    struct DeviceType
    {
        static let IS_IPHONE_4_OR_LESS =  UIDevice.current.userInterfaceIdiom == .phone && ScreenSize.SCREEN_MAX_LENGTH < 568.0
        static let IS_IPHONE_5_OR_LESS =  UIDevice.current.userInterfaceIdiom == .phone && ScreenSize.SCREEN_MAX_LENGTH <= 568.0
        static let IS_IPHONE_5 = UIDevice.current.userInterfaceIdiom == .phone && ScreenSize.SCREEN_MAX_LENGTH == 568.0
        static let IS_IPHONE_6 = UIDevice.current.userInterfaceIdiom == .phone && ScreenSize.SCREEN_MAX_LENGTH == 667.0
        static let IS_IPHONE_6P = UIDevice.current.userInterfaceIdiom == .phone && ScreenSize.SCREEN_MAX_LENGTH == 736.0
        static let IS_IPHONE_X_OR_MORE = UIDevice.current.userInterfaceIdiom == .phone && ScreenSize.SCREEN_MAX_LENGTH >= 812
        static let IS_IPAD = UIDevice.current.userInterfaceIdiom == .pad
    }
}



