//
//  AccountModel.swift
//  globalfoods
//
//  Created by Apple on 06/01/21.
//

import Foundation

class AccountModel:Codable{
    
    var accountNo:String?
    var cellphone:String?
    var balance:Double?
    var name:String?
    var transcations:[transactionModel]?
    
    enum CodingKeys: String, CodingKey {
        case name, cellphone, balance, transcations
        case accountNo = "account_no"
    }
    
    required init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        balance = values.getDoubleValue(key: CodingKeys.balance)
        cellphone = values.getStringValue(key: CodingKeys.cellphone)
        accountNo = values.getStringValue(key: CodingKeys.accountNo)
        name = values.getStringValue(key: CodingKeys.name)
        transcations = try? values.decode([transactionModel].self, forKey: .transcations)
    }
}

class transactionModel:Codable{
    
    var id:Int?
    var date:String?
    var refenrenceId:String?
    var credit:Double?
    var debit:Double?
    var type:String?
    
    enum CodingKeys: String, CodingKey {
        case id, credit, debit, type
        case date = "entry_date"
        case refenrenceId = "reference_id"
    }
    
    required init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        id = values.getIntValue(key: CodingKeys.id)
        date = values.getStringValue(key: CodingKeys.date)
        refenrenceId = values.getStringValue(key: CodingKeys.refenrenceId)
        type = values.getStringValue(key: CodingKeys.type)
        credit = values.getDoubleValue(key: CodingKeys.credit)
        debit = values.getDoubleValue(key: CodingKeys.debit)
    }
}
