//
//  DashboardModel.swift
//  globalfoods
//
//  Created by Apple on 13/01/21.
//

import Foundation

class DashboardModel:Codable{
    
    var banner:[BannerModel]?
    var newProducts:[ProductsModel]?
    var topProduct:[ProductsModel]?
    var orders:[OrderHistoryModel]?
    
    enum CodingKeys: String, CodingKey {
        case banner, newProducts, topProduct, orders
    }
    
    required init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        banner = try? values.decode([BannerModel].self, forKey: .banner)
        newProducts = try? values.decode([ProductsModel].self, forKey: .newProducts)
        topProduct = try? values.decode([ProductsModel].self, forKey: .topProduct)
        orders = try? values.decode([OrderHistoryModel].self, forKey: .orders)
    }
    
}

class BannerModel:Codable{
    
    var imagePath:String?
    
    enum CodingKeys: String, CodingKey {
        case imagePath = "image_path"
    }
    
    required init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        imagePath = values.getStringValue(key: CodingKeys.imagePath)
    }
}
