//
//  DispatchModel.swift
//  globalfoods
//
//  Created by Apple on 01/01/21.
//

import Foundation

class DispatchModel:Codable{
    
    var id:Int?
    var dispatchDate:String?
    var status:Int?
    var statusText:String?
    var paymentDueDate:String?
    var dispatchNo:String?
    var orderNo:String?
    var dispatchTotal:Double?
    var billingName:String?
    var billingPincode:String?
    var billingPhone:String?
    var billingCity:String?
    var billingAddress:String?
    var path:String?
    var remark:String?
    var items: String?
    
    enum CodingKeys: String, CodingKey {
        case id, status, path, remark, items
        case orderNo = "order_no"
        case dispatchDate = "dispatch_date"
        case paymentDueDate = "payment_due_date"
        case statusText = "status_slug"
        case dispatchNo = "dispatch_no"
        case dispatchTotal = "dispatch_grandtotal"
        case billingName = "dispatch_billing_name"
        case billingPincode = "dispatch_billing_pincode"
        case billingPhone = "dispatch_billing_phone"
        case billingAddress = "dispatch_billing_address"
        case billingCity = "dispatch_billing_city"
    }
    
    required init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        dispatchTotal = values.getDoubleValue(key: CodingKeys.dispatchTotal)
        id = values.getIntValue(key: CodingKeys.id)
        status = values.getIntValue(key: CodingKeys.status)
        dispatchDate = values.getStringValue(key: CodingKeys.dispatchDate)
        statusText = values.getStringValue(key: CodingKeys.statusText)
        dispatchNo = values.getStringValue(key: CodingKeys.dispatchNo)
        orderNo = values.getStringValue(key: CodingKeys.orderNo)
        paymentDueDate = values.getStringValue(key: CodingKeys.paymentDueDate)
        billingName = values.getStringValue(key: CodingKeys.billingName)
        billingPincode = values.getStringValue(key: CodingKeys.billingPincode)
        billingPhone = values.getStringValue(key: CodingKeys.billingPhone)
        billingCity = values.getStringValue(key: CodingKeys.billingCity)
        billingAddress = values.getStringValue(key: CodingKeys.billingAddress)
        path = values.getStringValue(key: CodingKeys.path)
        remark = values.getStringValue(key: CodingKeys.remark)
        items = values.getStringValue(key: CodingKeys.items)
    }
}

class DispatchItemsModel:Codable{
    
    var itemName:String?
    var itemPrice:Double?
    var itemTotalPrice:Double?
    var itemQty:Double?
    var itemId:Int?
    
    enum CodingKeys: String, CodingKey {
        case itemName = "dispatch_item_name"
        case itemPrice = "dispatch_item_selling_price"
        case itemTotalPrice = "dispatch_item_sub_total"
        case itemQty = "dispatched_item_qty"
        case itemId = "dispatch_item_id"
    }
    
    required init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        itemName = values.getStringValue(key: CodingKeys.itemName)
        itemPrice = values.getDoubleValue(key: CodingKeys.itemPrice)
        itemTotalPrice = values.getDoubleValue(key: CodingKeys.itemTotalPrice)
        itemQty = values.getDoubleValue(key: CodingKeys.itemQty)
        itemId = values.getIntValue(key: CodingKeys.itemId)
    }
}

class DispatchDetailModel:Codable{
    
    var dispatchNo:String?
    var customerName:String?
    var customerAddress:String?
    var customerCity:String?
    var customerPincode:String?
    var customerPhone:String?
    var statusSlug:String?
    
    var billingName:String?
    var billingAddress:String?
    var billingCity:String?
    var billingPincode:String?
    var billingPhone:String?
    var billingEmail:String?
    
    var vehicleName:String?
    var vehicleNo:String?
    var driverName:String?
    var driverEmail:String?
    var driverPhone:String?
    
    var subTotal:Double?
    var grandTotal:Double?
    var discount:Double?
    var remarks:String?
    var arrProducts:[DispatchItemsModel]?
    
    enum CodingKeys: String, CodingKey {
        case remarks
        case dispatchNo = "dispatch_no"
        case customerName = "dispatch_customer_name"
        case customerAddress = "dispatch_customer_address"
        case customerCity = "dispatch_customer_city"
        case customerPincode = "dispatch_customer_pincode"
        case customerPhone = "dispatch_customer_phone"
        case statusSlug = "status_slug"
        case billingName = "dispatch_billing_name"
        case billingAddress = "dispatch_billing_address"
        case billingCity = "dispatch_billing_city"
        case billingPincode = "dispatch_billing_pincode"
        case billingPhone = "dispatch_billing_phone"
        case billingEmail = "dispatch_billing_email"
        case vehicleName = "vehicle_name"
        case vehicleNo = "dispatch_actual_vehical_number"
        case driverName = "dispatch_actual_driver_name"
        case driverEmail = "driver_email"
        case driverPhone = "dispatch_actual_driver_number"
        case subTotal = "dispatch_subtotal"
        case grandTotal = "dispatch_grandtotal"
        case discount = "dispatch_discount"
        case arrProducts = "product"
    }
    
    required init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        dispatchNo = values.getStringValue(key: CodingKeys.dispatchNo)
        customerName = values.getStringValue(key: CodingKeys.customerName)
        customerAddress = values.getStringValue(key: CodingKeys.customerAddress)
        customerCity = values.getStringValue(key: CodingKeys.customerCity)
        customerPincode = values.getStringValue(key: CodingKeys.customerPincode)
        customerPhone = values.getStringValue(key: CodingKeys.customerPhone)
        statusSlug = values.getStringValue(key: CodingKeys.statusSlug)
        
        billingAddress = values.getStringValue(key: CodingKeys.billingAddress)
        billingCity = values.getStringValue(key: CodingKeys.billingCity)
        billingPhone = values.getStringValue(key: CodingKeys.billingPhone)
        billingEmail = values.getStringValue(key: CodingKeys.billingEmail)
        billingName = values.getStringValue(key: CodingKeys.billingName)
        billingPincode = values.getStringValue(key: CodingKeys.billingPincode)
        
        vehicleName = values.getStringValue(key: CodingKeys.vehicleName)
        driverEmail = values.getStringValue(key: CodingKeys.driverEmail)
        driverName = values.getStringValue(key: CodingKeys.driverName)
        driverPhone = values.getStringValue(key: CodingKeys.driverPhone)
        vehicleNo = values.getStringValue(key: CodingKeys.vehicleNo)
        
        subTotal = values.getDoubleValue(key: CodingKeys.subTotal)
        grandTotal = values.getDoubleValue(key: CodingKeys.grandTotal)
        discount = values.getDoubleValue(key: CodingKeys.discount)
        remarks = values.getStringValue(key: CodingKeys.remarks)
        
        arrProducts = try? values.decode([DispatchItemsModel].self, forKey: .arrProducts)
    }
}
