//
//  OrderHistoryModel.swift
//  globalfoods
//
//  Created by Apple on 31/12/20.
//

import Foundation

class OrderHistoryModel:Codable{
    
    var id:Int?
    var cid:Int?
    var cbid:Int?
    var date:String?
    var status:Int?
    var statusText:String?
    var orderStatusText:String?
    var orderNo:String?
    var orderTotal:Double?
    var subTotal:Double?
    var taxAmount:Double?
    var discount:Double?
    var cashAmount:Double?
    var refundAmount:Double?
    var cardAmount:Double?
    var chequeAmount:Double?
    var salesId:Int?
    var arrItems:[CartItemsModel]?
    var remarks:String?
    var customerName:String?
    var customerAddress:String?
    var customerEmail:String?
    var customerPincode:String?
    var customerPhone:String?
    var customerCity:String?
    var paymentMode:String?
    var chequeNumber:String?
    
    enum CodingKeys: String, CodingKey {
        case id, remarks, cid, cbid
        case refundAmount = "refund_amount"
        case cashAmount = "cash_amount"
        case cardAmount = "card_amount"
        case chequeAmount = "cheque_amount"
        case chequeNumber = "cheque_number"
        case customerAddress = "customer_address"
        case customerPincode = "customer_pincode"
        case customerEmail = "customer_email"
        case customerPhone = "customer_phone"
        case customerCity = "customer_city"
        case taxAmount = "tax_amount"
        case date = "order_date"
        case status = "order_status"
        case statusText = "order_status_slug"
        case orderStatusText = "status_slug"
        case orderNo = "order_no"
        case orderTotal = "order_grand_total"
        case salesId = "sales_id"
        case arrItems = "products"
        case discount = "order_discount_amount"
        case subTotal = "order_total_amount"
        case customerName = "customer_name"
        case paymentMode = "payment_mode"
    }
    
    required init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        discount = values.getDoubleValue(key: CodingKeys.discount)
        subTotal = values.getDoubleValue(key: CodingKeys.subTotal)
        orderTotal = values.getDoubleValue(key: CodingKeys.orderTotal)
        taxAmount = values.getDoubleValue(key: CodingKeys.taxAmount)
        cashAmount = values.getDoubleValue(key: CodingKeys.cashAmount)
        refundAmount = values.getDoubleValue(key: CodingKeys.refundAmount)
        cardAmount = values.getDoubleValue(key: CodingKeys.cardAmount)
        chequeAmount = values.getDoubleValue(key: CodingKeys.chequeAmount)
        id = values.getIntValue(key: CodingKeys.id)
        cbid = values.getIntValue(key: CodingKeys.cbid)
        cid = values.getIntValue(key: CodingKeys.cid)
        status = values.getIntValue(key: CodingKeys.status)
        salesId = values.getIntValue(key: CodingKeys.salesId)
        date = values.getStringValue(key: CodingKeys.date)
        statusText = values.getStringValue(key: CodingKeys.statusText)
        orderStatusText = values.getStringValue(key: CodingKeys.orderStatusText)
        orderNo = values.getStringValue(key: CodingKeys.orderNo)
        remarks = values.getStringValue(key: CodingKeys.remarks)
        customerName = values.getStringValue(key: CodingKeys.customerName)
        customerPhone = values.getStringValue(key: CodingKeys.customerPhone)
        customerEmail = values.getStringValue(key: CodingKeys.customerEmail)
        customerPincode = values.getStringValue(key: CodingKeys.customerPincode)
        customerAddress = values.getStringValue(key: CodingKeys.customerAddress)
        customerCity = values.getStringValue(key: CodingKeys.customerCity)
        paymentMode = values.getStringValue(key: CodingKeys.paymentMode)
        chequeNumber = values.getStringValue(key: CodingKeys.chequeNumber)
        arrItems = try? values.decode([CartItemsModel].self, forKey: .arrItems)
    }
}
