//
//  ProductModel.swift
//  globalfoods
//
//  Created by Apple on 29/12/20.
//

import Foundation

class ProductsModel:Codable{
    
    var itemName:String?
    var itemPrice:Double?
    var stockQty:Double?
    var id:Int?
    var categoryId:Int?
    var categoryName:String?
    var image:String?
    var imagePath:String?
    var selectedQty = 1.0
    var isAddedInCart = false
    var cartId:Int?
    var isSelected = false
    var itemTotalPrice:Double?
    var itemCode:String?
    
    enum CodingKeys: String, CodingKey {
        case itemName = "display_name"
        case itemPrice = "orignal_price"
        case categoryName = "category_name"
        case stockQty = "stock_qty"
        case categoryId = "category_id"
        case imagePath = "image_path"
        case id,image
        case itemCode = "product_code"
    }
    
    required init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        itemName = values.getStringValue(key: CodingKeys.itemName)
        itemPrice = values.getDoubleValue(key: CodingKeys.itemPrice)
        categoryName = values.getStringValue(key: CodingKeys.categoryName)
        image = values.getStringValue(key: CodingKeys.image)
        imagePath = values.getStringValue(key: CodingKeys.imagePath)
        stockQty = values.getDoubleValue(key: CodingKeys.stockQty)
        id = values.getIntValue(key: CodingKeys.id)
        categoryId = values.getIntValue(key: CodingKeys.categoryId)
        itemCode = values.getStringValue(key: CodingKeys.itemCode)
    }
}

class ProductCategoryModel:Codable{
    
    var categoryId:Int?
    var categoryName:String?
    var arrPrducts = [ProductsModel]()
    var arrSearchPrducts = [ProductsModel]()
    var isExpanded = false
    
    enum CodingKeys: String, CodingKey {
        case categoryName = "category_name"
        case categoryId = "id"
    }
    
    required init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        categoryName = values.getStringValue(key: CodingKeys.categoryName)
        categoryId = values.getIntValue(key: CodingKeys.categoryId)
    }
}
