//
//  RepoVisitModel.swift
//  globalfoods
//
//  Created by Apple on 05/01/21.
//

import Foundation

class RepoVisitModel:Codable{
    
    var id:Int?
    var createdDate:String?
    var customerName:String?
    var customerBranchName:String?
    var salesRepoName:String?
    var remark:String?
    
    enum CodingKeys: String, CodingKey {
        case id, remark
        case customerName = "customer_name"
        case createdDate = "created_date"
        case salesRepoName = "sales_repo_name"
        case customerBranchName = "customer_branch_name"
    }
    
    required init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        id = values.getIntValue(key: CodingKeys.id)
        customerName = values.getStringValue(key: CodingKeys.customerName)
        remark = values.getStringValue(key: CodingKeys.remark)
        createdDate = values.getStringValue(key: CodingKeys.createdDate)
        salesRepoName = values.getStringValue(key: CodingKeys.salesRepoName)
        customerBranchName = values.getStringValue(key: CodingKeys.customerBranchName)
    }
}

class FullReportModel:Codable{
    
    var totalItemCount:Double?
    var cardOrderValue:Double?
    var codOrderValue:Double?
    var chequeOrderValue:Double?
    var orderValue:Double?
    var totalRefundAmount:Double?
    var totalCardOrderCount:Int?
    var totalCodOrderCount:Int?
    var totalChequeOrderCount:Int?
    var totalOrderCount:Int?
    
    enum CodingKeys: String, CodingKey {
        case cardOrderValue = "card_order_value"
        case codOrderValue = "cod_order_value"
        case chequeOrderValue = "cheque_order_value"
        case totalChequeOrderCount = "total_cheque_order_count"
        case totalCardOrderCount = "total_card_order_count"
        case totalCodOrderCount = "total_cod_order_count"
        case totalItemCount = "total_item_count"
        case orderValue = "order_value"
        case totalOrderCount = "total_order_count"
        case totalRefundAmount = "total_refund_amount"
    }
    
    required init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        totalCardOrderCount = values.getIntValue(key: CodingKeys.totalCardOrderCount)
        totalCodOrderCount = values.getIntValue(key: CodingKeys.totalCodOrderCount)
        totalChequeOrderCount = values.getIntValue(key: CodingKeys.totalChequeOrderCount)
        totalOrderCount = values.getIntValue(key: CodingKeys.totalOrderCount)
        orderValue = values.getDoubleValue(key: CodingKeys.orderValue)
        cardOrderValue = values.getDoubleValue(key: CodingKeys.cardOrderValue)
        codOrderValue = values.getDoubleValue(key: CodingKeys.codOrderValue)
        chequeOrderValue = values.getDoubleValue(key: CodingKeys.chequeOrderValue)
        totalItemCount = values.getDoubleValue(key: CodingKeys.totalItemCount)
        totalRefundAmount = values.getDoubleValue(key: CodingKeys.totalRefundAmount)
    }
    
    init() {
        
    }
}
