//
//  ReturnOrderModel.swift
//  globalfoods
//
//  Created by Apple on 08/01/21.
//

import Foundation

class ReturnOrderModel:Codable{
    
    var id:Int?
    var eid:Int?
    var vehicleId:Int?
    var date:String?
    var statusSlug:String?
    var status:Int?
    var returnNo:String?
    var grandTotal:Double?
    var path:String?
    var arrItems:[ReturnItemModel]?
    
    enum CodingKeys: String, CodingKey {
        case id, path, eid, status 
        case vehicleId = "vehical_id"
        case date = "created_date"
        case statusSlug = "status_slug"
        case returnNo = "return_no"
        case grandTotal = "total_amount"
        case arrItems = "items"
    }
    
    required init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        grandTotal = values.getDoubleValue(key: CodingKeys.grandTotal)
        id = values.getIntValue(key: CodingKeys.id)
        vehicleId = values.getIntValue(key: CodingKeys.vehicleId)
        eid = values.getIntValue(key: CodingKeys.eid)
        status = values.getIntValue(key: CodingKeys.status)
        date = values.getStringValue(key: CodingKeys.date)
        statusSlug = values.getStringValue(key: CodingKeys.statusSlug)
        returnNo = values.getStringValue(key: CodingKeys.returnNo)
        path = values.getStringValue(key: CodingKeys.path)
        arrItems = try? values.decode([ReturnItemModel].self, forKey: .arrItems)
    }
}

class ReturnItemModel:Codable{
    
    var returnQty:Double?
    var itemName:String?
    var returnPrice:Double?
    var returnSubTotal:Double?
    var subtotal:Double?
    var qty:Double?
    var approveQty:Double?
    var id:Int?
    
    enum CodingKeys: String, CodingKey {
        case qty, subtotal, id
        case returnQty = "return_qty"
        case returnPrice = "return_price"
        case returnSubTotal = "return_subtotal"
        case itemName = "item_name"
    }
    
    required init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        returnPrice = values.getDoubleValue(key: CodingKeys.returnPrice)
        returnSubTotal = values.getDoubleValue(key: CodingKeys.returnSubTotal)
        returnQty = values.getDoubleValue(key: CodingKeys.returnQty)
        subtotal = values.getDoubleValue(key: CodingKeys.subtotal)
        qty = values.getDoubleValue(key: CodingKeys.qty)
        id = values.getIntValue(key: CodingKeys.id)
        itemName = values.getStringValue(key: CodingKeys.itemName)
    }
}
