//
//  UserCartModel.swift
//  globalfoods
//
//  Created by Apple on 29/12/20.
//

import Foundation

class UserCartModel:Codable{
    
    var cartitems:[CartItemsModel]?
    var finalTotal:Double?
    var remark:String?
    var cartId:Int?
    var employeeId:Int?
    var customerName:String?
    var cbid:Int?
    var cuid:Int?
    var orderLayAwayId:Int?
    
    enum CodingKeys: String, CodingKey {
        case cartitems, cbid, cuid, remark
        case employeeId = "employee_id"
        case cartId = "cart_id"
        case customerName = "customer_name"
        case finalTotal = "finaltotal"
        case orderLayAwayId = "id"
    }
    
    required init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        cartitems = try? values.decode([CartItemsModel].self, forKey: .cartitems)
        finalTotal = values.getDoubleValue(key: CodingKeys.finalTotal)
        cartId = values.getIntValue(key: CodingKeys.cartId)
        employeeId = values.getIntValue(key: CodingKeys.employeeId)
        cbid = values.getIntValue(key: CodingKeys.cbid)
        cuid = values.getIntValue(key: CodingKeys.cuid)
        orderLayAwayId = values.getIntValue(key: CodingKeys.orderLayAwayId)
        remark = values.getStringValue(key: CodingKeys.remark)
        customerName = values.getStringValue(key: CodingKeys.customerName)
    }
    
    init() {
        
    }
}

class CartItemsModel:Codable{
    
    var itemName:String?
    var categoryName:String?
    var itemPrice:Double?
    var itemTotalPrice:Double?
    var itemQty:Double?
    var itemId:Int?
    var image:String?
    var stockQty:Double?
    var cartId:Int?
    var id:Int?
    var cbid:Int?
    
    var isSelected = false
    var returnQty:Double?
    var approveQty:Double?
    var approvePrice:Double?
    var taxAmount:Double?
    
    enum CodingKeys: String, CodingKey {
        case image, id, cbid
        case cartId = "cart_id"
        case itemName = "order_item_name"
        case itemPrice = "order_item_selling_price"
        case itemTotalPrice = "order_item_sub_total"
        case itemQty = "order_item_qty"
        case itemId = "order_item_id"
        case stockQty = "stock_qty"
        case categoryName = "category_name"
        case taxAmount = "tax_amount"
    }
    
    required init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        itemName = values.getStringValue(key: CodingKeys.itemName)
        image = values.getStringValue(key: CodingKeys.image)
        itemPrice = values.getDoubleValue(key: CodingKeys.itemPrice)
        itemTotalPrice = values.getDoubleValue(key: CodingKeys.itemTotalPrice)
        itemQty = values.getDoubleValue(key: CodingKeys.itemQty)
        stockQty = values.getDoubleValue(key: CodingKeys.stockQty)
        taxAmount = values.getDoubleValue(key: CodingKeys.taxAmount)
        itemId = values.getIntValue(key: CodingKeys.itemId)
        cartId = values.getIntValue(key: CodingKeys.cartId)
        id = values.getIntValue(key: CodingKeys.id)
        cbid = values.getIntValue(key: CodingKeys.cbid)
        categoryName = values.getStringValue(key: CodingKeys.categoryName)
    }
    
    init() {
        
    }
}
