//
//  UserModel.swift
//  globalfoods
//
//  Created by Apple on 28/12/20.
//

import Foundation

class UserModel:Codable{
    
    var email: String?
    var id: Int?
    var name: String?
    var arrBranchs:[branchModel]?
    var showPrice: Int?
    var applicant: String?
    var city: String?
    var pincode: String?
    var address: String?
    var telephone: String?
    var cellphone: String?
    var ownerName: String?
    var ownerDesignation: String?
    var ownerPincode: String?
    var ownerEmail: String?
    var ownerAddress: String?
    var ownerTelephone: String?
    var ownerCellphone: String?
    var tradeName: String?
    var tradeAddress: String?
    var tradePincode: String?
    var creditLimit: String?
    var creditLimitDays: String?
    var discount: String?
    var transportBy: String?
    var allowCancel: Int?
    
    enum CodingKeys: String, CodingKey {
        case email, id, name, showPrice, applicant, city, pincode, address, telephone, cellphone, discount, allowCancel
        case arrBranchs = "customer_branch"
        case ownerName = "owner_name"
        case ownerDesignation = "owner_designation"
        case ownerPincode = "owner_pincode"
        case ownerEmail = "owner_email"
        case ownerAddress = "owner_address"
        case ownerTelephone = "owner_telephone"
        case ownerCellphone = "owner_cellphone"
        case tradeName = "trade_name"
        case tradeAddress = "trade_address"
        case tradePincode = "trade_pincode"
        case creditLimit = "credit_limit"
        case creditLimitDays = "credit_limit_days"
        case transportBy = "transport_by"
    }
    
    required init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        name = values.getStringValue(key: CodingKeys.name)
        email = values.getStringValue(key: CodingKeys.email)
        id = values.getIntValue(key: CodingKeys.id)
        allowCancel = values.getIntValue(key: CodingKeys.allowCancel)
        showPrice = values.getIntValue(key: CodingKeys.showPrice)
        arrBranchs = try? values.decode([branchModel].self, forKey: .arrBranchs)
        transportBy = values.getStringValue(key: CodingKeys.transportBy)
        creditLimitDays = values.getStringValue(key: CodingKeys.creditLimitDays)
        creditLimit = values.getStringValue(key: CodingKeys.creditLimit)
        tradePincode = values.getStringValue(key: CodingKeys.tradePincode)
        tradeAddress = values.getStringValue(key: CodingKeys.tradeAddress)
        tradeName = values.getStringValue(key: CodingKeys.tradeName)
        ownerCellphone = values.getStringValue(key: CodingKeys.ownerCellphone)
        ownerTelephone = values.getStringValue(key: CodingKeys.ownerTelephone)
        ownerAddress = values.getStringValue(key: CodingKeys.ownerAddress)
        ownerEmail = values.getStringValue(key: CodingKeys.ownerEmail)
        ownerPincode = values.getStringValue(key: CodingKeys.ownerPincode)
        ownerDesignation = values.getStringValue(key: CodingKeys.ownerDesignation)
        ownerName = values.getStringValue(key: CodingKeys.ownerName)
        discount = values.getStringValue(key: CodingKeys.discount)
        cellphone = values.getStringValue(key: CodingKeys.cellphone)
        telephone = values.getStringValue(key: CodingKeys.telephone)
        address = values.getStringValue(key: CodingKeys.address)
        pincode = values.getStringValue(key: CodingKeys.pincode)
        city = values.getStringValue(key: CodingKeys.city)
        applicant = values.getStringValue(key: CodingKeys.applicant)
    }
}

class branchModel:Codable{
    
    var email: String?
    var id: Int?
    var name: String?
    var closingBalance:Double?
    var phone: String?
    var address: String?
    var city: String?
    var country: String?
    var aid: Int?
    
    enum CodingKeys: String, CodingKey {
        case email, id, phone, address, city, country, aid
        case name = "branch_name"
        case closingBalance = "closing_amount"
    }
    
    required init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        name = values.getStringValue(key: CodingKeys.name)
        email = values.getStringValue(key: CodingKeys.email)
        phone = values.getStringValue(key: CodingKeys.phone)
        address = values.getStringValue(key: CodingKeys.address)
        country = values.getStringValue(key: CodingKeys.country)
        city = values.getStringValue(key: CodingKeys.city)
        id = values.getIntValue(key: CodingKeys.id)
        aid = values.getIntValue(key: CodingKeys.aid)
        closingBalance = values.getDoubleValue(key: CodingKeys.closingBalance)
    }
}

class EmployeeAccountModel:Codable{
    
    var id: Int?
    
    enum CodingKeys: String, CodingKey {
        case id
    }
    
    required init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        id = values.getIntValue(key: CodingKeys.id)
    }
}

class EmployeeModel:Codable{
    
    var email: String?
    var id: Int?
    var name: String?
    var closingBalance:Double?
    var phone: String?
    var empCode: String?
    var rights:RightsModel?
    var adminType:Int?
    var account:EmployeeAccountModel?
    
    enum CodingKeys: String, CodingKey {
        case email, id, phone, rights
        case account = "employee_account"
        case name = "first_name"
        case empCode = "emp_code"
        case adminType = "admin_type"
        case closingBalance = "closing_balance"
    }
    
    required init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        name = values.getStringValue(key: CodingKeys.name)
        email = values.getStringValue(key: CodingKeys.email)
        phone = values.getStringValue(key: CodingKeys.phone)
        empCode = values.getStringValue(key: CodingKeys.empCode)
        id = values.getIntValue(key: CodingKeys.id)
        adminType = values.getIntValue(key: CodingKeys.adminType)
        closingBalance = values.getDoubleValue(key: CodingKeys.closingBalance)
        rights = try? values.decode(RightsModel.self, forKey: .rights)
        account = try? values.decode(EmployeeAccountModel.self, forKey: .account)
    }
}

class RightsModel:Codable{
    
    var account: RightsAccessModel?
    var creditNote: RightsAccessModel?
    var dispatch: RightsAccessModel?
    var invoice: RightsAccessModel?
    var order: RightsAccessModel?
    var payment: RightsAccessModel?
    var picklist: RightsAccessModel?
    var returnOrder: RightsAccessModel?
    var visit: RightsAccessModel?
    var support: RightsAccessModel?
    var delivery: RightsAccessModel?
    var salesOrder: RightsAccessModel?
    var cashDrawer: RightsAccessModel?
    
    enum CodingKeys: String, CodingKey {
        case account, dispatch, invoice, order, payment, picklist, visit, delivery
        case creditNote = "credit_note"
        case returnOrder = "return"
        case salesOrder = "sale_order"
        case cashDrawer = "cash_drawer"
    }
    
    required init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        account = try? values.decode(RightsAccessModel.self, forKey: .account)
        creditNote = try? values.decode(RightsAccessModel.self, forKey: .creditNote)
        dispatch = try? values.decode(RightsAccessModel.self, forKey: .dispatch)
        invoice = try? values.decode(RightsAccessModel.self, forKey: .invoice)
        order = try? values.decode(RightsAccessModel.self, forKey: .order)
        payment = try? values.decode(RightsAccessModel.self, forKey: .payment)
        picklist = try? values.decode(RightsAccessModel.self, forKey: .picklist)
        returnOrder = try? values.decode(RightsAccessModel.self, forKey: .returnOrder)
        visit = try? values.decode(RightsAccessModel.self, forKey: .visit)
        delivery = try? values.decode(RightsAccessModel.self, forKey: .delivery)
        salesOrder = try? values.decode(RightsAccessModel.self, forKey: .salesOrder)
        cashDrawer = try? values.decode(RightsAccessModel.self, forKey: .cashDrawer)
    }
}

class RightsAccessModel:Codable{
    
    var delete: Int?
    var insert: Int?
    var update: Int?
    var view: Int?
    
    enum CodingKeys: String, CodingKey {
        case delete, insert, update, view
    }
    
    required init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        delete = values.getIntValue(key: CodingKeys.delete)
        insert = values.getIntValue(key: CodingKeys.insert)
        update = values.getIntValue(key: CodingKeys.update)
        view = values.getIntValue(key: CodingKeys.view)
    }
}

class StoreModel:Codable{
    
    var id: Int?
    var name: String?
    
    enum CodingKeys: String, CodingKey {
        case id
        case name = "store_name"
    }
    
    required init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        name = values.getStringValue(key: CodingKeys.name)
        id = values.getIntValue(key: CodingKeys.id)
    }
}

class vehicleModel:Codable{
    
    var id: Int?
    var driverId: Int?
    var name: String?
    var vehicleNo: String?
    
    enum CodingKeys: String, CodingKey {
        case id
        case driverId = "driver_id"
        case name = "vehical_name"
        case vehicleNo = "vehical_no"
    }
    
    required init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        name = values.getStringValue(key: CodingKeys.name)
        vehicleNo = values.getStringValue(key: CodingKeys.vehicleNo)
        id = values.getIntValue(key: CodingKeys.id)
        driverId = values.getIntValue(key: CodingKeys.driverId)
    }
}

class SubCustomerModel:Codable{
    
    var id: Int?
    var cid: Int?
    var name: String?
    var username: String?
    var cbid: Int?
    var branchName: String?
    
    enum CodingKeys: String, CodingKey {
        case id, cid, name, username, cbid
        case branchName = "branch_name"
    }
    
    required init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        name = values.getStringValue(key: CodingKeys.name)
        branchName = values.getStringValue(key: CodingKeys.branchName)
        username = values.getStringValue(key: CodingKeys.username)
        id = values.getIntValue(key: CodingKeys.id)
        cbid = values.getIntValue(key: CodingKeys.cbid)
        cid = values.getIntValue(key: CodingKeys.cid)
    }
}
