//
//  SelectBranchVC.swift
//  globalfoods
//
//  Created by Apple on 28/12/20.
//

import UIKit
import SideMenuSwift


class BranchViewCell: UITableViewCell {
    
    @IBOutlet weak var lblBranchName:UILabel!
    @IBOutlet weak var imgSelect:UIImageViewX!
    
    override class func awakeFromNib() {
        
    }
}

class SelectBranchVC: UIViewController {
    
    @IBOutlet weak var btnBack:UIButton!
    @IBOutlet weak var lblViewTitle:UILabel!
    
    var arrBranch = [branchModel]()
    var selectedBranch:branchModel?
    var arrPrinter = ["Zonerich","Mobile"]
    var isBackEnabled = false
    var popRecognizer: InteractivePopRecognizer?
    var isPrinterView = false
    var selectedPrinter = ""
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        // Do any additional setup after loading the view.
        arrBranch = AppConstants.userData?.arrBranchs ?? [branchModel]()
        selectedBranch = AppConstants.selectedBranch
        if isBackEnabled{
            btnBack.isHidden = false
            setInteractiveRecognizer()
        }
        if isPrinterView{
            lblViewTitle.text = "Select Printer"
        }
    }
    
    //MARK: create viewcontroller instance
    static func instance()->SelectBranchVC?{
        return UIStoryboard.init(name: "Main", bundle: nil).instantiateViewController(withIdentifier: "SelectBranchVC") as? SelectBranchVC
    }
    
    private func setInteractiveRecognizer() {
        guard let controller = navigationController else { return }
        popRecognizer = InteractivePopRecognizer(controller: controller)
        controller.interactivePopGestureRecognizer?.delegate = popRecognizer
    }
    
    @IBAction func btnBackAction(_ sender:UIButton){
        self.navigationController?.popViewController(animated: true)
    }
    
    @IBAction func btnConfirmAction(_ sender:UIButton){
        self.view.endEditing(true)
        if isPrinterView{
            if selectedPrinter == ""{
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: AppConstants.GlobalAlert.ALERT_SELECT_PRINTER, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
            }else{
                if selectedPrinter == "Mobile"{
                    AppCommonMethods.saveDataIntoUserDefault(value: "", withKey: AppConstants.userDefaultKey.kPrinterIPAddress)
                    if let VC = UIStoryboard.init(name: "SideMenu", bundle: nil).instantiateViewController(withIdentifier: "SideMenuController") as? SideMenuController{
                        AppCommonMethods.setupSideView(VC)
                        AppCommonMethods.appDelegate.window!.rootViewController = VC
                    }
                }else{
                    var settings = AlertSettings()
                    settings.alertTitle = "Printer IP Address"
                    settings.alertPlaceholder = "printer ip"
                    if let VC = CustomeAlertVC.showPopup(parentVC: self, settings: settings){
                        VC.delegate = self
                    }
                }
            }
        }else{
            if selectedBranch != nil{
                if let VC = UIStoryboard.init(name: "SideMenu", bundle: nil).instantiateViewController(withIdentifier: "SideMenuController") as? SideMenuController{
                    if self.isBackEnabled{
                        if AppConstants.selectedBranch?.id ?? 0 != selectedBranch?.id ?? 0{
                            if let encoded = AppCommonMethods.getjsonDataFromCodable(object: selectedBranch!) {
                                AppCommonMethods.saveDataIntoUserDefault(value: encoded, withKey: AppConstants.userDefaultKey.kSelectedBranch)
                            }
                            AppConstants.isBranchChanged = true
                            NotificationCenter.default.post(name: AppConstants.notifications.kBranchChanged, object: nil)
                        }
                        self.navigationController?.popViewController(animated: true)
                    }else{
                        if let encoded = AppCommonMethods.getjsonDataFromCodable(object: selectedBranch!) {
                            AppCommonMethods.saveDataIntoUserDefault(value: encoded, withKey: AppConstants.userDefaultKey.kSelectedBranch)
                        }
                        AppCommonMethods.setupSideView(VC)
                        AppConstants.appDelegate.window!.rootViewController = VC
                    }
                }
            }else{
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: AppConstants.GlobalAlert.ALERT_SELECT_BRANCH, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
            }
        }
    }
}

extension SelectBranchVC:UITableViewDelegate,UITableViewDataSource{
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return isPrinterView ? arrPrinter.count : arrBranch.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "BranchViewCell", for: indexPath) as! BranchViewCell
        if isPrinterView{
            cell.lblBranchName.text = arrPrinter[indexPath.row]
            cell.imgSelect.image = UIImage.init(named: "ic_radio_unselected")
            if selectedPrinter == arrPrinter[indexPath.row]{
                cell.imgSelect.image = UIImage.init(named: "ic_radio_selected")
            }
        }else{
            cell.lblBranchName.text = arrBranch[indexPath.row].name ?? ""
            cell.imgSelect.image = UIImage.init(named: "ic_radio_unselected")
            if selectedBranch?.id ?? 0 == arrBranch[indexPath.row].id ?? 0{
                cell.imgSelect.image = UIImage.init(named: "ic_radio_selected")
            }
        }
        cell.imgSelect.imageColor = AppConstants.Colors.kAppMainThemeColor
        return cell
    }
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        if isPrinterView{
            selectedPrinter = arrPrinter[indexPath.row]
        }else{
            selectedBranch = arrBranch[indexPath.row]
        }
        
        tableView.reloadData()
    }
}

extension SelectBranchVC:alertClickedDelegate{
    func alertButtonClicked(index: Int,value:String) {
        if index == 1{
            AppCommonMethods.saveDataIntoUserDefault(value: value, withKey: AppConstants.userDefaultKey.kPrinterIPAddress)
            if let VC = UIStoryboard.init(name: "SideMenu", bundle: nil).instantiateViewController(withIdentifier: "SideMenuController") as? SideMenuController{
                AppCommonMethods.setupSideView(VC)
                AppCommonMethods.appDelegate.window!.rootViewController = VC
            }
        }
    }
}
