//
//  CreateDispatchesVC.swift
//  globalfoods
//
//  Created by Apple on 19/01/21.
//

import UIKit
import DropDown
import ActionSheetPicker_3_0

class CreateDispatchesVC: UIViewController {

    @IBOutlet weak var txtSelectStore:UITextField!
    @IBOutlet weak var txtSelectDate:UITextField!
    
    @IBOutlet weak var txtCustomerName:UITextField!
    @IBOutlet weak var txtAddress:UITextField!
    @IBOutlet weak var txtPincode:UITextField!
    @IBOutlet weak var txtCity:UITextField!
    @IBOutlet weak var txtPhoneNo:UITextField!
    @IBOutlet weak var txtEmail:UITextField!
    
    @IBOutlet weak var lblOrderNo:UILabel!
    @IBOutlet weak var lblPageCount:UILabel!
    @IBOutlet weak var scrollBillingInfo:UIScrollView!
    @IBOutlet weak var scrollDispatchInfo:UIScrollView!
    @IBOutlet weak var tblOrders:UITableView!
    
    var customHeaderView:HeaderView?
    var popRecognizer: InteractivePopRecognizer?
    var currentPage = 1
    var selectedOrder:OrderHistoryModel!
    var arrStores = [StoreModel]()
    var storeData:StoreModel?
    var arrSearchStores = [StoreModel]()
    let storeDropDown = DropDown()
    var isStoreSearchEnabled = false
    var strStoreDate = ""
    var dictBillingInfo = NSMutableDictionary()
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
        setHeaderView()
        setInteractiveRecognizer()
        setView()
    }
    
    //MARK: Create Viewcontrlloer instance
    static func instance()->CreateDispatchesVC?{
        return UIStoryboard.init(name: "Employees", bundle: nil).instantiateViewController(withIdentifier: "CreateDispatchesVC") as? CreateDispatchesVC
    }
    
    //MARK: General methods
    func setHeaderView(){
        if customHeaderView != nil{
            customHeaderView!.removeFromSuperview()
            customHeaderView = nil
        }
        customHeaderView = HeaderView.init(controller: self, title: "Create Dispatch", isBackEnbaled: true)
    }

    private func setInteractiveRecognizer() {
        guard let controller = navigationController else { return }
        popRecognizer = InteractivePopRecognizer(controller: controller)
        controller.interactivePopGestureRecognizer?.delegate = popRecognizer
    }
    
    func setView(){
        if currentPage == 1{
            callGetStoreAPI()
            scrollDispatchInfo.isHidden = false
            scrollBillingInfo.isHidden = true
            tblOrders.superview?.isHidden = true
            selectedOrder.arrItems?.forEach({ (model) in
                model.returnQty = model.itemQty
            })
        }else if currentPage == 2{
            scrollDispatchInfo.isHidden = true
            scrollBillingInfo.isHidden = false
            tblOrders.superview?.isHidden = true
            txtCustomerName.text = selectedOrder.customerName ?? ""
            txtEmail.text = selectedOrder.customerEmail ?? ""
            txtAddress.text = selectedOrder.customerAddress ?? ""
            txtPincode.text = selectedOrder.customerPincode ?? ""
            txtPhoneNo.text = selectedOrder.customerPhone ?? ""
            txtCity.text = selectedOrder.customerCity ?? ""
        }else{
            scrollDispatchInfo.isHidden = true
            scrollBillingInfo.isHidden = true
            tblOrders.superview?.isHidden = false
        }
        lblPageCount.text = "\(currentPage)/3"
        self.lblOrderNo.text = "Order No: #\(selectedOrder.orderNo ?? "")"
    }
    
    func checkValidation()->Bool{
        if currentPage == 1{
            if storeData == nil{
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: AppConstants.GlobalAlert.ALERT_SELECT_STORE, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
                return false
            }else if strStoreDate == ""{
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: AppConstants.GlobalAlert.ALERT_SELECT_DISPATCHDATE, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
                return false
            }
        }else if currentPage == 2{
            if (txtCustomerName.text?.trimmingCharacters(in: .whitespaces).isEmpty)!
            {
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: AppConstants.GlobalAlert.ALERT_EMPTY_CUSTOMERNAME, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    _ = self.txtCustomerName.becomeFirstResponder()
                }
                return false

            }else if (txtAddress.text?.trimmingCharacters(in: .whitespaces).isEmpty)!
            {
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: AppConstants.GlobalAlert.ALERT_EMPTY_ADDRESS, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    _ = self.txtAddress.becomeFirstResponder()
                }
                return false

            }else if (txtPincode.text?.trimmingCharacters(in: .whitespaces).isEmpty)!
            {
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: AppConstants.GlobalAlert.ALERT_EMPTY_PINCODE, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    _ = self.txtPincode.becomeFirstResponder()
                }
                return false

            }else if (txtCity.text?.trimmingCharacters(in: .whitespaces).isEmpty)!
            {
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: AppConstants.GlobalAlert.ALERT_EMPTY_CITY, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    _ = self.txtCity.becomeFirstResponder()
                }
                return false

            }else if (txtPhoneNo.text?.trimmingCharacters(in: .whitespaces).isEmpty)!
            {
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: AppConstants.GlobalAlert.ALERT_EMPTY_PHONE, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    _ = self.txtPhoneNo.becomeFirstResponder()
                }
                return false

            }else if (txtEmail.text?.trimmingCharacters(in: .whitespaces).isEmpty)!
            {
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: AppConstants.GlobalAlert.ALERT_EMPTY_EMAIL, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    _ = self.txtEmail.becomeFirstResponder()
                }
                return false

            }else if !(AppValidation.shared.isValidRegEx(txtEmail.text!, .email))
            {
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: AppConstants.GlobalAlert.ALERT_INVALID_EMAIL, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    _ = self.txtEmail.becomeFirstResponder()
                }
                return false
            }
        }
        return true
    }
    
    @IBAction func btnBackAction(_ sender:UIButton){
        self.navigationController?.popViewController(animated: true)
    }
    
    @IBAction func btnNextAction(_ sender:UIButton){
        self.view.endEditing(true)
        if currentPage == 3{
            callCreateDispatchAPI()
        }else{
            if checkValidation(){
                if let VC = CreateDispatchesVC.instance(){
                    VC.currentPage = currentPage+1
                    VC.selectedOrder = selectedOrder
                    VC.strStoreDate = strStoreDate
                    VC.storeData = storeData
                    if currentPage == 2{
                        dictBillingInfo["billing_company_name"] = txtCustomerName.text ?? ""
                        dictBillingInfo["billing_email"] = txtEmail.text ?? ""
                        dictBillingInfo["billing_pincode"] = txtPincode.text ?? ""
                        dictBillingInfo["billing_address"] = txtAddress.text ?? ""
                        dictBillingInfo["billing_phone"] = txtPhoneNo.text ?? ""
                        dictBillingInfo["billing_city"] = txtCity.text ?? ""
                        VC.dictBillingInfo = dictBillingInfo
                    }
                    self.navigationController?.pushViewController(VC, animated: true)
                }
            }
        }
    }
    
    @IBAction func txtSelectStoreAction(_ sender:UITextField){
        if sender.text ?? "" == ""{
            isStoreSearchEnabled = false
        }else{
            isStoreSearchEnabled = true
            arrSearchStores = arrStores.filter({ (model) -> Bool in
                return (model.name ?? "").lowercased().contains((sender.text ?? "").lowercased())
            })
            
        }
        var arrName = [String]()
        for model in (isStoreSearchEnabled ? arrSearchStores : arrStores){
            arrName.append(model.name ?? "")
        }
        storeDropDown.dataSource = arrName
        if storeDropDown.isDropdownHidden{
            storeDropDown.show()
        }else{
            storeDropDown.reloadAllComponents()
        }
    }
    
    func callGetStoreAPI(){
        var param = [String:String]()
        param["key"] = AppConstants.commonConstant.kAPIKey
        param["s"] = "67"
        
        AppCommonMethods.startProgressBar()
        WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: AppConstants.APIURLs.kServiceOrderURL) { (message, response) in
            DispatchQueue.main.async {
                var aMessage = message
                self.arrStores.removeAll()
                AppCommonMethods.stopProgressBar()
                if response != nil{
                    if AppConstants.isInDevlopmentMode{
                        print("store Data:",response!)
                    }
                    if let result = response!["result"] as? [NSDictionary], response!.getIntValue("ack") ?? 0 == 1{
                        if let data = AppCommonMethods.convertToJson(object: result){
                            let jsonDecoder = JSONDecoder()
                            if let aData = try? jsonDecoder.decode([StoreModel].self, from: data){
                                self.arrStores = aData
                                return
                            }
                        }
                    }else{
                        aMessage = response!.getStringValue("ack_msg") ?? ""
                    }
                }
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: aMessage, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
            }
            
        }
    }
    
    func callCreateDispatchAPI(){
        var param = [String:String]()
        param["key"] = AppConstants.commonConstant.kAPIKey
        param["s"] = "71"
        param["order_id"] = "\(selectedOrder.id ?? 0)"
        param["store_id"] = "\(storeData?.id ?? 0)"
        param["dispatch_date"] = strStoreDate
        var arrItems = [NSMutableDictionary]()
        for model in selectedOrder.arrItems!{
            let dict = NSMutableDictionary()
            if model.returnQty ?? 0 == 0{
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: "Please enter quantity for \(model.itemName ?? "")", withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
                return
            }
            dict["qty"] = "\(model.returnQty ?? 0)"
            dict["id"] = "\(model.id ?? 0)"
            arrItems.append(dict)
            param["order_item"] = AppCommonMethods.convertJsontoString(json: arrItems)
        }
        param["billing_details"] = AppCommonMethods.convertJsontoString(json: dictBillingInfo)
        if AppConstants.isInDevlopmentMode{
            print("Create Dispatch Param:",param)
        }
        AppCommonMethods.startProgressBar()
        WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: AppConstants.APIURLs.kServiceOrderURL) { (message, response) in
            DispatchQueue.main.async {
                AppCommonMethods.stopProgressBar()
                var setting = BottomAlertSettings()
                setting.strMessage = message
                if response != nil{
                    if AppConstants.isInDevlopmentMode{
                        print("Create Dispatch Data:",response!)
                    }
                    if response!.getIntValue("ack") ?? 0 == 1{
                        self.navigationController?.popToRootViewController(animated: true)
                    }
                    setting.strMessage = response!.getStringValue("ack_msg") ?? ""
                }
                AppValidation.shared.showBottomAlertView(settings: setting)
            }
        }
    }
}

extension CreateDispatchesVC:UITableViewDataSource,UITableViewDelegate{
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return selectedOrder.arrItems?.count ?? 0
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "OrderDetailViewCell", for: indexPath) as! OrderDetailViewCell
        let model = selectedOrder.arrItems![indexPath.row]
        cell.lblName.text = model.itemName ?? ""
        if model.returnQty != nil{
            cell.txtQty.text = "\(model.returnQty ?? 0)"
        }else{
            if model.itemQty ?? 0 > model.stockQty ?? 0{
                cell.txtQty.text = ""
            }else{
                cell.txtQty.text = "\(model.itemQty ?? 0)"
            }
        }
        cell.txtQty.tag = indexPath.row
        cell.lblQty.setLabelAttributedText(title: "Purchased quantity", value: String.init(format: "%.1f", model.itemQty ?? 0), fontSize: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
        cell.lblStockQty.setLabelAttributedText(title: "Stock quantity", value: String.init(format: "%.1f", model.stockQty ?? 0), fontSize: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
        return cell
    }
}

extension CreateDispatchesVC:UITextFieldDelegate{
    func textFieldDidBeginEditing(_ textField: UITextField) {
        if textField == txtSelectStore{
            isStoreSearchEnabled = false
            txtSelectStore.text = ""
            storeDropDown.dismissMode = .manual
            storeDropDown.anchorView = txtSelectStore
            storeDropDown.bottomOffset = CGPoint(x: 0, y: txtSelectStore.bounds.height)
            storeDropDown.topOffset = CGPoint(x: 0, y: -txtSelectStore.bounds.height)
            var arrName = [String]()
            for model in (isStoreSearchEnabled ? arrSearchStores : arrStores){
                arrName.append(model.name ?? "")
            }
            storeDropDown.dataSource = arrName
            // Action triggered on selection
            storeDropDown.selectionAction = { [weak self] (index, item) in
                self?.storeData = ((self?.isStoreSearchEnabled ?? false) ? self?.arrSearchStores : self?.arrStores)?[index]
                self?.txtSelectStore.text = item
                self?.view.endEditing(true)
            }
            storeDropDown.show()
        }
    }
    
    func textFieldShouldBeginEditing(_ textField: UITextField) -> Bool {
        if textField == txtSelectDate{
            txtSelectStore.resignFirstResponder()
            let date = strStoreDate.getDateFromString(format: "dd-MM-yyyy", locale: nil) ?? Date()
            let datePicker = ActionSheetDatePicker(title: "Select dispatch date", datePickerMode: UIDatePicker.Mode.date, selectedDate: date, doneBlock: {
                picker, value, index in
                self.strStoreDate = (value as! Date).getDateInString(format: "dd-MM-yyyy")
                self.txtSelectDate.text = (value as! Date).getDateInString(format: "dd/MM/yyyy")
            }, cancel: { ActionStringCancelBlock in return }, origin: textField)
            datePicker?.minimumDate = Date()
            datePicker?.show()
            return false
        }
        return true
    }
    
    func textFieldShouldReturn(_ textField: UITextField) -> Bool {
        return textField.resignFirstResponder()
    }
    
    func textField(_ textField: UITextField, shouldChangeCharactersIn range: NSRange, replacementString string: String) -> Bool {
        if textField == txtSelectStore || textField == txtSelectDate{
            return true
        }
        let allowedCharacters = CharacterSet(charactersIn:"0123456789.")//Here change this characters based on your requirement
        let characterSet = CharacterSet(charactersIn: string)
        return allowedCharacters.isSuperset(of: characterSet)
    }
    
    func textFieldDidEndEditing(_ textField: UITextField) {
        if textField == txtSelectStore{
            txtSelectStore.text = storeData?.name ?? ""
        }else if textField == txtSelectDate{
            
        }else{
            let item = selectedOrder.arrItems![textField.tag]
            let qty = Double(textField.text ?? "") ?? 0
            if qty == 0{
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: AppConstants.GlobalAlert.ALERT_ITEM_NOT_ZERO, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
                if let cell = tblOrders.cellForRow(at: IndexPath.init(row: textField.tag, section: 0)) as? OrderDetailViewCell{
                    if item.returnQty != nil{
                        cell.txtQty.text = "\(item.returnQty ?? 0)"
                    }else{
                        if item.itemQty ?? 0 > item.stockQty ?? 0{
                            cell.txtQty.text = ""
                        }else{
                            cell.txtQty.text = "\(item.itemQty ?? 0)"
                        }
                    }
                }
                return
            }else if qty > item.itemQty ?? 0{
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: AppConstants.GlobalAlert.QTY_BELOW_SELECTED_QTY, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
                if let cell = tblOrders.cellForRow(at: IndexPath.init(row: textField.tag, section: 0)) as? OrderDetailViewCell{
                    if item.returnQty != nil{
                        cell.txtQty.text = "\(item.returnQty ?? 0)"
                    }else{
                        if item.itemQty ?? 0 > item.stockQty ?? 0{
                            cell.txtQty.text = ""
                        }else{
                            cell.txtQty.text = "\(item.itemQty ?? 0)"
                        }
                    }
                }
                return
            }else if qty > item.stockQty ?? 0{
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: String.init(format: "Selected item has %.1f quantity in stock, Please enter below stock quantity to proceed", item.stockQty ?? 0), withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
                if let cell = tblOrders.cellForRow(at: IndexPath.init(row: textField.tag, section: 0)) as? OrderDetailViewCell{
                    if item.returnQty != nil{
                        cell.txtQty.text = "\(item.returnQty ?? 0)"
                    }else{
                        if item.itemQty ?? 0 > item.stockQty ?? 0{
                            cell.txtQty.text = ""
                        }else{
                            cell.txtQty.text = "\(item.itemQty ?? 0)"
                        }
                    }
                }
                return
            }
            
            if let cell = tblOrders.cellForRow(at: IndexPath.init(row: textField.tag, section: 0)) as? OrderDetailViewCell{
                cell.txtQty.text = "\(qty)"
            }
            item.returnQty = qty
        }
        
    }
}
