//
//  EmployeeDashboardVC.swift
//  globalfoods
//
//  Created by Apple on 01/02/21.
//

import UIKit

class EmployeeDashboardCell:UICollectionViewCell{
    
    @IBOutlet weak var lblTitle:UILabel!
    @IBOutlet weak var imgView:UIImageViewX!
    @IBOutlet weak var lblHorizontalLine:UILabel!
    @IBOutlet weak var lblVerticalLine:UILabel!
    
    override class func awakeFromNib() {
        
    }
}

class EmployeeDashboardVC: UIViewController {
    
    @IBOutlet weak var collectionDashboard:UICollectionView!
    
    var arrSideMenu = [SideMenuCellData]()
    var customHeaderView:HeaderView?
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        // Do any additional setup after loading the view.
        setViewData()
        setHeaderView()
        NotificationCenter.default.addObserver(self, selector: #selector(setViewData), name: AppConstants.notifications.kEmployeeDataFetch, object: nil)
    }
    
    deinit {
        NotificationCenter.default.removeObserver(self)
    }
    
    //MARK: Create Viewcontrlloer instance
    static func instance()->EmployeeDashboardVC?{
        return UIStoryboard.init(name: "SideMenu", bundle: nil).instantiateViewController(withIdentifier: "EmployeeDashboardVC") as? EmployeeDashboardVC
    }
    
    override func viewDidLayoutSubviews() {
        DispatchQueue.main.async {
            self.collectionDashboard.reloadData()
        }
    }
    
    //MARK: General methods
    func setHeaderView(){
        if customHeaderView != nil{
            customHeaderView!.removeFromSuperview()
            customHeaderView = nil
        }
        customHeaderView = HeaderView.init(controller: self, title: "Dashboard", isBackEnbaled: false)
    }
    
    @objc func setViewData(){
        arrSideMenu.removeAll()
        if AppConstants.employeeData?.rights?.order?.insert ?? 0 == 1{
            arrSideMenu.append(.init("Create Order", "createorder", SideMenuCellType.kCreateOrder))
        }
        if AppConstants.employeeData?.rights?.salesOrder?.insert ?? 0 == 1{
            arrSideMenu.append(.init("Create Sales Order", "createorder", SideMenuCellType.kCreateSalesOrder))
        }
        if AppConstants.employeeData?.rights?.order?.view ?? 0 == 1{
            arrSideMenu.append(.init("Order History", "orderhistory", SideMenuCellType.kOrderHistory))
        }
        if AppConstants.employeeData?.rights?.salesOrder?.view ?? 0 == 1{
            arrSideMenu.append(.init("Sales Order History", "orderhistory", SideMenuCellType.kSalesOrderHistory))
        }
        if AppConstants.employeeData?.rights?.salesOrder?.insert ?? 0 == 1{
            arrSideMenu.append(.init("Order Layaway", "lawaway", SideMenuCellType.kLayAway))
        }
        if AppConstants.employeeData?.rights?.returnOrder?.view ?? 0 == 1{
            arrSideMenu.append(.init("Return Order", "return_order", SideMenuCellType.kReturnOrder))
        }
        if AppConstants.employeeData?.rights?.invoice?.view ?? 0 == 1{
            arrSideMenu.append(.init("Invoice", "invoice", SideMenuCellType.kInvoice))
        }
        if AppConstants.employeeData?.rights?.creditNote?.view ?? 0 == 1{
            arrSideMenu.append(.init("Credit Note", "createorder", SideMenuCellType.kCreateNote))
        }
        if AppConstants.employeeData?.rights?.payment?.view ?? 0 == 1{
            arrSideMenu.append(.init("Payment", "pay", SideMenuCellType.kPayment))
        }
        if AppConstants.employeeData?.rights?.dispatch?.view ?? 0 == 1{
            arrSideMenu.append(.init("Dispatches", "dispath", SideMenuCellType.kDispatches))
        }
        if AppConstants.employeeData?.rights?.delivery?.view ?? 0 == 1{
            arrSideMenu.append(.init("Deliveries", "dispath", SideMenuCellType.kDeliveries))
        }
        if AppConstants.employeeData?.rights?.visit?.view ?? 0 == 1{
            arrSideMenu.append(.init("Repo Visits", "repovisit", SideMenuCellType.kRepoVisits))
        }
        if AppConstants.employeeData?.rights?.picklist?.view ?? 0 == 1{
            arrSideMenu.append(.init("Checklist", "checklist", SideMenuCellType.kChecklist))
        }
        if AppConstants.employeeData?.rights?.salesOrder?.view ?? 0 == 1{
            arrSideMenu.append(.init("Sales Report", "createorder", SideMenuCellType.kSalesReport))
        }
        if let drawer = AppConstants.employeeData?.rights?.cashDrawer{
            if drawer.view ?? 0 == 1{
                arrSideMenu.append(.init("Cash Drawer", "ic_cash", SideMenuCellType.kCashDrawer))
            }
        }else{
            arrSideMenu.append(.init("Cash Drawer", "ic_cash", SideMenuCellType.kCashDrawer))
        }
        var arr:[SideMenuCellData] = [.init("Notifications", "notificationios", SideMenuCellType.kNotification),.init("Terms & Condition", "termsandcondition", SideMenuCellType.kTermCondition)]
        arr.insert(.init("Support", "support", SideMenuCellType.kSupport), at: 0)
        if AppConstants.employeeData?.rights?.account?.view ?? 0 == 1{
            arr.insert(.init("Account", "account", SideMenuCellType.kAccount), at: 0)
        }
        
        arrSideMenu.append(contentsOf: arr)
        collectionDashboard.reloadData()
    }
}

extension EmployeeDashboardVC:UICollectionViewDataSource,UICollectionViewDelegate, UICollectionViewDelegateFlowLayout{
    
    func collectionView(_ collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return arrSideMenu.count
    }
    
    func collectionView(_ collectionView: UICollectionView, cellForItemAt indexPath: IndexPath) -> UICollectionViewCell {
        let cell = collectionView.dequeueReusableCell(withReuseIdentifier: "EmployeeDashboardCell", for: indexPath) as! EmployeeDashboardCell
        let model = arrSideMenu[indexPath.row]
        cell.lblTitle.text = model.title
        cell.imgView.image = UIImage.init(named: model.imgName)
        cell.imgView.imageColor = AppConstants.Colors.kAppMainThemeColor
        cell.lblVerticalLine.isHidden = false
        cell.lblHorizontalLine.isHidden = false
        
        var totalColumn = 3
        if AppConstants.DeviceType.IS_IPAD{
            if UIScreen.main.bounds.size.width > 1024{
                totalColumn = 7
            }else{
                totalColumn = 5
            }
        }
        if (indexPath.row+1)%totalColumn == 0{
            cell.lblVerticalLine.isHidden = true
        }
        let lastRow = arrSideMenu.count%totalColumn
        if lastRow == 0{
            if arrSideMenu.count-(indexPath.row+1) < totalColumn{
                cell.lblHorizontalLine.isHidden = true
            }
        }else{
            if arrSideMenu.count-(indexPath.row+1) < lastRow{
                cell.lblHorizontalLine.isHidden = true
            }
        }
        return cell
    }
    
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, sizeForItemAt indexPath: IndexPath) -> CGSize {
        let width = UIScreen.main.bounds.size.width-40
        if AppConstants.DeviceType.IS_IPAD{
            if UIScreen.main.bounds.size.width > 1024{
                return CGSize.init(width: width/7, height: width/7)
            }else{
                return CGSize.init(width: width/5, height: width/5)
            }
        }else{
            return CGSize.init(width: width/3, height: width/3)
        }
    }
    
    func collectionView(_ collectionView: UICollectionView, didSelectItemAt indexPath: IndexPath) {
        let type = arrSideMenu[indexPath.row].type
        switch type {
        case SideMenuCellType.kAccount:
            if let VC = AccountVC.instance(){
                VC.isBackEnabled = true
                self.navigationController?.pushViewController(VC, animated: true)
            }
        case SideMenuCellType.kCreateOrder:
            if let VC = CreateOrderVC.instance(){
                VC.isBackEnabled = true
                self.navigationController?.pushViewController(VC, animated: true)
            }
        case SideMenuCellType.kCreateSalesOrder:
            if let VC = CreateOrderVC.instance(){
                VC.isBackEnabled = true
                VC.isSalesOrder = true
                self.navigationController?.pushViewController(VC, animated: true)
            }
        case SideMenuCellType.kSalesOrderHistory:
            if let VC = OrderHistoryVC.instance(){
                VC.isSalesOrder = true
                VC.isBackEnabled = true
                self.navigationController?.pushViewController(VC, animated: true)
            }
        case SideMenuCellType.kOrderHistory:
            if let VC = OrderHistoryVC.instance(){
                VC.isBackEnabled = true
                self.navigationController?.pushViewController(VC, animated: true)
            }
        case SideMenuCellType.kReturnOrder:
            if let VC = ReturnOrderVC.instance(){
                VC.isBackEnabled = true
                self.navigationController?.pushViewController(VC, animated: true)
            }
        case SideMenuCellType.kInvoice:
            if let VC = InvoiceVC.instance(){
                VC.isBackEnabled = true
                self.navigationController?.pushViewController(VC, animated: true)
            }
        case SideMenuCellType.kCreateNote:
            if let VC = CreditNoteVC.instance(){
                VC.isBackEnabled = true
                self.navigationController?.pushViewController(VC, animated: true)
            }
        case SideMenuCellType.kDispatches:
            if let VC = DispatchesVC.instance(){
                VC.isBackEnabled = true
                self.navigationController?.pushViewController(VC, animated: true)
            }
        case SideMenuCellType.kDeliveries:
            if let VC = DeliveriesVC.instance(){
                VC.isBackEnabled = true
                self.navigationController?.pushViewController(VC, animated: true)
            }
        case SideMenuCellType.kRepoVisits:
            if let VC = RepoVisitVC.instance(){
                VC.isBackEnabled = true
                self.navigationController?.pushViewController(VC, animated: true)
            }
        case SideMenuCellType.kSupport:
            if let VC = SupportVC.instance(){
                VC.isBackEnabled = true
                self.navigationController?.pushViewController(VC, animated: true)
            }
        case SideMenuCellType.kNotification:
            if let VC = NotificationsVC.instance(){
                VC.isBackEnabled = true
                self.navigationController?.pushViewController(VC, animated: true)
            }
        case SideMenuCellType.kTermCondition:
            if let VC = TermsConditionVC.instance(){
                VC.isBackEnabled = true
                self.navigationController?.pushViewController(VC, animated: true)
            }
        case SideMenuCellType.kPayment:
            if let VC = PaymentListVC.instance(){
                VC.isBackEnabled = true
                self.navigationController?.pushViewController(VC, animated: true)
            }
        case SideMenuCellType.kChecklist:
            if let VC = ChecklistVC.instance(){
                VC.isBackEnabled = true
                self.navigationController?.pushViewController(VC, animated: true)
            }
        case SideMenuCellType.kSalesReport:
            if let VC = SalesReportVC.instance(){
                VC.isBackEnabled = true
                self.navigationController?.pushViewController(VC, animated: true)
            }
        case SideMenuCellType.kLayAway:
            if let VC = OrderLayawayVC.instance(){
                VC.isBackEnabled = true
                self.navigationController?.pushViewController(VC, animated: true)
            }
        case SideMenuCellType.kCashDrawer:
            PrintManager.shared.connectToPrinterWithPrint(model: AppConstants.employeeData!)
        default:
            break
        }
    }
}
