//
//  OrderLayawayVC.swift
//  globalfoods
//
//  Created by Apple on 25/11/21.
//

import UIKit

class OrderLayawayVC: UIViewController {

    @IBOutlet weak var tblOrders:UITableView!
    
    var customHeaderView:HeaderView?
    var isBackEnabled = false
    var arrLayAway = [OrderHistoryModel]()
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
        setHeaderView()
    }

    override func viewWillAppear(_ animated: Bool) {
        getOrderLayAwayAPI()
    }
    
    //MARK: Create Viewcontrlloer instance
    static func instance()->OrderLayawayVC?{
        return UIStoryboard.init(name: "Employees", bundle: nil).instantiateViewController(withIdentifier: "OrderLayawayVC") as? OrderLayawayVC
    }
    
    //MARK: General methods
    func setHeaderView(){
        if customHeaderView != nil{
            customHeaderView!.removeFromSuperview()
            customHeaderView = nil
        }
        customHeaderView = HeaderView.init(controller: self, title: "Order Layaway", isBackEnbaled: isBackEnabled)
    }
    
    @IBAction func btnOrderAction(_ sender:UIButton){
        let model = arrLayAway[sender.tag]
        let cart = UserCartModel()
        cart.remark = model.remarks
        cart.cartitems = model.arrItems
        cart.orderLayAwayId = model.id
        AppConstants.employeeCart = cart
        if let VC = UserCartVC.instance(){
            VC.isSalesOrder = true
            VC.isFromLayAway = true
            VC.customerName = model.customerName ?? ""
            VC.cuid = model.cid
            VC.cbid = model.cbid
            self.navigationController?.pushViewController(VC, animated: true)
        }
    }
    
    func getOrderLayAwayAPI(){
        var param = [String:String]()
        param["key"] = AppConstants.commonConstant.kAPIKey
        
        AppCommonMethods.startProgressBar()
        param["s"] = "135"
        param["emp_id"] = "\(AppConstants.employeeData?.id ?? 0)"
        
        WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: AppConstants.APIURLs.kServiceEmployeeURL) { (message, response) in
            DispatchQueue.main.async {
                var aMessage = message
                self.arrLayAway.removeAll()
                AppCommonMethods.stopProgressBar()
                if response != nil{
                    if AppConstants.isInDevlopmentMode{
                        print("Order Layaway Data:",response!)
                    }
                    if let result = response!["layaway_orders"] as? [NSDictionary], response!.getIntValue("ack") ?? 0 == 1{
                        if let data = AppCommonMethods.convertToJson(object: result){
                            let jsonDecoder = JSONDecoder()
                            if let aData = try? jsonDecoder.decode([OrderHistoryModel].self, from: data){
                                self.arrLayAway = aData
                                self.tblOrders.reloadData()
                                return
                            }
                        }
                    }else{
                        aMessage = response!.getStringValue("ack_msg") ?? ""
                    }
                }
                self.tblOrders.reloadData()
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: aMessage, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
            }
        }
    }
}

extension OrderLayawayVC:UITableViewDataSource{
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return arrLayAway.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "OrderHistoryCell", for: indexPath) as! OrderHistoryCell
        let model = arrLayAway[indexPath.row]
        cell.lblOrderNo.text = "Customer Name: \(model.customerName ?? "")"
        let date = (model.date ?? "").getDateFromString(format: "dd-MM-yyyy") ?? Date()
        let strDesc = "Saved on: \(date.getDateInString(format: "dd'\(date.getDateSuffix())' MMM, yyyy"))"
        let attrDesc = NSMutableAttributedString.init(string: strDesc, attributes: [NSAttributedString.Key.foregroundColor : AppConstants.Colors.kAppGrayThemeColor,NSAttributedString.Key.font:AppConstants.GlobalFontConstants.kRegularFont(size: AppConstants.DeviceType.IS_IPAD ? 16 : 14)])
        attrDesc.addFontAttribute(title: "Saved on", fontSize: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
        cell.lblDescription.attributedText = attrDesc
        cell.lblOrderPrice.text = String.init(format: "%@%.2f", AppConstants.currencySign,model.orderTotal ?? 0)
        cell.btnOrders.tag = indexPath.row
        return cell
    }
}
