//
//  UpdateInvoiceVC.swift
//  globalfoods
//
//  Created by Apple on 30/01/21.
//

import UIKit
import ActionSheetPicker_3_0

class UpdateInvoiceVC: UIViewController {
    
    @IBOutlet weak var txtInvoiceDate:UITextField!
    @IBOutlet weak var txtDueDate:UITextField!
    @IBOutlet weak var tblInvoice:UITableView!
    
    var arrItems = [InvoiceItemModel]()
    var arrAllItems = [ProductsModel]()
    var invoiceDetail:InvoiceModel!
    var strInvoiceDate = ""
    var strDueDate = ""
    var customHeaderView:HeaderView?
    var popRecognizer: InteractivePopRecognizer?
    var apiCount = 0
    var totalAPI = 2
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
        callGetInvoiceDetail()
        callGetProductAPI()
        setHeaderView()
        setInteractiveRecognizer()
        self.strInvoiceDate = (self.invoiceDetail.invoiceDate ?? "").changeDateFormat(fromFormat: "dd-MM-yy", toFormat: "yyyy-MM-dd") ?? ""
        self.txtInvoiceDate.text = (self.invoiceDetail.invoiceDate ?? "").changeDateFormat(fromFormat: "dd-MM-yy", toFormat: "dd/MM/yyyy") ?? ""
        self.strDueDate = (self.invoiceDetail.invoiceDate ?? "").changeDateFormat(fromFormat: "dd-MM-yy", toFormat: "yyyy-MM-dd") ?? ""
        self.txtDueDate.text = (self.invoiceDetail.invoiceDate ?? "").changeDateFormat(fromFormat: "dd-MM-yy", toFormat: "dd/MM/yyyy") ?? ""
    }

    //MARK: create viewcontroller instance
    class func instance()->UpdateInvoiceVC?{
        return UIStoryboard.init(name: "Employees", bundle: nil).instantiateViewController(withIdentifier: "UpdateInvoiceVC") as? UpdateInvoiceVC
    }
    
    //MARK: General methods
    func setHeaderView(){
        if customHeaderView != nil{
            customHeaderView!.removeFromSuperview()
            customHeaderView = nil
        }
        customHeaderView = HeaderView.init(controller: self, title: "Sales Invoice", isBackEnbaled: true)
    }

    private func setInteractiveRecognizer() {
        guard let controller = navigationController else { return }
        popRecognizer = InteractivePopRecognizer(controller: controller)
        controller.interactivePopGestureRecognizer?.delegate = popRecognizer
    }
    
    @IBAction func btnAddProdcutAction(_ sender:UIButton){
        if let VC = ModifyProductsVC.instance(items: arrAllItems){
            if let topVC = VC.childViewController as? ModifyProductsVC{
                topVC.delegate = self
            }
            self.present(VC, animated: true, completion: nil)
        }
    }
    
    @IBAction func btnConfirmAction(_ sender:UIButton){
        if strInvoiceDate == ""{
            AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: AppConstants.GlobalAlert.ALERT_SELECT_INVOICEDATE, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                
            }
        }else if strDueDate == ""{
            AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: AppConstants.GlobalAlert.ALERT_SELECT_DUEDATE, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                
            }
        }else{
            callUpdateInvoiceDetail()
        }
    }
    
    func callUpdateInvoiceDetail(){
        //http://global.smartmps.co.uk/rms/service/service_employee.php?key=1226&s=122&sales_invoice_date=&sales_invoice_no=&invoice_due_date=&item=
        var param = [String:String]()
        param["key"] = AppConstants.commonConstant.kAPIKey
        param["s"] = "122"
        param["id"] = "\(invoiceDetail.id ?? 0)"
        param["sales_invoice_no"] = invoiceDetail.invoiceNo ?? ""
        param["invoice_due_date"] = strDueDate
        param["sales_invoice_date"] = strInvoiceDate
        var arrProdcut = [NSMutableDictionary]()
        for item in arrItems{
            let dictProduct = NSMutableDictionary()
            dictProduct["item_id"] = "\(item.itemId ?? 0)"
            dictProduct["item_qty"] = "\(item.qty ?? 0)"
            dictProduct["item_price"] = "\(item.price ?? 0)"
            arrProdcut.append(dictProduct)
        }
        param["item"] = AppCommonMethods.convertJsontoString(json: arrProdcut)
        if AppConstants.isInDevlopmentMode{
            print("Invoice Update Param:",param)
        }
        AppCommonMethods.startProgressBar()
        WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: AppConstants.APIURLs.kServiceEmployeeURL) { (message, response) in
            DispatchQueue.main.async {
                var aMessage = message
                AppCommonMethods.stopProgressBar()
                if response != nil{
                    if AppConstants.isInDevlopmentMode{
                        print("Invoice Update Data:",response!)
                    }
                    aMessage = response!.getStringValue("ack_msg") ?? ""
                    if response!.getIntValue("ack") ?? 0 == 1{
                        var setting = BottomAlertSettings()
                        setting.strMessage = aMessage
                        AppValidation.shared.showBottomAlertView(settings: setting)
                        self.navigationController?.popToRootViewController(animated: true)
                        return
                    }
                }
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: aMessage, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
            }
        }
    }
    
    func callGetInvoiceDetail(){
        //http://global.smartmps.co.uk/rms/service/service_customer.php?s=8&key=1226&cid=4&cbid=4&emp_id=2&iid=51
        var param = [String:String]()
        param["key"] = AppConstants.commonConstant.kAPIKey
        param["s"] = "79"
        param["cuid"] = "\(invoiceDetail?.cid ?? 0)"
        param["cbid"] = "\(invoiceDetail?.cbid ?? 0)"
        param["emp_id"] = "\(AppConstants.employeeData?.id ?? 0)"
        param["iid"] = "\(invoiceDetail?.id ?? 0)"
        
        AppCommonMethods.startProgressBar()
        WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: AppConstants.APIURLs.kServiceCustomerURL) { (message, response) in
            DispatchQueue.main.async {
                var aMessage = message
                self.arrItems.removeAll()
                if response != nil{
                    if AppConstants.isInDevlopmentMode{
                        print("Invoice Data:",response!)
                    }
                    if let result = response!["result"] as? NSDictionary, response!.getIntValue("ack") ?? 0 == 1, let arr = result["items"] as? [NSDictionary]{
                        if let data = AppCommonMethods.convertToJson(object: arr){
                            let jsonDecoder = JSONDecoder()
                            if let aData = try? jsonDecoder.decode([InvoiceItemModel].self, from: data){
                                self.arrItems = aData
                                self.arrItems.forEach { (model) in
                                    model.subTotal = (model.price ?? 0) * (model.qty ?? 0)
                                }
                                self.tblInvoice.reloadData()
                                self.stopLoader()
                                return
                            }
                        }
                    }else{
                        aMessage = response!.getStringValue("ack_msg") ?? ""
                    }
                }
                self.stopLoader()
                self.tblInvoice.reloadData()
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: aMessage, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
            }
        }
    }
    
    func callGetProductAPI(){
        var param = [String:String]()
        param["key"] = AppConstants.commonConstant.kAPIKey
        param["s"] = "8"
        param["cuid"] = "\(invoiceDetail.cid ?? 0)"
        param["cbid"] = "\(invoiceDetail.cbid ?? 0)"
        param["type"] = "iOS"
        AppCommonMethods.startProgressBar()
        WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: AppConstants.APIURLs.kServiceCustomerURL) { (message, response) in
            DispatchQueue.main.async {
                var aMessage = message
                if response != nil{
                    if AppConstants.isInDevlopmentMode{
                        print("Product Data:",response!)
                    }
                    if let result = response!["result"] as? [NSDictionary], response!.getIntValue("ack") ?? 0 == 1{
                        if let data = AppCommonMethods.convertToJson(object: result){
                            let jsonDecoder = JSONDecoder()
                            if let aData = try? jsonDecoder.decode([ProductsModel].self, from: data){
                                self.arrAllItems = aData
                                self.stopLoader()
                                return
                            }
                        }
                    }else{
                        aMessage = response!.getStringValue("ack_msg") ?? ""
                    }
                }
                self.stopLoader()
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: aMessage, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
            }
        }
    }
    
    func stopLoader(){
        apiCount += 1
        if apiCount == totalAPI{
            AppCommonMethods.stopProgressBar()
            arrAllItems.forEach { (item) in
                let index = arrItems.firstIndex(where: { (model) -> Bool in
                    return item.id ?? 0 == model.itemId ?? 0
                })
                if index != nil{
                    item.isSelected = true
                    item.selectedQty = arrItems[index!].qty ?? 0
                    item.itemPrice = arrItems[index!].price ?? 0
                }else{
                    item.selectedQty = 1
                }
                item.itemTotalPrice = item.selectedQty * (item.itemPrice ?? 0)
            }
        }
    }
}

extension UpdateInvoiceVC:UITableViewDataSource,UITableViewDelegate{
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return arrItems.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "OrderDetailViewCell", for: indexPath) as! OrderDetailViewCell
        let model = arrItems[indexPath.row]
        cell.lblName.text = model.itemName ?? ""
        cell.lblPrice.text = String.init(format: "%@%.2f", AppConstants.currencySign ,model.subTotal ?? 0)
        
        let strDesc = "Item Quantity: \(String.init(format: "%.1f", model.qty ?? 0))\nItem Price: \(String.init(format: "%@%.2f", AppConstants.currencySign ,model.price ?? 0))"
        let attrDesc = NSMutableAttributedString.init(string: strDesc, attributes: [NSAttributedString.Key.foregroundColor : AppConstants.Colors.kAppGrayThemeColor,NSAttributedString.Key.font:AppConstants.GlobalFontConstants.kRegularFont(size: AppConstants.DeviceType.IS_IPAD ? 16 : 14)])
        attrDesc.addFontAttribute(title: "Item Quantity", fontSize: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
        attrDesc.addFontAttribute(title: "Item Price", fontSize: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
        cell.lblQty.attributedText = attrDesc
        
        return cell
    }
}

extension UpdateInvoiceVC:UITextFieldDelegate{
    func textFieldShouldBeginEditing(_ textField: UITextField) -> Bool {
        if textField == txtInvoiceDate{
            let date = strInvoiceDate.getDateFromString(format: "yyyy-MM-dd", locale: nil) ?? Date()
            let datePicker = ActionSheetDatePicker(title: "Select invoice date", datePickerMode: UIDatePicker.Mode.date, selectedDate: date, doneBlock: {
                picker, value, index in
                self.strInvoiceDate = (value as! Date).getDateInString(format: "yyyy-MM-dd")
                self.txtInvoiceDate.text = (value as! Date).getDateInString(format: "dd/MM/yyyy")
            }, cancel: { ActionStringCancelBlock in return }, origin: textField)
            datePicker?.minimumDate = Date()
            datePicker?.show()
            return false
        }else if textField == txtDueDate{
            let date = strDueDate.getDateFromString(format: "yyyy-MM-dd", locale: nil) ?? Date()
            let datePicker = ActionSheetDatePicker(title: "Select due date", datePickerMode: UIDatePicker.Mode.date, selectedDate: date, doneBlock: {
                picker, value, index in
                self.strDueDate = (value as! Date).getDateInString(format: "yyyy-MM-dd")
                self.txtDueDate.text = (value as! Date).getDateInString(format: "dd/MM/yyyy")
            }, cancel: { ActionStringCancelBlock in return }, origin: textField)
            datePicker?.minimumDate = Date()
            datePicker?.show()
            return false
        }
        return true
    }
}

extension UpdateInvoiceVC:ModifyProductsDelegate{
    func productUpdated(arrSelecteditems: [InvoiceItemModel]) {
        arrItems = arrSelecteditems
        arrAllItems.forEach { (item) in
            let index = arrItems.firstIndex(where: { (model) -> Bool in
                return item.id ?? 0 == model.itemId ?? 0
            })
            if index != nil{
                item.isSelected = true
                item.selectedQty = arrItems[index!].qty ?? 0
                item.itemPrice = arrItems[index!].price ?? 0
            }else{
                item.selectedQty = 1
            }
            item.itemTotalPrice = item.selectedQty * (item.itemPrice ?? 0)
        }
        tblInvoice.reloadData()
    }
}
