//
//  SelectDriverVC.swift
//  globalfoods
//
//  Created by Apple on 21/01/21.
//

import UIKit

class VehicleStorageVC: UIViewController {

    @IBOutlet weak var tblVehicleStorage:UITableView!
    @IBOutlet weak var lblDriverInfo:UILabel!
    @IBOutlet weak var lblPayment:UILabel!
    @IBOutlet weak var lblTotalDispatch:UILabel!
    @IBOutlet weak var lblTotalPremises:UILabel!
    @IBOutlet weak var viewForSelectDriver:UIView!
    @IBOutlet weak var viewForPaytmntInfo:UIView!
    
    var customHeaderView:HeaderView?
    var popRecognizer: InteractivePopRecognizer?
    var selectedVehicle:vehicleModel?
    var selectedDriver:EmployeeModel?
    var arrVehicleLoad = [DispatchModel]()
    var arrSelectedDelivery = [DispatchModel]()
    var totalArrCount = 0
    var isAPICalling = false
    let limit = 10
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
        setInteractiveRecognizer()
        setHeaderView()
        if let VC = SelectDriverVC.showPopup(parentVC: self, vehicleData: selectedVehicle, driverData: selectedDriver){
            VC.delegate = self
        }
    }
    
    //MARK: Create Viewcontrlloer instance
    static func instance()->VehicleStorageVC?{
        return UIStoryboard.init(name: "Employees", bundle: nil).instantiateViewController(withIdentifier: "VehicleStorageVC") as? VehicleStorageVC
    }
    
    //MARK: General methods
    func setHeaderView(){
        if customHeaderView != nil{
            customHeaderView!.removeFromSuperview()
            customHeaderView = nil
        }
        customHeaderView = HeaderView.init(controller: self, title: "Deliveries", isBackEnbaled: true)
    }

    private func setInteractiveRecognizer() {
        guard let controller = navigationController else { return }
        popRecognizer = InteractivePopRecognizer(controller: controller)
        controller.interactivePopGestureRecognizer?.delegate = popRecognizer
    }
    
    @IBAction func btnChangeDriverAction(_ sender:UIButton){
        if let VC = SelectDriverVC.showPopup(parentVC: self, vehicleData: selectedVehicle, driverData: selectedDriver){
            VC.delegate = self
        }
    }
    
    @IBAction func btnConfirmAction(_ sender:UIButton){
        //http://global.smartmps.co.uk/rms/service/service_order.php?key=1226&s=74&dispatchs=[12,13,14]&vehical_id=1&driver_id=1&emp_id=1&emp_type=1
        callConfirmDeliveryAPI()
    }
    
    func callConfirmDeliveryAPI(){
        var param = [String:String]()
        param["key"] = AppConstants.commonConstant.kAPIKey
        param["s"] = "74"
        param["emp_id"] = "\(AppConstants.employeeData?.id ?? 0)"
        param["emp_type"] = "\(AppConstants.employeeData?.adminType ?? 0)"
        param["vehical_id"] = "\(selectedVehicle?.id ?? 0)"
        param["driver_id"] = "\(selectedDriver?.id ?? 0)"
        var arrItems = [String]()
        for model in arrSelectedDelivery{
            arrItems.append("\(model.id ?? 0)")
        }
        param["dispatchs"] = AppCommonMethods.convertJsontoString(json: arrItems)
        
        if AppConstants.isInDevlopmentMode{
            print("Delivery Param:",param)
        }
        AppCommonMethods.startProgressBar()
        WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: AppConstants.APIURLs.kServiceOrderURL) { (message, response) in
            DispatchQueue.main.async {
                AppCommonMethods.stopProgressBar()
                var setting = BottomAlertSettings()
                setting.strMessage = message
                if response != nil{
                    if AppConstants.isInDevlopmentMode{
                        print("Delivery Data:",response!)
                    }
                    if response!.getIntValue("ack") ?? 0 == 1{
                        self.navigationController?.popToRootViewController(animated: true)
                    }
                    setting.strMessage = response!.getStringValue("ack_msg") ?? ""
                }
                AppValidation.shared.showBottomAlertView(settings: setting)
            }
        }
    }
    
    func callGetVehicleStorage(isFromLoad:Bool){
        //http://global.smartmps.co.uk/rms/service/service_order.php?key=1226&s=72&vid=1&did=1
        if isAPICalling{
            return
        }
        isAPICalling = true
        var param = [String:String]()
        param["key"] = AppConstants.commonConstant.kAPIKey
        param["s"] = "72"
        param["vid"] = "\(selectedVehicle?.id ?? 0)"
        param["did"] = "\(selectedDriver?.id ?? 0)"
        if isFromLoad{
            param["offset"] = "0,\(limit)"
        }else{
            param["offset"] = "\(arrVehicleLoad.count),\(limit)"
        }
        AppCommonMethods.startProgressBar()
        WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: AppConstants.APIURLs.kServiceOrderURL) { (message, response) in
            DispatchQueue.main.async {
                var aMessage = message
                if isFromLoad{
                    self.arrVehicleLoad.removeAll()
                }
                self.isAPICalling = false
                AppCommonMethods.stopProgressBar()
                if response != nil{
                    if AppConstants.isInDevlopmentMode{
                        print("Dispatches Data:",response!)
                    }
                    if let result = response!["result"] as? NSDictionary, response!.getIntValue("ack") ?? 0 == 1, let dispatch = result["dispatch"] as? [NSDictionary]{
                        self.totalArrCount = result.getIntValue("total_dispatch") ?? 0
                        if let data = AppCommonMethods.convertToJson(object: dispatch){
                            let jsonDecoder = JSONDecoder()
                            if let aData = try? jsonDecoder.decode([DispatchModel].self, from: data){
                                if isFromLoad{
                                    self.arrVehicleLoad = aData
                                    self.lblTotalDispatch.setLabelAttributedText(title: "Total Dispatches", value: result.getStringValue("total_dispatch") ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16)
                                    self.lblPayment.setLabelAttributedText(title: "Payment To Be Collect", value: String.init(format: "%@%.2f", AppConstants.currencySign,result.getDoubleValue("total_grantotal") ?? 0), fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16)
                                    self.lblTotalPremises.setLabelAttributedText(title: "Total Premises", value: result.getStringValue("total_premises") ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16)
                                    self.viewForPaytmntInfo.isHidden = false
                                }else{
                                    self.arrVehicleLoad.append(contentsOf: aData)
                                }
                                self.tblVehicleStorage.reloadData()
                                return
                            }
                        }
                    }else{
                        aMessage = response!.getStringValue("ack_msg") ?? ""
                    }
                }
                self.tblVehicleStorage.reloadData()
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: aMessage, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
            }
            
        }
    }
}

extension VehicleStorageVC:driverSelctionDelegate{
    func driverSelected(driverData: EmployeeModel?, vehicleData: vehicleModel?) {
        self.selectedDriver = driverData
        self.selectedVehicle = vehicleData
        self.viewForSelectDriver.isHidden = false
        let strDriver = "Driver name: \(driverData?.name ?? "")\nVehicle name: \(vehicleData?.name ?? "")\nVehicle no: \(vehicleData?.vehicleNo ?? "")"
        let attrDriver = NSMutableAttributedString.init(string: strDriver, attributes: [NSAttributedString.Key.foregroundColor : AppConstants.Colors.kAppGrayThemeColor,NSAttributedString.Key.font:AppConstants.GlobalFontConstants.kRegularFont(size: AppConstants.DeviceType.IS_IPAD ? 17 : 15)])
        attrDriver.addFontAttribute(title: "Driver name", fontSize: AppConstants.DeviceType.IS_IPAD ? 17 : 15)
        attrDriver.addFontAttribute(title: "Vehicle name", fontSize: AppConstants.DeviceType.IS_IPAD ? 17 : 15)
        attrDriver.addFontAttribute(title: "Vehicle no", fontSize: AppConstants.DeviceType.IS_IPAD ? 17 : 15)
        lblDriverInfo.attributedText = attrDriver
        callGetVehicleStorage(isFromLoad: true)
        viewForSelectDriver.isHidden = true
    }
}

extension VehicleStorageVC:UITableViewDataSource,UITableViewDelegate{
    func scrollViewDidScroll(_ scrollView: UIScrollView) {
        if tblVehicleStorage.contentOffset.y >= (tblVehicleStorage.contentSize.height - tblVehicleStorage.frame.size.height) {
            if self.arrVehicleLoad.count < self.totalArrCount{
                self.callGetVehicleStorage(isFromLoad: false)
            }
        }
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return arrVehicleLoad.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "DispatchesCell", for: indexPath) as! DispatchesCell
        let model = arrVehicleLoad[indexPath.row]
        cell.lblOrderNo.text = "Order No: #\(model.orderNo ?? "")"
        cell.lblTotalPrice.text = String.init(format: "%@%.2f", AppConstants.currencySign, model.dispatchTotal ?? 0)
        let strDesc = "Billing person name: \(model.billingName ?? "")\nAddress: \(model.billingAddress ?? "")\nCity: \(model.billingCity ?? "")\nPincode: \(model.billingPincode ?? "")"
        let attrDesc = NSMutableAttributedString.init(string: strDesc, attributes: [NSAttributedString.Key.foregroundColor : AppConstants.Colors.kAppGrayThemeColor,NSAttributedString.Key.font:AppConstants.GlobalFontConstants.kRegularFont(size: AppConstants.DeviceType.IS_IPAD ? 16 : 14)])
        attrDesc.addFontAttribute(title: "City", fontSize: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
        attrDesc.addFontAttribute(title: "Billing person name", fontSize: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
        attrDesc.addFontAttribute(title: "Address", fontSize: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
        attrDesc.addFontAttribute(title: "Pincode", fontSize: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
        cell.lblDescription.attributedText = attrDesc
        cell.lblProducts.attributedText = (model.items ?? "").htmlToAttributedString(font: nil)
        return cell
    }
}
