//
//  DateRangeVC.swift
//  globalfoods
//
//  Created by Apple on 06/01/21.
//

import UIKit
import ActionSheetPicker_3_0

protocol dateRangeDelegate: AnyObject {
    func userselectedDate(toDate:String,fromDate:String)
}

class DateRangeVC: UIViewController {

    @IBOutlet weak var lblFromDate:UILabel!
    @IBOutlet weak var lblToDate:UILabel!
    
    weak var delegate:dateRangeDelegate?
    var strToDate = ""
    var strFromDate = ""
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
        self.lblFromDate.text = "From - \(strFromDate.changeDateFormat(fromFormat: "dd-MM-yyyy", toFormat: "dd/MM/yyyy") ?? "")"
        self.lblToDate.text = "To - \(strToDate.changeDateFormat(fromFormat: "dd-MM-yyyy", toFormat: "dd/MM/yyyy") ?? "")"
    }
    
    //MARK: create viewcontroller instance
    class func showPopup(parentVC:UIViewController,toDate:String,fromDate:String)->DateRangeVC?{
        if let container = UIStoryboard.init(name: "PopUps", bundle: nil).instantiateViewController(withIdentifier: "DateRangeVC") as? DateRangeVC{
            container.strToDate = toDate
            container.strFromDate = fromDate
            parentVC.addChild(container)
            parentVC.view.addSubview(container.view)
            container.view.frame = CGRect.init(x: 0, y: 0, width: UIScreen.main.bounds.size.width, height: UIScreen.main.bounds.size.height)
            container.view.alpha = 0.0
            UIView.animate(withDuration: 0.25) {
                container.view.alpha = 1.0
            }
            return container
        }
        return nil
    }
    
    func closePopup(){
        UIView.animate(withDuration: 0.25) {
            self.view.alpha = 0.0
        } completion: { (status) in
            self.view.removeFromSuperview()
            self.removeFromParent()
        }
    }
    
    //MARK: Button Actions
    @IBAction func btnFromDateAction(_ sender:UIButton){
        let date = strFromDate.getDateFromString(format: "dd-MM-yyyy", locale: nil) ?? Date()
        let datePicker = ActionSheetDatePicker(title: "Select from date", datePickerMode: UIDatePicker.Mode.date, selectedDate: date, doneBlock: {
            picker, value, index in
            self.strFromDate = (value as! Date).getDateInString(format: "dd-MM-yyyy")
            self.lblFromDate.text = "From - \((value as! Date).getDateInString(format: "dd/MM/yyyy"))"
        }, cancel: { ActionStringCancelBlock in return }, origin: sender)
        datePicker?.maximumDate = strToDate.getDateFromString(format: "dd-MM-yyyy", locale: nil) ?? Date()
        datePicker?.show()
    }
    
    @IBAction func btnToDateAction(_ sender:UIButton){
        let date = strToDate.getDateFromString(format: "dd-MM-yyyy", locale: nil) ?? Date()
        let datePicker = ActionSheetDatePicker(title: "Select to date", datePickerMode: UIDatePicker.Mode.date, selectedDate: date, doneBlock: {
            picker, value, index in
            self.strToDate = (value as! Date).getDateInString(format: "dd-MM-yyyy")
            self.lblToDate.text = "To - \((value as! Date).getDateInString(format: "dd/MM/yyyy"))"
        }, cancel: { ActionStringCancelBlock in return }, origin: sender)
        if let fromDate = strFromDate.getDateFromString(format: "dd-MM-yyyy", locale: nil){
            datePicker?.minimumDate = fromDate
        }
        datePicker?.show()
    }
    
    @IBAction func btnConfirmAction(_ sender:UIButton){
        self.closePopup()
        if delegate != nil{
            self.delegate?.userselectedDate(toDate: strToDate, fromDate: strFromDate)
        }
    }
    
    @IBAction func btnCancelAction(_ sender:UIButton){
        self.closePopup()
    }
}
