//
//  SettingsVC.swift
//  globalfoods
//
//  Created by Apple on 29/12/20.
//

import UIKit
import ActionSheetPicker_3_0

class AccountViewCell: UITableViewCell {
    
    @IBOutlet weak var lblDate:UILabel!
    @IBOutlet weak var lblRefNo:UILabel!
    @IBOutlet weak var lblCreditAmt:UILabel!
    @IBOutlet weak var lblDebitAmt:UILabel!
    
    override class func awakeFromNib() {
        
    }
}

class AccountVC: UIViewController {

    @IBOutlet weak var tblAccount:UITableView!
    @IBOutlet weak var lblAccountNo:UILabel!
    @IBOutlet weak var lblContactNo:UILabel!
    @IBOutlet weak var lblClosingBalance:UILabel!
    @IBOutlet weak var lblCustomerName:UILabel!
    @IBOutlet weak var lblCreditTitle:UILabel!
    @IBOutlet weak var lblDebitTitle:UILabel!
    @IBOutlet weak var lblTotalTitle:UILabel!
    @IBOutlet weak var lblTotalAmount:UILabel!
    @IBOutlet weak var btnChange:UIButton!
    @IBOutlet weak var btnBack:UIButton!
    @IBOutlet weak var viewForSelectCustomer:UIView!
    @IBOutlet weak var btnAddPayment:UIButton!
    
    var strToDate = ""
    var strFromDate = ""
    var arrTransaction = [transactionModel]()
    var selectedCustomer:UserModel?
    var selectedBranch:branchModel?
    var isBackEnabled = false
    var popRecognizer: InteractivePopRecognizer?
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
        self.strFromDate = Date().addingTimeInterval(-7*24*60*60).getDateInString(format: "dd-MM-yyyy")
        self.strToDate = Date().getDateInString(format: "dd-MM-yyyy")
        btnBack.isSelected = isBackEnabled
        if isBackEnabled{
            setInteractiveRecognizer()
        }
    }
    
    override func viewWillAppear(_ animated: Bool) {
        viewForSelectCustomer.isHidden = true
//        if AppConstants.userData != nil{
            callGetAccountAPI()
            btnChange.isHidden = true
            btnAddPayment.superview?.isHidden = true
//        }else{
//            btnChange.isHidden = false
//            if selectedCustomer == nil{
//                if let VC = SelectCustomerVC.showPopup(parentVC: self, branchData: selectedBranch, customerData: selectedCustomer){
//                    VC.delegate = self
//                }
//                if AppConstants.employeeData?.rights?.payment?.insert ?? 0 == 1{
//                    btnAddPayment.superview?.isHidden = false
//                }else{
//                    btnAddPayment.superview?.isHidden = true
//                }
//                viewForSelectCustomer.isHidden = false
//            }else{
//                callGetAccountAPI()
//            }
//        }
        
    }
    
    //MARK: Create Viewcontrlloer instance
    static func instance()->AccountVC?{
        return UIStoryboard.init(name: "SideMenu", bundle: nil).instantiateViewController(withIdentifier: "AccountVC") as? AccountVC
    }
    
    private func setInteractiveRecognizer() {
        guard let controller = navigationController else { return }
        popRecognizer = InteractivePopRecognizer(controller: controller)
        controller.interactivePopGestureRecognizer?.delegate = popRecognizer
    }

    //MARK: Button Actions
    @IBAction func btnChangeCustomerAction(_ sender:UIButton){
        if let VC = SelectCustomerVC.showPopup(parentVC: self, branchData: selectedBranch, customerData: selectedCustomer){
            VC.delegate = self
        }
    }
    
    @IBAction func btnCreatePaymentAction(_ sender:UIButton){
        if let VC = CreatePaymentVC.instance(){
            self.navigationController?.pushViewController(VC, animated: true)
        }
    }
    
    @IBAction func btnMenuAction(_ sender:UIButton) {
        if isBackEnabled{
            self.navigationController?.popViewController(animated: true)
        }else{
            self.sideMenuController?.revealMenu()
        }
        
    }
    
    @IBAction func btnFilterAction(_ sender:UIButton) {
        if let VC = DateRangeVC.showPopup(parentVC: self, toDate: strToDate, fromDate: strFromDate){
            VC.delegate = self
        }
    }
    
    @IBAction func btnDownloadAction(_ sender:UIButton) {
        downloadAccountPDFAPI()
    }
    
    func callGetAccountAPI(){
        //http://global.smartmps.co.uk/rms/service/service_employee.php?key=1226&s=76&aid=2&from_date=01-01-2001&date=01-01-2022
        var param = [String:String]()
        param["key"] = AppConstants.commonConstant.kAPIKey
        
        if AppConstants.userData != nil{
            param["cuid"] = "\(AppConstants.userData?.id ?? 0)"
            param["aid"] = "\(AppConstants.selectedBranch?.aid ?? 0)"
            param["s"] = "43"
            param["to_date"] = strToDate
        }else{
            param["s"] = "76"
            param["aid"] = "\(AppConstants.employeeData?.account?.id ?? 0)"
            param["date"] = strToDate
        }
        param["from_date"] = strFromDate
        
        
        if AppConstants.isInDevlopmentMode{
            print("Accounts Param:",param)
        }
        
        AppCommonMethods.startProgressBar()
        WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: (AppConstants.userData != nil) ? AppConstants.APIURLs.kServiceCustomerURL : AppConstants.APIURLs.kServiceEmployeeURL) { (message, response) in
            DispatchQueue.main.async {
                var aMessage = message
                self.arrTransaction.removeAll()
                self.viewForSelectCustomer.isHidden = true
                AppCommonMethods.stopProgressBar()
                if response != nil{
                    if AppConstants.isInDevlopmentMode{
                        print("Accounts Data:",response!)
                    }
                    if let result = response!["result"] as? NSDictionary, response!.getIntValue("ack") ?? 0 == 1{
                        if let data = AppCommonMethods.convertToJson(object: result){
                            let jsonDecoder = JSONDecoder()
                            if let aData = try? jsonDecoder.decode(AccountModel.self, from: data){
                                self.arrTransaction = aData.transcations ?? [transactionModel]()
                                self.lblTotalAmount.text = String.init(format: "%.2f", aData.balance ?? 0)
                                self.lblClosingBalance.setLabelAttributedText(title: "Closing balance", value: String.init(format: "%.2f", aData.balance ?? 0), fontSize: AppConstants.DeviceType.IS_IPAD ? 17 : 15)
                                self.lblAccountNo.setLabelAttributedText(title: "Account no", value: aData.accountNo ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 17 : 15)
                                self.lblContactNo.setLabelAttributedText(title: "Contact no", value: aData.cellphone ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 17 : 15)
                                if AppConstants.userData != nil{
                                    self.lblCustomerName.setLabelAttributedText(title: "Customer name", value: aData.name ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 17 : 15)
                                }else{
                                    self.lblCustomerName.setLabelAttributedText(title: "Employee name", value: aData.name ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 17 : 15)
                                }
                                self.tblAccount.reloadData()
                                return
                            }
                        }
                    }else{
                        aMessage = response!.getStringValue("ack_msg") ?? ""
                    }
                }
                self.tblAccount.reloadData()
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: aMessage, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
            }
        }
    }
    
    func downloadAccountPDFAPI(){
        var param = [String:String]()
        param["key"] = AppConstants.commonConstant.kAPIKey
        
        if AppConstants.userData != nil{
            param["s"] = "25"
            param["cuid"] = "\(AppConstants.userData?.id ?? 0)"
            param["aid"] = "\(AppConstants.selectedBranch?.aid ?? 0)"
        }else{
            param["s"] = "77"
            param["emp_id"] = "\(AppConstants.employeeData?.id ?? 0)"
        }
        param["from_date"] = strFromDate
        param["to_date"] = strToDate
        //https://manager.globalfoodsltd.co.uk/rms/service/service_employee.php?key=1226&s=77&emp_id=1
        if AppConstants.isInDevlopmentMode{
            print("Accounts Param:",param)
        }
        
        AppCommonMethods.startProgressBar()
        WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: (AppConstants.userData != nil) ? AppConstants.APIURLs.kServiceCustomerURL : AppConstants.APIURLs.kServiceEmployeeURL) { (message, response) in
            DispatchQueue.main.async {
                var aMessage = message
                AppCommonMethods.stopProgressBar()
                if response != nil{
                    if AppConstants.isInDevlopmentMode{
                        print("Accounts Data:",response!)
                    }
                    if let result = response!["result"] as? NSDictionary, response!.getIntValue("ack") ?? 0 == 1{
                        if let VC = WebViewController.instance(){
                            VC.strURL = result.getStringValue("pdf") ?? ""
                            self.navigationController?.pushViewController(VC, animated: true)
                        }
                        return
                    }else{
                        aMessage = response!.getStringValue("ack_msg") ?? ""
                    }
                }
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: aMessage, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
            }
        }
    }
}

extension AccountVC:UITableViewDataSource,UITableViewDelegate{
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return arrTransaction.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "AccountViewCell", for: indexPath) as! AccountViewCell
        let model = arrTransaction[indexPath.row]
        cell.lblRefNo.text = "Reference No: #\(model.refenrenceId ?? "")"
        var strType = ""
        if model.type ?? "" == "credit"{
            cell.lblCreditAmt.text = String.init(format: "%@%.2f", AppConstants.currencySign, model.credit ?? 0)
            strType = "Credited on"
        }else{
            cell.lblCreditAmt.text = String.init(format: "%@%.2f", AppConstants.currencySign, model.debit ?? 0)
            strType = "Debited on"
        }
        
        if let date = model.date?.getDateFromString(format: "dd-MM-yyyy"){
            let strDesc = "\(strType): \(date.getDateInString(format: "dd'\(date.getDateSuffix())' MMM, yyyy"))"
            let attrDesc = NSMutableAttributedString.init(string: strDesc, attributes: [NSAttributedString.Key.foregroundColor : AppConstants.Colors.kAppGrayThemeColor,NSAttributedString.Key.font:AppConstants.GlobalFontConstants.kRegularFont(size: AppConstants.DeviceType.IS_IPAD ? 16 : 14)])
            attrDesc.addFontAttribute(title: strType, fontSize: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
            cell.lblDate.attributedText = attrDesc
        }
        return cell
    }
}

extension AccountVC:dateRangeDelegate{
    func userselectedDate(toDate: String, fromDate: String) {
        strToDate = toDate
        strFromDate = fromDate
        callGetAccountAPI()
    }
}

extension AccountVC:customerSelctionDelegate{
    func customerSelected(customerData: UserModel?, branchData: branchModel?,customerName:String?) {
        if branchData?.id ?? 0 == self.selectedBranch?.id ?? 0 && customerData?.id ?? 0 == selectedCustomer?.id ?? 0{
            return
        }
        self.selectedBranch = branchData
        self.selectedCustomer = customerData
        callGetAccountAPI()
        
    }
}
