//
//  CreateOrderVC.swift
//  globalfoods
//
//  Created by Apple on 29/12/20.
//

import UIKit
import SDWebImage

class ProductHeaderCell: UITableViewCell {
    
    @IBOutlet weak var lblTitle:UILabel!
    @IBOutlet weak var btnExpand:UIButton!
    @IBOutlet weak var imgSelect:UIImageView!
    
    override class func awakeFromNib() {
        
    }
}

class ProductViewCell: UITableViewCell {
    
    @IBOutlet weak var lblProductName:UILabel!
    @IBOutlet weak var txtProductQty:UITextField!
    @IBOutlet weak var txtProductPrice:UITextField!
    @IBOutlet weak var lblProductPrice:UILabel!
    @IBOutlet weak var lblCategory:UILabel!
    @IBOutlet weak var btnIncrement:UIButton!
    @IBOutlet weak var btnDecrement:UIButton!
    @IBOutlet weak var btnAdd:UIButton!
    @IBOutlet weak var viewForQty:UIView!
    @IBOutlet weak var lblOutOfStock:UILabel!
    @IBOutlet weak var imgProduct:UIImageView!
    
    override class func awakeFromNib() {
        
    }
}

class ProductCategoryCell: UICollectionViewCell {
    
    @IBOutlet weak var lblCategoryName:UILabel!
    @IBOutlet weak var viewForBG:UIViewX!
    
    override class func awakeFromNib() {
        
    }
}

class CreateOrderVC: UIViewController {
    
    @IBOutlet weak var txtSearch:UITextField!
    @IBOutlet weak var tblProducts:UITableView!
    @IBOutlet weak var btnCheckout:UIButton!
    @IBOutlet weak var lblCustomerInfo:UILabel!
    @IBOutlet weak var viewForCustomer:UIView!
    @IBOutlet weak var viewForSelectCustomer:UIView!
    @IBOutlet weak var collectionCategory:UICollectionView!
    
    var customHeaderView:HeaderView?
    var arrProducts = [ProductsModel]()
    var arrCategoryProducts = [ProductCategoryModel]()
    var userCart:UserCartModel?
    var totalAPI = 3
    var apiCount = 0
    var refreshControl = UIRefreshControl()
    var isSearchEnabled = false
    var isAPICalling = false
    var selectedCategory:ProductCategoryModel?
    var lastTblIndex:Int?
    var selectedCustomer:UserModel?
    var selectedBranch:branchModel?
    var isBackEnabled = false
    var isSalesOrder = false
    var popRecognizer: InteractivePopRecognizer?
    var customerName = ""
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        // Do any additional setup after loading the view.
        setHeaderView()
        if AppConstants.employeeData != nil{
            totalAPI = 2
        }
        refreshControl.addTarget(self, action: #selector(didPullToRefresh), for: .valueChanged)
        self.tblProducts.addSubview(refreshControl)
        if isBackEnabled{
            setInteractiveRecognizer()
        }
    }
    
    override func viewWillAppear(_ animated: Bool) {
        txtSearch.text = ""
        isSearchEnabled = false
        viewForSelectCustomer.isHidden = true
        if AppConstants.employeeData != nil{
            if isSalesOrder{
                if customerName == ""{
                    if let VC = SelectCustomerVC.showPopup(parentVC: self, branchData: selectedBranch, customerData: selectedCustomer, isSalesOrder: isSalesOrder){
                        VC.delegate = self
                    }
                    viewForSelectCustomer.isHidden = false
                    return
                }
            }else{
                if selectedCustomer == nil{
                    if let VC = SelectCustomerVC.showPopup(parentVC: self, branchData: selectedBranch, customerData: selectedCustomer, isSalesOrder: isSalesOrder){
                        VC.delegate = self
                    }
                    viewForSelectCustomer.isHidden = false
                    return
                }
            }
            setProducts()
            checkForCart()
            tblProducts.reloadData()
        }else{
            viewForCustomer.isHidden = true
            if AppConstants.isBranchChanged{
                didPullToRefresh()
                AppConstants.isBranchChanged = false
            }else{
                if arrProducts.count == 0{
                    apiCount = 0
                    callGetCategoryAPI()
                    callGetProductAPI()
                    callGetCartAPI(isFromLoad: true)
                }else{
                    callGetCartAPI(isFromLoad: false)
                }
            }
        }
    }
    
    //MARK: Create Viewcontrlloer instance
    static func instance()->CreateOrderVC?{
        return UIStoryboard.init(name: "SideMenu", bundle: nil).instantiateViewController(withIdentifier: "CreateOrderVC") as? CreateOrderVC
    }
    
    //MARK: General methods
    func setHeaderView(){
        if customHeaderView != nil{
            customHeaderView!.removeFromSuperview()
            customHeaderView = nil
        }
        customHeaderView = HeaderView.init(controller: self, title: isSalesOrder ? "Create Sales Order" :"Create Order", isBackEnbaled: isBackEnabled)
    }
    
    private func setInteractiveRecognizer() {
        guard let controller = navigationController else { return }
        popRecognizer = InteractivePopRecognizer(controller: controller)
        controller.interactivePopGestureRecognizer?.delegate = popRecognizer
    }
    
    @objc func didPullToRefresh(){
        apiCount = 0
        if AppConstants.employeeData == nil{
            callGetProductAPI()
            callGetCategoryAPI()
            callGetCartAPI(isFromLoad: true)
        }else{
            if isSalesOrder{
                if customerName != ""{
                    callGetProductAPI()
                    callGetCategoryAPI()
                }else{
                    self.refreshControl.endRefreshing()
                }
            }else{
                if selectedBranch != nil{
                    callGetProductAPI()
                    callGetCategoryAPI()
                }else{
                    self.refreshControl.endRefreshing()
                }
            }
        }
    }
    
    func checkForCart(){
        if (AppConstants.employeeData != nil ? AppConstants.employeeCart : userCart) == nil{
            btnCheckout.isEnabled = false
            btnCheckout.superview?.backgroundColor = AppConstants.Colors.kAppLightGrayColor
        }else{
            var arrCart = [CartItemsModel]()
            for category in arrCategoryProducts{
                let arr = category.arrPrducts.filter { (model) -> Bool in
                    return model.isAddedInCart
                }
                for model in arr{
                    let cart = CartItemsModel()
                    cart.itemQty = model.selectedQty
                    cart.itemName = model.itemName
                    cart.itemId = model.id
                    cart.itemPrice = model.itemPrice
                    cart.image = model.image
                    cart.categoryName = model.categoryName
                    cart.stockQty = model.stockQty
                    cart.itemTotalPrice = (model.selectedQty * (model.itemPrice ?? 0))
                    arrCart.append(cart)
                }
            }
            (AppConstants.employeeData != nil ? AppConstants.employeeCart : userCart)?.cartitems = arrCart
            if AppConstants.employeeData != nil{
                NotificationCenter.default.post(name: AppConstants.notifications.kUserCartChanged, object: nil, userInfo: ["userCartCount":AppConstants.employeeCart?.cartitems?.count ?? 0])
            }else{
                NotificationCenter.default.post(name: AppConstants.notifications.kUserCartChanged, object: nil, userInfo: ["userCartCount":userCart?.cartitems?.count ?? 0])
            }
            
            if arrCart.count == 0{
                btnCheckout.isEnabled = false
                btnCheckout.superview?.backgroundColor = AppConstants.Colors.kAppLightGrayColor
            }else{
                btnCheckout.isEnabled = true
                btnCheckout.superview?.backgroundColor = AppConstants.Colors.kAppMainThemeColor
            }
        }
    }
    
    @IBAction func btnChangeCustomerAction(_ sender:UIButton){
        self.view.endEditing(true)
        if let VC = SelectCustomerVC.showPopup(parentVC: self, branchData: selectedBranch, customerData: selectedCustomer, isSalesOrder: isSalesOrder, customerName: customerName){
            VC.delegate = self
        }
    }
    
    @IBAction func btnIncrementAction(_ sender:UIButton){
        self.view.endEditing(true)
        let item = isSearchEnabled ? arrCategoryProducts[Int(sender.accessibilityIdentifier ?? "") ?? 0].arrSearchPrducts[sender.tag] : arrCategoryProducts[Int(sender.accessibilityIdentifier ?? "") ?? 0].arrPrducts[sender.tag]
        var quantity = item.selectedQty
        if quantity == 0.5{
            quantity = 1
        }else if quantity < item.stockQty ?? 0{
            quantity += 1
        }else{
            return
        }
        callAddCartAPI(row: sender.tag, section: Int(sender.accessibilityIdentifier ?? "") ?? 0, quantity: quantity)
    }
    
    @IBAction func btnDecrementAction(_ sender:UIButton){
        self.view.endEditing(true)
        let item = isSearchEnabled ? arrCategoryProducts[Int(sender.accessibilityIdentifier ?? "") ?? 0].arrSearchPrducts[sender.tag] : arrCategoryProducts[Int(sender.accessibilityIdentifier ?? "") ?? 0].arrPrducts[sender.tag]
        var quantity = item.selectedQty
        if quantity == 1.0{
            quantity = 0.5
        }else if quantity > 1.0{
            quantity -= 1
        }else{
            callRemoveCartAPI(row: sender.tag, section: Int(sender.accessibilityIdentifier ?? "") ?? 0)
            return
        }
        callAddCartAPI(row: sender.tag, section: Int(sender.accessibilityIdentifier ?? "") ?? 0, quantity: quantity)
    }
    
    @IBAction func btnConfirmAction(_ sender:UIButton){
        self.view.endEditing(true)
        if let VC = UserCartVC.instance(){
            VC.delegate = self
            VC.isSalesOrder = isSalesOrder
            VC.customerName = customerName
            VC.cuid = selectedCustomer?.id
            VC.cbid = selectedBranch?.id
            self.navigationController?.pushViewController(VC, animated: true)
        }
    }
    
    @IBAction func btnExpandAction(_ sender:UIButton){
        self.view.endEditing(true)
        let model = arrCategoryProducts[sender.tag]
        model.isExpanded = !model.isExpanded
        tblProducts.reloadData()
    }
    
    @IBAction func btnAddToCartAction(_ sender:UIButton){
        self.view.endEditing(true)
        callAddCartAPI(row: sender.tag, section: Int(sender.accessibilityIdentifier ?? "") ?? 0, quantity: 1)
    }
    
    @IBAction func txtSearchChanged(_ sender:UITextField){
        if sender.text == ""{
            isSearchEnabled = false
        }else{
            isSearchEnabled = true
            for category in arrCategoryProducts{
                category.arrSearchPrducts = category.arrPrducts.filter({ (model) -> Bool in
                    return (model.itemName ?? "").lowercased().contains(self.txtSearch.text!.lowercased())
                })
            }
        }
        tblProducts.reloadData()
    }
    
    func callRemoveCartAPI(row:Int,section:Int){
        let item = isSearchEnabled ? arrCategoryProducts[section].arrSearchPrducts[row] : arrCategoryProducts[section].arrPrducts[row]
        if AppConstants.employeeData != nil{
            item.selectedQty = 0
            item.isAddedInCart = false
            self.checkForCart()
            self.tblProducts.reloadData()
            return
        }
        var param = [String:String]()
        param["key"] = AppConstants.commonConstant.kAPIKey
        param["s"] = "36"
        if AppConstants.subCustomerData != nil{
            param["cuid"] = "\(AppConstants.subCustomerData?.cid ?? 0)"
            param["cbid"] = "\(AppConstants.subCustomerData?.cbid ?? 0)"
        }else{
            param["cuid"] = "\(AppConstants.userData?.id ?? 0)"
            param["cbid"] = "\(AppConstants.selectedBranch?.id ?? 0)"
        }
        param["ci_id"] = "\(item.cartId ?? 0)"
        param["cart_id"] = "\(userCart?.cartId ?? 0)"
        if AppConstants.isInDevlopmentMode{
            print("Remove cart param:",param)
        }
        AppCommonMethods.startProgressBar()
        WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: AppConstants.APIURLs.kServiceCartURL) { (message, response) in
            DispatchQueue.main.async {
                AppCommonMethods.stopProgressBar()
                var setting = BottomAlertSettings()
                setting.strMessage = message
                if response != nil{
                    if AppConstants.isInDevlopmentMode{
                        print("Remove cart Data:",response!)
                    }
                    self.callGetCartAPI(isFromLoad: false)
                    setting.strMessage = response!.getStringValue("ack_msg") ?? ""
                }
                AppValidation.shared.showBottomAlertView(settings: setting)
            }
        }
    }
    
    func callGetCartAPI(isFromLoad:Bool){
        if isAPICalling{
            return
        }
        isAPICalling = true
        var param = [String:String]()
        param["key"] = AppConstants.commonConstant.kAPIKey
        param["s"] = "39"
        if AppConstants.subCustomerData != nil{
            param["cuid"] = "\(AppConstants.subCustomerData?.cid ?? 0)"
            param["cbid"] = "\(AppConstants.subCustomerData?.cbid ?? 0)"
        }else{
            param["cuid"] = "\(AppConstants.userData?.id ?? 0)"
            param["cbid"] = "\(AppConstants.selectedBranch?.id ?? 0)"
        }
        AppCommonMethods.startProgressBar()
        WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: AppConstants.APIURLs.kServiceCartURL) { (message, response) in
            DispatchQueue.main.async {
                self.userCart = nil
                self.isAPICalling = false
                if response != nil{
                    if AppConstants.isInDevlopmentMode{
                        print("Cart Data:",response!)
                    }
                    if let result = response!["result"] as? NSDictionary, response!.getIntValue("ack") ?? 0 == 1{
                        if let data = AppCommonMethods.convertToJson(object: result){
                            let jsonDecoder = JSONDecoder()
                            if let aData = try? jsonDecoder.decode(UserCartModel.self, from: data){
                                self.userCart = aData
                                if !isFromLoad{
                                    AppCommonMethods.stopProgressBar()
                                    self.setProducts()
                                    self.checkForCart()
                                    self.tblProducts.reloadData()
                                }else{
                                    self.stopLoader()
                                }
                                return
                            }
                        }
                    }
                }
                if !isFromLoad{
                    AppCommonMethods.stopProgressBar()
                    self.setProducts()
                    self.checkForCart()
                    self.tblProducts.reloadData()
                }else{
                    self.stopLoader()
                }
            }
        }
    }
    
    func callGetCategoryAPI(){
        var param = [String:String]()
        param["key"] = AppConstants.commonConstant.kAPIKey
        param["s"] = "34"
        if !isSalesOrder{
            if AppConstants.subCustomerData != nil{
                param["cuid"] = "\(AppConstants.subCustomerData?.cid ?? 0)"
                param["cbid"] = "\(AppConstants.subCustomerData?.cbid ?? 0)"
            }else{
                if selectedBranch != nil{
                    param["cuid"] = "\(selectedCustomer?.id ?? 0)"
                    param["cbid"] = "\(selectedBranch?.id ?? 0)"
                }else{
                    param["cuid"] = "\(AppConstants.userData?.id ?? 0)"
                    param["cbid"] = "\(AppConstants.selectedBranch?.id ?? 0)"
                }
            }
        }
        param["type"] = "iOS"
        AppCommonMethods.startProgressBar()
        WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: AppConstants.APIURLs.kCreateOrderURL) { (message, response) in
            DispatchQueue.main.async {
                var aMessage = message
                self.arrCategoryProducts.removeAll()
                if response != nil{
                    print("category")
                    if AppConstants.isInDevlopmentMode{
                        print("Category Data:",response!)
                    }
                    if let result = response!["result"] as? [NSDictionary], response!.getIntValue("ack") ?? 0 == 1{
                        if let data = AppCommonMethods.convertToJson(object: result){
                            let jsonDecoder = JSONDecoder()
                            if let aData = try? jsonDecoder.decode([ProductCategoryModel].self, from: data){
                                self.arrCategoryProducts = aData
                                self.stopLoader()
                                return
                            }
                        }
                    }else{
                        aMessage = response!.getStringValue("ack_msg") ?? ""
                    }
                }
                self.stopLoader()
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: aMessage, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
            }
        }
    }
    
    func callGetProductAPI(){
        var param = [String:String]()
        param["key"] = AppConstants.commonConstant.kAPIKey
        if isSalesOrder{
            param["s"] = "127"
        }else{
            param["s"] = "8"
            if AppConstants.subCustomerData != nil{
                param["cuid"] = "\(AppConstants.subCustomerData?.cid ?? 0)"
                param["cbid"] = "\(AppConstants.subCustomerData?.cbid ?? 0)"
            }else{
                if selectedBranch != nil{
                    param["cuid"] = "\(selectedCustomer?.id ?? 0)"
                    param["cbid"] = "\(selectedBranch?.id ?? 0)"
                }else{
                    param["cuid"] = "\(AppConstants.userData?.id ?? 0)"
                    param["cbid"] = "\(AppConstants.selectedBranch?.id ?? 0)"
                }
            }
            param["type"] = "iOS"
        }
        
        AppCommonMethods.startProgressBar()
        WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: AppConstants.APIURLs.kServiceCustomerURL) { (message, response) in
            DispatchQueue.main.async {
                var aMessage = message
                if response != nil{
                    print("product")
                    if AppConstants.isInDevlopmentMode{
                        print("Product Data:",response!)
                    }
                    if let result = response!["result"] as? [NSDictionary], response!.getIntValue("ack") ?? 0 == 1{
                        if let data = AppCommonMethods.convertToJson(object: result){
                            let jsonDecoder = JSONDecoder()
                            if let aData = try? jsonDecoder.decode([ProductsModel].self, from: data){
                                self.arrProducts = aData
                                self.stopLoader()
                                return
                            }
                        }
                    }else{
                        aMessage = response!.getStringValue("ack_msg") ?? ""
                    }
                }
                self.stopLoader()
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: aMessage, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
            }
        }
    }
    
    func callAddCartAPI(row:Int,section:Int,quantity:Double){
        let item = isSearchEnabled ? arrCategoryProducts[section].arrSearchPrducts[row] : arrCategoryProducts[section].arrPrducts[row]
        if AppConstants.employeeData != nil{
            if AppConstants.employeeCart == nil{
                AppConstants.employeeCart = UserCartModel.init()
            }
            item.selectedQty = quantity
            item.isAddedInCart = true
            self.tblProducts.reloadData()
            self.checkForCart()
            return
        }
        var param = [String:String]()
        param["key"] = AppConstants.commonConstant.kAPIKey
        param["s"] = "35"
        if AppConstants.subCustomerData != nil{
            param["cuid"] = "\(AppConstants.subCustomerData?.cid ?? 0)"
            param["cbid"] = "\(AppConstants.subCustomerData?.cbid ?? 0)"
        }else{
            param["cuid"] = "\(AppConstants.userData?.id ?? 0)"
            param["cbid"] = "\(AppConstants.selectedBranch?.id ?? 0)"
        }
        param["qty"] = "\(quantity)"
        param["pid"] = "\(item.id ?? 0)"
        AppCommonMethods.startProgressBar()
        WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: AppConstants.APIURLs.kServiceCartURL) { (message, response) in
            DispatchQueue.main.async {
                AppCommonMethods.stopProgressBar()
                if response != nil{
                    if AppConstants.isInDevlopmentMode{
                        print("Add cart Data:",response!)
                    }
                    if response!.getIntValue("ack") ?? 0 == 1{
                        if self.userCart == nil{
                            self.userCart = UserCartModel.init()
                        }
                        self.userCart?.cartId = response!.getIntValue("cart_id") ?? 0
                        item.cartId = response!.getIntValue("id") ?? 0
                        item.selectedQty = quantity
                        item.isAddedInCart = true
                        self.tblProducts.reloadData()
                        self.checkForCart()
                    }
                }
            }
        }
    }
    
    
    func stopLoader(){
        apiCount += 1
        if apiCount == totalAPI{
            self.refreshControl.endRefreshing()
            AppCommonMethods.stopProgressBar()
            self.setProducts()
            self.checkForCart()
            self.tblProducts.reloadData()
            self.collectionCategory.reloadData()
        }
    }
    
    func setProducts(){
        var arrC = [ProductCategoryModel]()
        for i in 0..<arrCategoryProducts.count{
            let category = arrCategoryProducts[i]
            let arrP = arrProducts.filter { (model) -> Bool in
                return model.categoryId ?? 0 == category.categoryId ?? 0
            }
            if arrP.count != 0{
                for j in 0..<arrP.count{
                    arrP[j].isAddedInCart = false
                    arrP[j].selectedQty = 0
                    if AppConstants.employeeData != nil{
                        if AppConstants.employeeCart != nil && AppConstants.employeeCart?.cartitems?.count ?? 0 > 0{
                            let index = AppConstants.employeeCart!.cartitems!.firstIndex { (model) -> Bool in
                                return model.itemId ?? 0 == arrP[j].id ?? 0
                            }
                            if index != nil{
                                arrP[j].isAddedInCart = true
                                arrP[j].selectedQty = AppConstants.employeeCart!.cartitems![index!].itemQty ?? 0
                                arrP[j].cartId = AppConstants.employeeCart!.cartitems![index!].id ?? 0
                            }
                        }
                    }else{
                        if userCart != nil && userCart?.cartitems?.count ?? 0 != 0{
                            let index = userCart!.cartitems!.firstIndex { (model) -> Bool in
                                return model.itemId ?? 0 == arrP[j].id ?? 0
                            }
                            if index != nil{
                                arrP[j].isAddedInCart = true
                                arrP[j].selectedQty = userCart!.cartitems![index!].itemQty ?? 0
                                arrP[j].cartId = userCart!.cartitems![index!].id ?? 0
                            }
                        }
                    }
                }
                category.arrPrducts = arrP
                arrC.append(category)
            }
        }
        selectedCategory = arrC.first
        arrCategoryProducts = arrC
    }
}

extension CreateOrderVC:UITableViewDataSource,UITableViewDelegate{
    func tableView(_ tableView: UITableView, willDisplay cell: UITableViewCell, forRowAt indexPath: IndexPath) {
        if self.lastTblIndex != nil{
            if self.lastTblIndex == indexPath.section{
                return
            }
        }
        self.lastTblIndex = indexPath.section
        self.selectedCategory = self.arrCategoryProducts[indexPath.section]
        UIView.setAnimationsEnabled(false)
        self.collectionCategory.reloadItems(at: self.collectionCategory.indexPathsForVisibleItems)
        UIView.setAnimationsEnabled(true)
        self.collectionCategory.scrollToItem(at: IndexPath.init(row: indexPath.section, section: 0), at: .centeredHorizontally, animated: false)
    }
    
    func numberOfSections(in tableView: UITableView) -> Int {
        return arrCategoryProducts.count
    }
    
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        return (arrCategoryProducts[section].arrPrducts.count == 0) ? 0 : 35
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return AppConstants.DeviceType.IS_IPAD ? 107 : 95
    }
    
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        let cell = tableView.dequeueReusableCell(withIdentifier: "ProductHeaderCell") as! ProductHeaderCell
        let model = arrCategoryProducts[section]
        cell.lblTitle.text = model.categoryName ?? ""
        if model.isExpanded{
            cell.imgSelect.image = UIImage.init(named: "next_arrow")
        }else{
            cell.imgSelect.image = UIImage.init(named: "down_arrow")
        }
        cell.btnExpand.tag = section
        return cell
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        let model = arrCategoryProducts[section]
        return model.isExpanded ? 0 : (isSearchEnabled ? model.arrSearchPrducts.count : model.arrPrducts.count)
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "ProductViewCell", for: indexPath) as! ProductViewCell
        let model = isSearchEnabled ? arrCategoryProducts[indexPath.section].arrSearchPrducts[indexPath.row] : arrCategoryProducts[indexPath.section].arrPrducts[indexPath.row]
        cell.lblProductName.text = model.itemName ?? ""
        cell.txtProductQty.tag = indexPath.row
        cell.txtProductQty.accessibilityIdentifier = "\(indexPath.section)"
        cell.txtProductQty.text = String.init(format: "%.1f", model.selectedQty)
        cell.lblProductPrice.isHidden = true
        if isSalesOrder{
            cell.txtProductPrice.superview?.isHidden = false
            cell.txtProductPrice.tag = indexPath.row
            cell.txtProductPrice.accessibilityIdentifier = "\(indexPath.section)"
            cell.txtProductPrice.superview?.tag = 101
            cell.txtProductPrice.text = String.init(format: "%@%.2f", AppConstants.currencySign,model.itemPrice ?? 0)
        }else{
            cell.txtProductPrice.superview?.isHidden = true
            if let data = AppConstants.userData{
                if data.showPrice ?? 0 == 1{
                    cell.lblProductPrice.isHidden = false
                    cell.lblProductPrice.text = String.init(format: "%@%.2f", AppConstants.currencySign,model.itemPrice ?? 0)
                }
            }else{
                cell.lblProductPrice.isHidden = false
                cell.lblProductPrice.text = String.init(format: "%@%.2f", AppConstants.currencySign,model.itemPrice ?? 0)
            }
        }
        if model.stockQty ?? 0 == 0{
            cell.btnAdd.isHidden = true
            cell.viewForQty.isHidden = true
            cell.lblOutOfStock.isHidden = false
        }else{
            cell.lblOutOfStock.isHidden = true
            if model.isAddedInCart{
                cell.btnAdd.isHidden = true
                cell.viewForQty.isHidden = false
            }else{
                cell.btnAdd.isHidden = false
                cell.viewForQty.isHidden = true
            }
        }
        cell.btnAdd.tag = indexPath.row
        cell.btnIncrement.tag = indexPath.row
        cell.btnDecrement.tag = indexPath.row
        cell.btnAdd.accessibilityIdentifier = "\(indexPath.section)"
        cell.btnIncrement.accessibilityIdentifier = "\(indexPath.section)"
        cell.btnDecrement.accessibilityIdentifier = "\(indexPath.section)"
        cell.imgProduct.sd_setImage(with: URL(string: model.image ?? ""), placeholderImage:UIImage(named: "placeholder"), options: .avoidDecodeImage)
        return cell
    }
}

extension CreateOrderVC:UITextFieldDelegate{
    func textField(_ textField: UITextField, shouldChangeCharactersIn range: NSRange, replacementString string: String) -> Bool {
        if textField.superview?.tag ?? 0 == 101{
            let allowedCharacters = CharacterSet(charactersIn:"0123456789")
            let characterSet = CharacterSet(charactersIn: string)
            if allowedCharacters.isSuperset(of: characterSet){
                var strText = (textField.text ?? "").replacingOccurrences(of: AppConstants.currencySign, with: "").replacingOccurrences(of: ".", with: "")
                if string == ""{
                    if strText != "000"{
                        if strText.count == 3{
                            strText.removeLast()
                            strText = "0\(strText)"
                        }else{
                            strText.removeLast()
                        }
                        strText.insert(".", at: strText.index(strText.endIndex, offsetBy: -2))
                        textField.text = "\(AppConstants.currencySign)\(strText)"
                    }
                }else{
                    if strText.first! == "0"{
                        strText.removeFirst()
                        strText = "\(strText)\(string)"
                    }else{
                        strText = "\(strText)\(string)"
                    }
                    strText.insert(".", at: strText.index(strText.endIndex, offsetBy: -2))
                    textField.text = "\(AppConstants.currencySign)\(strText)"
                }
            }
            return false
        }else{
            let allowedCharacters = CharacterSet(charactersIn:"0123456789.")
            let characterSet = CharacterSet(charactersIn: string)
            return allowedCharacters.isSuperset(of: characterSet)
        }
    }
    
    func textFieldDidEndEditing(_ textField: UITextField) {
        let item = isSearchEnabled ? arrCategoryProducts[Int(textField.accessibilityIdentifier ?? "") ?? 0].arrSearchPrducts[textField.tag] : arrCategoryProducts[Int(textField.accessibilityIdentifier ?? "") ?? 0].arrPrducts[textField.tag]
        if textField.superview?.tag ?? 0 == 101{
            let price = Double((textField.text ?? "").replacingOccurrences(of: AppConstants.currencySign, with: "")) ?? 0
            if price == 0{
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: AppConstants.GlobalAlert.ALERT_AMOUNT_ZERO, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
                if let cell = tblProducts.cellForRow(at: IndexPath.init(row: textField.tag, section: Int(textField.accessibilityIdentifier ?? "") ?? 0)) as? ProductViewCell{
                    cell.txtProductPrice.text = String.init(format: "%@%.2f", AppConstants.currencySign, item.itemPrice ?? 0)
                }
                return
            }
            item.itemPrice = price
            let index = AppConstants.employeeCart?.cartitems?.firstIndex(where: { model in
                return model.itemId ?? 0 == item.id ?? 0
            })
            if index != nil{
                AppConstants.employeeCart!.cartitems![index!].itemPrice = price
            }
        }else{
            let qty = Double(textField.text ?? "") ?? 0
            if qty == 0{
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: AppConstants.GlobalAlert.ALERT_ITEM_NOT_ZERO, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
                if let cell = tblProducts.cellForRow(at: IndexPath.init(row: textField.tag, section: Int(textField.accessibilityIdentifier ?? "") ?? 0)) as? ProductViewCell{
                    cell.txtProductQty.text = String.init(format: "%.1f", item.selectedQty)
                }
                return
            }else if qty > item.stockQty ?? 0{
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: String.init(format: "Selected item has %.1f quantity in stock, Please enter below stock quantity to proceed", item.stockQty ?? 0), withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
                if let cell = tblProducts.cellForRow(at: IndexPath.init(row: textField.tag, section: Int(textField.accessibilityIdentifier ?? "") ?? 0)) as? ProductViewCell{
                    cell.txtProductQty.text = String.init(format: "%.1f", item.selectedQty)
                }
                return
            }
            self.callAddCartAPI(row: textField.tag, section: Int(textField.accessibilityIdentifier ?? "") ?? 0, quantity: qty)
        }
    }
}

extension CreateOrderVC:CheckoutDelegate{
    func userPlacedOrder() {
        userCart = nil
        checkForCart()
        setProducts()
        self.tblProducts.reloadData()
    }
    
    func userChangePrice(item:CartItemsModel){
        let index = arrProducts.firstIndex { model in
            model.id ?? 0 == item.itemId ?? 0
        }
        if index != nil{
            arrProducts[index!].itemPrice = item.itemPrice ?? 0
        }
        self.tblProducts.reloadData()
        
    }
}

extension CreateOrderVC:UICollectionViewDataSource,UICollectionViewDelegate{
    func collectionView(_ collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return arrCategoryProducts.count
    }
    
    func collectionView(_ collectionView: UICollectionView, cellForItemAt indexPath: IndexPath) -> UICollectionViewCell {
        let cell = collectionView.dequeueReusableCell(withReuseIdentifier: "ProductCategoryCell", for: indexPath) as! ProductCategoryCell
        cell.lblCategoryName.text = arrCategoryProducts[indexPath.row].categoryName ?? ""
        cell.viewForBG.backgroundColor = .white
        cell.lblCategoryName.textColor = AppConstants.Colors.kAppThemeTextColor
        if selectedCategory != nil{
            if selectedCategory!.categoryId ?? 0 == arrCategoryProducts[indexPath.row].categoryId ?? 0{
                cell.viewForBG.backgroundColor = AppConstants.Colors.kAppDarkThemeColor
                cell.lblCategoryName.textColor = .white
            }
        }
        return cell
    }
    
    func collectionView(_ collectionView: UICollectionView, didSelectItemAt indexPath: IndexPath) {
        self.view.endEditing(true)
        isSearchEnabled = false
        txtSearch.text = ""
        tblProducts.reloadData()
        selectedCategory = arrCategoryProducts[indexPath.row]
        collectionView.reloadData()
        tblProducts.scrollToRow(at: IndexPath.init(row: 0, section: indexPath.row), at: .top, animated: true)
    }
}

extension CreateOrderVC:customerSelctionDelegate{
    func customerSelected(customerData: UserModel?, branchData: branchModel?,customerName:String?) {
        if branchData?.id ?? 0 == self.selectedBranch?.id ?? 0 && customerData?.id ?? 0 == selectedCustomer?.id ?? 0 && !isSalesOrder{
            return
        }
        if customerName ?? "" == self.customerName && isSalesOrder{
            return
        }
        AppConstants.employeeCart = nil
        var strCustomer = ""
        if isSalesOrder{
            strCustomer = "Customer name: \(customerName ?? "")"
        }else{
            strCustomer = "Customer name: \(customerData?.name ?? "")\nBranch name: \(branchData?.name ?? "")"
        }
        self.customerName = customerName ?? ""
        self.selectedBranch = branchData
        self.selectedCustomer = customerData
        self.viewForCustomer.isHidden = false
        let attrCustomer = NSMutableAttributedString.init(string: strCustomer, attributes: [NSAttributedString.Key.foregroundColor : AppConstants.Colors.kAppGrayThemeColor,NSAttributedString.Key.font:AppConstants.GlobalFontConstants.kRegularFont(size: AppConstants.DeviceType.IS_IPAD ? 17 : 15)])
        attrCustomer.addFontAttribute(title: "Branch name", fontSize: AppConstants.DeviceType.IS_IPAD ? 17 : 15)
        attrCustomer.addFontAttribute(title: "Customer name", fontSize: AppConstants.DeviceType.IS_IPAD ? 17 : 15)
        lblCustomerInfo.attributedText = attrCustomer
        apiCount = 0
        callGetProductAPI()
        callGetCategoryAPI()
        viewForSelectCustomer.isHidden = true
        
    }
}
