//
//  CreateNoteVC.swift
//  globalfoods
//
//  Created by Apple on 29/12/20.
//

import UIKit
import ActionSheetPicker_3_0

class CreateNoteViewCell: UITableViewCell {
    
    @IBOutlet weak var lblCustomerName:UILabel!
    @IBOutlet weak var btnDownload:UIButton!
    @IBOutlet weak var lblDescription:UILabel!
    @IBOutlet weak var lblTotalPrice:UILabel!
    @IBOutlet weak var lblCreditAmount:UILabel!
    
    override class func awakeFromNib() {
        
    }
}

class CreditNoteVC: UIViewController {
    
    @IBOutlet weak var lblFromDate:UILabel!
    @IBOutlet weak var lblToDate:UILabel!
    @IBOutlet weak var tblCreditNote:UITableView!
    @IBOutlet weak var btnAddNote:UIButton!
    
    var customHeaderView:HeaderView?
    var strToDate = ""
    var strFromDate = ""
    var arrCreditNote = [CreditNoteModel]()
    var isBackEnabled = false
    var popRecognizer: InteractivePopRecognizer?
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
        
        self.strFromDate = Date().addingTimeInterval(-7*24*60*60).getDateInString(format: "dd-MM-yyyy")
        self.strToDate = Date().getDateInString(format: "dd-MM-yyyy")
        self.lblFromDate.text = "From - \(Date().addingTimeInterval(-7*24*60*60).getDateInString(format: "dd/MM/yyyy"))"
        self.lblToDate.text = "To - \(Date().getDateInString(format: "dd/MM/yyyy"))"
        if isBackEnabled{
            setInteractiveRecognizer()
        }
    }
    
    override func viewWillAppear(_ animated: Bool) {
        if AppConstants.userData == nil{
            if AppConstants.employeeData?.rights?.creditNote?.insert ?? 0 == 1{
                btnAddNote.superview?.isHidden = false
            }else{
                btnAddNote.superview?.isHidden = true
            }
        }else{
            btnAddNote.superview?.isHidden = true
        }
        setHeaderView()
        callGetCreditNoteAPI()
    }
    
    //MARK: Create Viewcontrlloer instance
    static func instance()->CreditNoteVC?{
        return UIStoryboard.init(name: "SideMenu", bundle: nil).instantiateViewController(withIdentifier: "CreditNoteVC") as? CreditNoteVC
    }
    
    //MARK: General methods
    func setHeaderView(){
        if customHeaderView != nil{
            customHeaderView!.removeFromSuperview()
            customHeaderView = nil
        }
        customHeaderView = HeaderView.init(controller: self, title: "Credit Note", isBackEnbaled: isBackEnabled)
    }
    
    private func setInteractiveRecognizer() {
        guard let controller = navigationController else { return }
        popRecognizer = InteractivePopRecognizer(controller: controller)
        controller.interactivePopGestureRecognizer?.delegate = popRecognizer
    }
    
    func checkPDFExist(id:Int)->Bool{
        let fileName = "CreditNote_\(id).pdf"
        let documentsUrl =  FileManager.default.urls(for: .documentDirectory, in: .userDomainMask).first!
        let destinationFileUrl = documentsUrl.appendingPathComponent("\(fileName)")
        return FileManager.default.fileExists(atPath: destinationFileUrl.path)
    }
    
    func downloadPDFFile(id:Int,path:String){
        let fileName = "CreditNote_\(id).pdf"
        let documentsUrl =  FileManager.default.urls(for: .documentDirectory, in: .userDomainMask).first!
        let destinationFileUrl = documentsUrl.appendingPathComponent("\(fileName)")
        
        if let fileURL = URL(string: path){
            AppCommonMethods.startProgressBar()
            DispatchQueue.global().async {
                do{
                    let data = try Data.init(contentsOf: fileURL)
                    try data.write(to: destinationFileUrl)
                    DispatchQueue.main.async {
                        AppCommonMethods.stopProgressBar()
                        if let VC = WebViewController.instance(){
                            VC.strURL = destinationFileUrl.absoluteString
                            self.navigationController?.pushViewController(VC, animated: true)
                        }
                    }
                }catch (let err) {
                    DispatchQueue.main.async {
                        AppCommonMethods.stopProgressBar()
                    }
                    print("error: \(err)")
                }
            }
        }
    }
    
    //MARK: Button Actions
    @IBAction func btnFromDateAction(_ sender:UIButton){
        let date = strFromDate.getDateFromString(format: "dd-MM-yyyy", locale: nil) ?? Date()
        let datePicker = ActionSheetDatePicker(title: "Select from date", datePickerMode: UIDatePicker.Mode.date, selectedDate: date, doneBlock: {
            picker, value, index in
            self.strFromDate = (value as! Date).getDateInString(format: "dd-MM-yyyy")
            self.lblFromDate.text = "From - \((value as! Date).getDateInString(format: "dd/MM/yyyy"))"
            self.callGetCreditNoteAPI()
        }, cancel: { ActionStringCancelBlock in return }, origin: sender)
        datePicker?.maximumDate = strToDate.getDateFromString(format: "dd-MM-yyyy", locale: nil) ?? Date()
        datePicker?.show()
    }
    
    @IBAction func btnToDateAction(_ sender:UIButton){
        let date = strToDate.getDateFromString(format: "dd-MM-yyyy", locale: nil) ?? Date()
        let datePicker = ActionSheetDatePicker(title: "Select to date", datePickerMode: UIDatePicker.Mode.date, selectedDate: date, doneBlock: {
            picker, value, index in
            self.strToDate = (value as! Date).getDateInString(format: "dd-MM-yyyy")
            self.lblToDate.text = "To - \((value as! Date).getDateInString(format: "dd/MM/yyyy"))"
            self.callGetCreditNoteAPI()
        }, cancel: { ActionStringCancelBlock in return }, origin: sender)
        if let fromDate = strFromDate.getDateFromString(format: "dd-MM-yyyy", locale: nil){
            datePicker?.minimumDate = fromDate
        }
        datePicker?.show()
    }
    
    @IBAction func btnDownloadAction(_ sender:UIButton){
        if sender.isSelected{
            if let VC = WebViewController.instance(){
                let fileName = "Invoices_\(arrCreditNote[sender.tag].id ?? 0).pdf"
                let documentsUrl =  FileManager.default.urls(for: .documentDirectory, in: .userDomainMask).first!
                let destinationFileUrl = documentsUrl.appendingPathComponent("\(fileName)")
                VC.strURL = destinationFileUrl.absoluteString
                self.navigationController?.pushViewController(VC, animated: true)
            }
        }else{
            downloadPDFFile(id: arrCreditNote[sender.tag].id ?? 0, path: arrCreditNote[sender.tag].path ?? "")
        }
    }
    
    @IBAction func btnCreateNoteAction(_ sender:UIButton){
        if let VC = CreateCreditNoteVC.instance(){
            self.navigationController?.pushViewController(VC, animated: true)
        }
    }
    
    func callGetCreditNoteAPI(){
        var param = [String:String]()
        param["key"] = AppConstants.commonConstant.kAPIKey
        var strURL = AppConstants.APIURLs.kServiceCustomerURL
        if AppConstants.userData == nil{
            param["s"] = "90"
            strURL = AppConstants.APIURLs.kServiceEmployeeURL
        }else{
            param["s"] = "56"
            param["cuid"] = "\(AppConstants.userData?.id ?? 0)"
            param["cbid"] = "\(AppConstants.selectedBranch?.id ?? 0)"
        }
        param["from_date"] = strFromDate
        param["to_date"] = strToDate
        
        AppCommonMethods.startProgressBar()
        WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: strURL) { (message, response) in
            DispatchQueue.main.async {
                var aMessage = message
                self.arrCreditNote.removeAll()
                AppCommonMethods.stopProgressBar()
                if response != nil{
                    if AppConstants.isInDevlopmentMode{
                        print("Credit Note Data:",response!)
                    }
                    if let result = response!["result"] as? [NSDictionary], response!.getIntValue("ack") ?? 0 == 1{
                        if let data = AppCommonMethods.convertToJson(object: result){
                            let jsonDecoder = JSONDecoder()
                            if let aData = try? jsonDecoder.decode([CreditNoteModel].self, from: data){
                                self.arrCreditNote = aData
                                self.tblCreditNote.reloadData()
                                return
                            }
                        }
                    }else{
                        aMessage = response!.getStringValue("ack_msg") ?? ""
                    }
                }
                self.tblCreditNote.reloadData()
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: aMessage, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
            }
        }
    }
}

extension CreditNoteVC:UITableViewDataSource,UITableViewDelegate{
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return arrCreditNote.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "CreateNoteViewCell", for: indexPath) as! CreateNoteViewCell
        let model = arrCreditNote[indexPath.row]
        cell.lblCustomerName.text = model.customerName ?? ""
        cell.lblTotalPrice.text = ""
        cell.lblCreditAmount.isHidden = true
        if let data = AppConstants.userData{
            if data.showPrice ?? 0 == 1{
                cell.lblCreditAmount.isHidden = false
                cell.lblTotalPrice.text = "\(model.creditAmount ?? 0)"
            }
        }else{
            cell.lblCreditAmount.isHidden = false
            cell.lblTotalPrice.text = "\(model.creditAmount ?? 0)"
        }
        if checkPDFExist(id: model.id ?? 0){
            cell.btnDownload.isSelected = true
        }else{
            cell.btnDownload.isSelected = false
        }
        cell.btnDownload.tag = indexPath.row
        if let noteDate = model.noteDate?.getDateFromString(format: "dd-MM-yyyy"){
            let strDesc = "Date: \(noteDate.getDateInString(format: "dd'\(noteDate.getDateSuffix())' MMM, yyyy"))\nStatus: \(model.statusSlug ?? "")"
            let attrDesc = NSMutableAttributedString.init(string: strDesc, attributes: [NSAttributedString.Key.foregroundColor : AppConstants.Colors.kAppGrayThemeColor,NSAttributedString.Key.font:AppConstants.GlobalFontConstants.kRegularFont(size: AppConstants.DeviceType.IS_IPAD ? 16 : 14)])
            attrDesc.addFontAttribute(title: "Date", fontSize: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
            attrDesc.addFontAttribute(title: "Status", fontSize: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
            cell.lblDescription.attributedText = attrDesc
        }
        return cell
    }
}
