//
//  DashboardVC.swift
//  globalfoods
//
//  Created by Apple on 29/12/20.
//

import UIKit
import SDWebImage

class DashbordViewCell: UITableViewCell {
    
    @IBOutlet weak var lblLeftProductName:UILabel!
    @IBOutlet weak var txtLeftProductQty:UITextField!
    @IBOutlet weak var lblLeftProductPrice:UILabel!
    @IBOutlet weak var lblLeftCategory:UILabel!
    @IBOutlet weak var btnLeftIncrement:UIButton!
    @IBOutlet weak var btnLeftDecrement:UIButton!
    @IBOutlet weak var btnLeftAdd:UIButton!
    @IBOutlet weak var viewForLeftQty:UIView!
    @IBOutlet weak var imgLeftProduct:UIImageView!
    
    @IBOutlet weak var lblRightProductName:UILabel!
    @IBOutlet weak var txtRightProductQty:UITextField!
    @IBOutlet weak var lblRightProductPrice:UILabel!
    @IBOutlet weak var lblRightCategory:UILabel!
    @IBOutlet weak var btnRightIncrement:UIButton!
    @IBOutlet weak var btnRightDecrement:UIButton!
    @IBOutlet weak var btnRightAdd:UIButton!
    @IBOutlet weak var viewForRightQty:UIView!
    @IBOutlet weak var imgRightProduct:UIImageView!
    
    override class func awakeFromNib() {
        
    }
}

class DashbordProductCell: UICollectionViewCell {
    
    @IBOutlet weak var lblProductName:UILabel!
    @IBOutlet weak var txtProductQty:UITextField!
    @IBOutlet weak var lblProductPrice:UILabel!
    @IBOutlet weak var lblCategory:UILabel!
    @IBOutlet weak var lblOutOfStock:UILabel!
    @IBOutlet weak var btnIncrement:UIButton!
    @IBOutlet weak var btnDecrement:UIButton!
    @IBOutlet weak var btnAdd:UIButton!
    @IBOutlet weak var viewForQty:UIView!
    @IBOutlet weak var imgProduct:UIImageView!
    
    override class func awakeFromNib() {
        
    }
}

class DashbordBannerCell: UICollectionViewCell {
    
    @IBOutlet weak var imgBanner:UIImageView!
    
    override class func awakeFromNib() {
        
    }
}


class DashboardVC: UIViewController {

    @IBOutlet weak var collectionBanner:UICollectionView!
    @IBOutlet weak var viewForOrders:UIView!
    @IBOutlet weak var constOrderHeight:NSLayoutConstraint!
    @IBOutlet weak var tblOrderHistory:UITableView!
    @IBOutlet weak var collectionTopProducts:UICollectionView!
    @IBOutlet weak var collectionNewProducts:UICollectionView!
    
    var userCart:UserCartModel?
    var totalAPI = 2
    var apiCount = 0
    var customHeaderView:HeaderView?
    var dashboardData:DashboardModel?
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
        collectionTopProducts.superview?.isHidden = true
        viewForOrders.isHidden = true
        collectionNewProducts.superview?.isHidden = true
        
    }
    
    override func viewWillAppear(_ animated: Bool) {
        setHeaderView()
        apiCount = 0
        callGetDashboardAPI()
        callGetCartAPI()
    }
    
    override func viewDidLayoutSubviews() {
        if dashboardData?.orders?.count ?? 0 != 0{
            DispatchQueue.main.asyncAfter(deadline: .now()+0.1) {
                self.constOrderHeight.constant = self.tblOrderHistory.contentSize.height
            }
        }
    }
    
    //MARK: Create Viewcontrlloer instance
    static func instance()->DashboardVC?{
        return UIStoryboard.init(name: "SideMenu", bundle: nil).instantiateViewController(withIdentifier: "DashboardVC") as? DashboardVC
    }
    
    //MARK: General methods
    func setHeaderView(){
        if customHeaderView != nil{
            customHeaderView!.removeFromSuperview()
            customHeaderView = nil
        }
        customHeaderView = HeaderView.init(controller: self, title: "Dashboard", isBackEnbaled: false)
    }
    
    @IBAction func btnTopProductAddAction(_ sender:UIButton){
        callAddCartAPI(row: sender.tag, quantity: 1, isNewOrder: false)
    }
    
    @IBAction func btnTopProductIncrementAction(_ sender:UIButton){
        let item = dashboardData!.topProduct![sender.tag]
        var quantity = item.selectedQty
        if quantity == 0.5{
            quantity = 1
        }else if quantity < item.stockQty ?? 0{
            quantity += 1
        }else{
            return
        }
        callAddCartAPI(row: sender.tag, quantity: quantity, isNewOrder: false)
    }
    
    @IBAction func btnTopProductDecrementAction(_ sender:UIButton){
        let item = dashboardData!.topProduct![sender.tag]
        var quantity = item.selectedQty
        if quantity == 1.0{
            quantity = 0.5
        }else if quantity > 1.0{
            quantity -= 1
        }else{
            callRemoveCartAPI(row: sender.tag, isNewOrder: false)
            return
        }
        callAddCartAPI(row: sender.tag, quantity: quantity, isNewOrder: false)
    }
    
    @IBAction func btnNewProductAddAction(_ sender:UIButton){
        callAddCartAPI(row: sender.tag, quantity: 1, isNewOrder: true)
    }
    
    @IBAction func btnNewProductIncrementAction(_ sender:UIButton){
        let item = dashboardData!.newProducts![sender.tag]
        var quantity = item.selectedQty
        if quantity == 0.5{
            quantity = 1
        }else if quantity < item.stockQty ?? 0{
            quantity += 1
        }else{
            return
        }
        callAddCartAPI(row: sender.tag, quantity: quantity, isNewOrder: true)
    }
    
    @IBAction func btnNewProductDecrementAction(_ sender:UIButton){
        let item = dashboardData!.newProducts![sender.tag]
        var quantity = item.selectedQty
        if quantity == 1.0{
            quantity = 0.5
        }else if quantity > 1.0{
            quantity -= 1
        }else{
            callRemoveCartAPI(row: sender.tag, isNewOrder: true)
            return
        }
        callAddCartAPI(row: sender.tag, quantity: quantity, isNewOrder: true)
    }
    
    @IBAction func btnViewAllAction(_ sender:UIButton){
        self.sideMenuController?.setContentViewController(with: "\(SideMenuCellType.kCreateOrder)")
    }
    
    @IBAction func btnViewAllOrderAction(_ sender:UIButton){
        self.sideMenuController?.setContentViewController(with: "\(SideMenuCellType.kOrderHistory)")
    }
    
    func callRemoveCartAPI(row:Int,isNewOrder:Bool){
        var param = [String:String]()
        let item = isNewOrder ? dashboardData!.newProducts![row] : dashboardData!.topProduct![row]
        
        param["key"] = AppConstants.commonConstant.kAPIKey
        param["s"] = "36"
        if AppConstants.subCustomerData != nil{
            param["cuid"] = "\(AppConstants.subCustomerData?.cid ?? 0)"
            param["cbid"] = "\(AppConstants.subCustomerData?.cbid ?? 0)"
        }else{
            param["cuid"] = "\(AppConstants.userData?.id ?? 0)"
            param["cbid"] = "\(AppConstants.selectedBranch?.id ?? 0)"
        }
        param["ci_id"] = "\(item.cartId ?? 0)"
        param["cart_id"] = "\(userCart?.cartId ?? 0)"
        if AppConstants.isInDevlopmentMode{
            print("Remove cart param:",param)
        }
        AppCommonMethods.startProgressBar()
        WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: AppConstants.APIURLs.kServiceCartURL) { (message, response) in
            DispatchQueue.main.async {
                AppCommonMethods.stopProgressBar()
                var setting = BottomAlertSettings()
                setting.strMessage = message
                if response != nil{
                    if AppConstants.isInDevlopmentMode{
                        print("Remove cart Data:",response!)
                    }
                    self.callGetCartAPI(isFromLoad: false)
                    setting.strMessage = response!.getStringValue("ack_msg") ?? ""
                }
                AppValidation.shared.showBottomAlertView(settings: setting)
            }
        }
    }
    
    func callAddCartAPI(row:Int,quantity:Double,isNewOrder:Bool){
        var param = [String:String]()
        let item = isNewOrder ? dashboardData!.newProducts![row] : dashboardData!.topProduct![row]
        param["key"] = AppConstants.commonConstant.kAPIKey
        param["s"] = "35"
        if AppConstants.subCustomerData != nil{
            param["cuid"] = "\(AppConstants.subCustomerData?.cid ?? 0)"
            param["cbid"] = "\(AppConstants.subCustomerData?.cbid ?? 0)"
        }else{
            param["cuid"] = "\(AppConstants.userData?.id ?? 0)"
            param["cbid"] = "\(AppConstants.selectedBranch?.id ?? 0)"
        }
        param["qty"] = "\(quantity)"
        param["pid"] = "\(item.id ?? 0)"
        AppCommonMethods.startProgressBar()
        WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: AppConstants.APIURLs.kServiceCartURL) { (message, response) in
            DispatchQueue.main.async {
                AppCommonMethods.stopProgressBar()
                if response != nil{
                    if AppConstants.isInDevlopmentMode{
                        print("Add cart Data:",response!)
                    }
                    if response!.getIntValue("ack") ?? 0 == 1{
                        self.callGetCartAPI(isFromLoad: false)
                    }
                }
            }
        }
    }
    
    func callGetCartAPI(isFromLoad:Bool = true){
        var param = [String:String]()
        param["key"] = AppConstants.commonConstant.kAPIKey
        param["s"] = "39"
        if AppConstants.subCustomerData != nil{
            param["cuid"] = "\(AppConstants.subCustomerData?.cid ?? 0)"
            param["cbid"] = "\(AppConstants.subCustomerData?.cbid ?? 0)"
        }else{
            param["cuid"] = "\(AppConstants.userData?.id ?? 0)"
            param["cbid"] = "\(AppConstants.selectedBranch?.id ?? 0)"
        }
        AppCommonMethods.startProgressBar()
        WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: AppConstants.APIURLs.kServiceCartURL) { (message, response) in
            DispatchQueue.main.async {
                self.userCart = nil
                if response != nil{
                    if AppConstants.isInDevlopmentMode{
                        print("Cart Data:",response!)
                    }
                    if let result = response!["result"] as? NSDictionary, response!.getIntValue("ack") ?? 0 == 1{
                        if let data = AppCommonMethods.convertToJson(object: result){
                            let jsonDecoder = JSONDecoder()
                            if let aData = try? jsonDecoder.decode(UserCartModel.self, from: data){
                                self.userCart = aData
                                if isFromLoad{
                                    self.stopLoader()
                                }else{
                                    self.setProductsCart()
                                    AppCommonMethods.stopProgressBar()
                                    self.collectionNewProducts.reloadData()
                                    self.collectionTopProducts.reloadData()
                                }
                                NotificationCenter.default.post(name: AppConstants.notifications.kUserCartChanged, object: nil, userInfo: ["userCartCount":self.userCart?.cartitems?.count ?? 0])
                                return
                            }
                        }
                    }
                }
                NotificationCenter.default.post(name: AppConstants.notifications.kUserCartChanged, object: nil, userInfo: ["userCartCount":0])
                if isFromLoad{
                    self.stopLoader()
                }else{
                    self.setProductsCart()
                    AppCommonMethods.stopProgressBar()
                    self.collectionNewProducts.reloadData()
                    self.collectionTopProducts.reloadData()
                }
                
            }
        }
    }
    
    func callGetDashboardAPI(){
        var param = [String:String]()
        param["key"] = AppConstants.commonConstant.kAPIKey
        param["s"] = "81"
        if AppConstants.subCustomerData != nil{
            param["cuid"] = "\(AppConstants.subCustomerData?.cid ?? 0)"
            param["cbid"] = "\(AppConstants.subCustomerData?.cbid ?? 0)"
        }else{
            param["cuid"] = "\(AppConstants.userData?.id ?? 0)"
            param["cbid"] = "\(AppConstants.selectedBranch?.id ?? 0)"
        }
        
        if AppConstants.isInDevlopmentMode{
            print("Dashboard Param:",param)
        }
        
        AppCommonMethods.startProgressBar()
        WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: AppConstants.APIURLs.kServiceCustomerURL) { (message, response) in
            DispatchQueue.main.async {
                var aMessage = message
                self.dashboardData = nil
                if response != nil{
                    if AppConstants.isInDevlopmentMode{
                        print("Dashbaord Data:",response!)
                    }
                    if response!.getIntValue("ack") ?? 0 == 1{
                        if let data = AppCommonMethods.convertToJson(object: response!){
                            let jsonDecoder = JSONDecoder()
                            if let aData = try? jsonDecoder.decode(DashboardModel.self, from: data){
                                self.dashboardData = aData
                                self.tblOrderHistory.reloadData()
                                self.stopLoader()
                                self.collectionBanner.reloadData()
                                if aData.orders?.count ?? 0 != 0{
                                    self.viewForOrders.isHidden = false
                                    DispatchQueue.main.asyncAfter(deadline: .now()+0.1) {
                                        self.constOrderHeight.constant = self.tblOrderHistory.contentSize.height
                                    }
                                }
                                if aData.topProduct?.count ?? 0 != 0{
                                    self.collectionTopProducts.superview?.isHidden = false
                                }
                                if aData.newProducts?.count ?? 0 != 0{
                                    self.collectionNewProducts.superview?.isHidden = false
                                }
                                return
                            }
                        }
                    }else{
                        aMessage = response!.getStringValue("ack_msg") ?? ""
                    }
                }
                self.collectionNewProducts.superview?.isHidden = true
                self.collectionTopProducts.superview?.isHidden = true
                self.viewForOrders.isHidden = true
                self.tblOrderHistory.reloadData()
                self.stopLoader()
                self.collectionBanner.reloadData()
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: aMessage, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
            }
        }
    }
    
    func stopLoader(){
        apiCount += 1
        if apiCount == totalAPI{
            AppCommonMethods.stopProgressBar()
            setProductsCart()
            self.collectionTopProducts.reloadData()
            self.collectionNewProducts.reloadData()
        }
    }
    
    func setProductsCart(){
        if dashboardData?.topProduct?.count ?? 0 != 0{
            for j in 0..<dashboardData!.topProduct!.count{
                dashboardData!.topProduct![j].isAddedInCart = false
                dashboardData!.topProduct![j].selectedQty = 0
                if userCart != nil && userCart?.cartitems?.count ?? 0 != 0{
                    let index = userCart!.cartitems!.firstIndex { (model) -> Bool in
                        return model.itemId ?? 0 == dashboardData!.topProduct![j].id ?? 0
                    }
                    if index != nil{
                       dashboardData!.topProduct![j].isAddedInCart = true
                       dashboardData!.topProduct![j].selectedQty = userCart!.cartitems![index!].itemQty ?? 0
                       dashboardData!.topProduct![j].cartId = userCart!.cartitems![index!].id ?? 0
                    }
                }
             }
        }
        if dashboardData?.newProducts?.count ?? 0 != 0{
            for j in 0..<dashboardData!.newProducts!.count{
                dashboardData!.newProducts![j].isAddedInCart = false
                dashboardData!.newProducts![j].selectedQty = 0
                if userCart != nil && userCart?.cartitems?.count ?? 0 != 0{
                    let index = userCart!.cartitems!.firstIndex { (model) -> Bool in
                        return model.itemId ?? 0 == dashboardData!.newProducts![j].id ?? 0
                    }
                    if index != nil{
                       dashboardData!.newProducts![j].isAddedInCart = true
                       dashboardData!.newProducts![j].selectedQty = userCart!.cartitems![index!].itemQty ?? 0
                       dashboardData!.newProducts![j].cartId = userCart!.cartitems![index!].id ?? 0
                    }
                }
             }
        }
    }
    
    func checkForCart(){
        var arrCart = [CartItemsModel]()
        if dashboardData?.topProduct?.count ?? 0 != 0{
            let arr = dashboardData!.topProduct!.filter { (model) -> Bool in
                return model.isAddedInCart
            }
            for model in arr{
                let cart = CartItemsModel()
                cart.itemQty = model.selectedQty
                cart.itemName = model.itemName
                cart.itemId = model.id
                cart.itemPrice = model.itemPrice
                cart.itemTotalPrice = (model.selectedQty * (model.itemPrice ?? 0))
                arrCart.append(cart)
            }
        }
        if dashboardData?.newProducts?.count ?? 0 != 0{
            let arr = dashboardData!.newProducts!.filter { (model) -> Bool in
                return model.isAddedInCart
            }
            for model in arr{
                let cart = CartItemsModel()
                cart.itemQty = model.selectedQty
                cart.itemName = model.itemName
                cart.itemId = model.id
                cart.itemPrice = model.itemPrice
                cart.itemTotalPrice = (model.selectedQty * (model.itemPrice ?? 0))
                arrCart.append(cart)
            }
        }
        userCart?.cartitems = arrCart
        
    }
}

extension DashboardVC:UITableViewDelegate,UITableViewDataSource{
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return self.dashboardData?.orders?.count ?? 0
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "OrderHistoryCell", for: indexPath) as! OrderHistoryCell
        let model = self.dashboardData!.orders![indexPath.row]
        cell.lblOrderPrice.text = ""
        if let data = AppConstants.userData{
            if data.showPrice ?? 0 == 1{
                cell.lblOrderPrice.text = String.init(format: "%@%.2f", AppConstants.currencySign,model.orderTotal ?? 0)
            }
        }else{
            cell.lblOrderPrice.text = String.init(format: "%@%.2f", AppConstants.currencySign,model.orderTotal ?? 0)
        }
        cell.lblOrderNo.text = "Order No: #\(model.orderNo ?? "")"
        if let date = model.date?.getDateFromString(format: "dd-MM-yyyy"){
            cell.lblDescription.text = "Ordered on: \(date.getDateInString(format: "dd'\(date.getDateSuffix())' MMM, yyyy"))\nOrder status: \(model.statusText ?? "")"
            let strDesc = "Ordered on: \(date.getDateInString(format: "dd'\(date.getDateSuffix())' MMM, yyyy"))\nOrder status: \(model.statusText ?? "")"
            let attrDesc = NSMutableAttributedString.init(string: strDesc, attributes: [NSAttributedString.Key.foregroundColor : AppConstants.Colors.kAppGrayThemeColor,NSAttributedString.Key.font:AppConstants.GlobalFontConstants.kRegularFont(size: AppConstants.DeviceType.IS_IPAD ? 16 : 14)])
            attrDesc.addFontAttribute(title: "Order status", fontSize: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
            attrDesc.addFontAttribute(title: "Ordered on", fontSize: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
            cell.lblDescription.attributedText = attrDesc
        }
        return cell
    }
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        if let VC = OrderDetailVC.instance(){
            VC.orderDetail = self.dashboardData!.orders![indexPath.row]
            self.navigationController?.pushViewController(VC, animated: true)
        }
    }
}

extension DashboardVC: UICollectionViewDataSource,UICollectionViewDelegate,UICollectionViewDelegateFlowLayout{
    func collectionView(_ collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        if collectionView == collectionBanner{
            return self.dashboardData?.banner?.count ?? 0
        }
        if collectionView == collectionNewProducts{
            return self.dashboardData?.newProducts?.count ?? 0
        }
        return self.dashboardData?.topProduct?.count ?? 0
    }
    
    func collectionView(_ collectionView: UICollectionView, cellForItemAt indexPath: IndexPath) -> UICollectionViewCell {
        if collectionView == collectionBanner{
            let cell = collectionView.dequeueReusableCell(withReuseIdentifier: "DashbordBannerCell", for: indexPath) as! DashbordBannerCell
            cell.imgBanner.sd_setImage(with: URL(string: dashboardData!.banner![indexPath.row].imagePath ?? ""), placeholderImage:UIImage(named: "placeholder"), options: .avoidDecodeImage)
            cell.imgBanner.clipsToBounds = true
            cell.imgBanner.contentMode = .scaleAspectFill
            return cell
        }
        let cell = collectionView.dequeueReusableCell(withReuseIdentifier: "DashbordProductCell", for: indexPath) as! DashbordProductCell
        let model = (collectionView == collectionNewProducts) ? dashboardData!.newProducts![indexPath.row] : dashboardData!.topProduct![indexPath.row]
        cell.lblProductName.text = model.itemName ?? ""
        cell.txtProductQty.tag = indexPath.row
        cell.txtProductQty.text = String.init(format: "%.1f", model.selectedQty)
        cell.lblProductPrice.text = ""
        if let data = AppConstants.userData{
            if data.showPrice ?? 0 == 1{
                cell.lblProductPrice.text = String.init(format: "%@%.2f", AppConstants.currencySign,model.itemPrice ?? 0)
            }
        }else{
            cell.lblProductPrice.text = String.init(format: "%@%.2f", AppConstants.currencySign,model.itemPrice ?? 0)
        }
        cell.btnIncrement.tag = indexPath.row
        cell.btnDecrement.tag = indexPath.row
        cell.btnAdd.tag = indexPath.row
        cell.imgProduct.sd_setImage(with: URL(string: model.imagePath ?? ""), placeholderImage:UIImage(named: "placeholder"), options: .avoidDecodeImage)
        cell.lblCategory.text = model.categoryName ?? ""
        if model.stockQty ?? 0 == 0{
            cell.btnAdd.isHidden = true
            cell.viewForQty.isHidden = true
            cell.lblOutOfStock.isHidden = false
        }else{
            cell.lblOutOfStock.isHidden = true
            if model.isAddedInCart{
                cell.btnAdd.isHidden = true
                cell.viewForQty.isHidden = false
            }else{
                cell.btnAdd.isHidden = false
                cell.viewForQty.isHidden = true
            }
        }
        return cell
    }
    
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, sizeForItemAt indexPath: IndexPath) -> CGSize {
        if collectionView == collectionBanner{
            return CGSize.init(width: UIScreen.main.bounds.size.width, height: AppConstants.DeviceType.IS_IPAD ? 200 : 150)
        }
        return CGSize.init(width: 150, height: 190)
    }
}
