//
//  DispatchesVC.swift
//  globalfoods
//
//  Created by Apple on 29/12/20.
//

import UIKit
import ActionSheetPicker_3_0

class DispatchesCell: UITableViewCell {
    
    @IBOutlet weak var lblDispatchNo:UILabel!
    @IBOutlet weak var lblOrderNo:UILabel!
    @IBOutlet weak var btnDownload:UIButton!
    @IBOutlet weak var lblDescription:UILabel!
    @IBOutlet weak var lblTotalPrice:UILabel!
    @IBOutlet weak var lblProducts:UILabel!
    @IBOutlet weak var imgSelect:UIImageViewX!
    @IBOutlet weak var viewDispatchNote:UIView!
    
    override class func awakeFromNib() {
        
    }
}

class DispatchesVC: UIViewController {

    @IBOutlet weak var contTblTopSpace:NSLayoutConstraint!
    @IBOutlet weak var viewForRange:UIView!
    @IBOutlet weak var tblDisptaches:UITableView!
    @IBOutlet weak var lblFromDate:UILabel!
    @IBOutlet weak var lblToDate:UILabel!
    
    var customHeaderView:HeaderView?
    var strToDate = ""
    var strFromDate = ""
    var orderDetail:OrderHistoryModel?
    var popRecognizer: InteractivePopRecognizer?
    var arrDispatches = [DispatchModel]()
    var isBackEnabled = false
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
        
        if orderDetail != nil{
            viewForRange.isHidden = true
            contTblTopSpace.constant = AppConstants.DeviceType.IS_IPAD ? 65 : 55
            setInteractiveRecognizer()
        }else{
            contTblTopSpace.constant = AppConstants.DeviceType.IS_IPAD ? 125 : 115
            self.strFromDate = Date().addingTimeInterval(-7*24*60*60).getDateInString(format: "dd-MM-yyyy")
            self.strToDate = Date().getDateInString(format: "dd-MM-yyyy")
            self.lblFromDate.text = "From - \(Date().addingTimeInterval(-7*24*60*60).getDateInString(format: "dd/MM/yyyy"))"
            self.lblToDate.text = "To - \(Date().getDateInString(format: "dd/MM/yyyy"))"
            if isBackEnabled{
                setInteractiveRecognizer()
            }
        }
        
    }
    
    override func viewWillAppear(_ animated: Bool) {
        setHeaderView()
        callGetDispatchesAPI()
    }
    
    //MARK: Create Viewcontrlloer instance
    static func instance()->DispatchesVC?{
        return UIStoryboard.init(name: "SideMenu", bundle: nil).instantiateViewController(withIdentifier: "DispatchesVC") as? DispatchesVC
    }
    
    //MARK: General methods
    func setHeaderView(){
        if customHeaderView != nil{
            customHeaderView!.removeFromSuperview()
            customHeaderView = nil
        }
        customHeaderView = HeaderView.init(controller: self, title: "Dispatches", isBackEnbaled: (orderDetail != nil) ? true : isBackEnabled)
    }
    
    private func setInteractiveRecognizer() {
        guard let controller = navigationController else { return }
        popRecognizer = InteractivePopRecognizer(controller: controller)
        controller.interactivePopGestureRecognizer?.delegate = popRecognizer
    }
    
    //MARK: Button Actions
    @IBAction func btnFromDateAction(_ sender:UIButton){
        let date = strFromDate.getDateFromString(format: "dd-MM-yyyy", locale: nil) ?? Date()
        let datePicker = ActionSheetDatePicker(title: "Select from date", datePickerMode: UIDatePicker.Mode.date, selectedDate: date, doneBlock: {
            picker, value, index in
            self.strFromDate = (value as! Date).getDateInString(format: "dd-MM-yyyy")
            self.lblFromDate.text = "From - \((value as! Date).getDateInString(format: "dd/MM/yyyy"))"
            self.callGetDispatchesAPI()
        }, cancel: { ActionStringCancelBlock in return }, origin: sender)
        datePicker?.maximumDate = strToDate.getDateFromString(format: "dd-MM-yyyy", locale: nil) ?? Date()
        datePicker?.show()
    }
    
    @IBAction func btnToDateAction(_ sender:UIButton){
        let date = strToDate.getDateFromString(format: "dd-MM-yyyy", locale: nil) ?? Date()
        let datePicker = ActionSheetDatePicker(title: "Select to date", datePickerMode: UIDatePicker.Mode.date, selectedDate: date, doneBlock: {
            picker, value, index in
            self.strToDate = (value as! Date).getDateInString(format: "dd-MM-yyyy")
            self.lblToDate.text = "To - \((value as! Date).getDateInString(format: "dd/MM/yyyy"))"
            self.callGetDispatchesAPI()
        }, cancel: { ActionStringCancelBlock in return }, origin: sender)
        if let fromDate = strFromDate.getDateFromString(format: "dd-MM-yyyy", locale: nil){
            datePicker?.minimumDate = fromDate
        }
        datePicker?.show()
    }
    
    @IBAction func btnDownloadAction(_ sender:UIButton){
        if sender.isSelected{
            if let VC = WebViewController.instance(){
                let fileName = "Dispatches_\(arrDispatches[sender.tag].id ?? 0).pdf"
                let documentsUrl =  FileManager.default.urls(for: .documentDirectory, in: .userDomainMask).first!
                let destinationFileUrl = documentsUrl.appendingPathComponent("\(fileName)")
                VC.strURL = destinationFileUrl.absoluteString
                self.navigationController?.pushViewController(VC, animated: true)
            }
        }else{
            downloadPDFFile(id: arrDispatches[sender.tag].id ?? 0, path: arrDispatches[sender.tag].path ?? "")
        }
    }
    
    func checkPDFExist(id:Int)->Bool{
        let fileName = "Dispatches_\(id).pdf"
        let documentsUrl =  FileManager.default.urls(for: .documentDirectory, in: .userDomainMask).first!
        let destinationFileUrl = documentsUrl.appendingPathComponent("\(fileName)")
        return FileManager.default.fileExists(atPath: destinationFileUrl.path)
    }
    
    func downloadPDFFile(id:Int,path:String){
        let fileName = "Dispatches_\(id).pdf"
        let documentsUrl =  FileManager.default.urls(for: .documentDirectory, in: .userDomainMask).first!
        let destinationFileUrl = documentsUrl.appendingPathComponent("\(fileName)")
        
        if let fileURL = URL(string: path){
            AppCommonMethods.startProgressBar()
            DispatchQueue.global().async {
                do{
                    let data = try Data.init(contentsOf: fileURL)
                    try data.write(to: destinationFileUrl)
                    DispatchQueue.main.async {
                        AppCommonMethods.stopProgressBar()
                        if let VC = WebViewController.instance(){
                            VC.strURL = destinationFileUrl.absoluteString
                            self.navigationController?.pushViewController(VC, animated: true)
                        }
                    }
                }catch (let err) {
                    DispatchQueue.main.async {
                        AppCommonMethods.stopProgressBar()
                    }
                    print("error: \(err)")
                }
            }
        }
        
    }
    
    func callGetDispatchesAPI(){
        var param = [String:String]()
        param["key"] = AppConstants.commonConstant.kAPIKey
        var strURL = AppConstants.APIURLs.kServiceCustomerURL
        if orderDetail != nil{
            param["s"] = "26"
            param["order_id"] = "\(orderDetail?.id ?? 0)"
            strURL = AppConstants.APIURLs.kServiceGeneralURL
        }else{
            if AppConstants.userData == nil{
                param["s"] = "91"
                strURL = AppConstants.APIURLs.kServiceEmployeeURL
            }else{
                param["s"] = "53"
                param["cuid"] = "\(AppConstants.userData?.id ?? 0)"
                param["cbid"] = "\(AppConstants.selectedBranch?.id ?? 0)"
            }
            param["from_date"] = strFromDate
            param["to_date"] = strToDate
        }
        AppCommonMethods.startProgressBar()
        WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: strURL) { (message, response) in
            DispatchQueue.main.async {
                var aMessage = message
                self.arrDispatches.removeAll()
                AppCommonMethods.stopProgressBar()
                if response != nil{
                    if AppConstants.isInDevlopmentMode{
                        print("Dispatches Data:",response!)
                    }
                    if let result = response!["result"] as? [NSDictionary], response!.getIntValue("ack") ?? 0 == 1{
                        if let data = AppCommonMethods.convertToJson(object: result){
                            let jsonDecoder = JSONDecoder()
                            if let aData = try? jsonDecoder.decode([DispatchModel].self, from: data){
                                self.arrDispatches = aData
                                self.tblDisptaches.reloadData()
                                return
                            }
                        }
                    }else{
                        aMessage = response!.getStringValue("ack_msg") ?? ""
                    }
                }
                self.tblDisptaches.reloadData()
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: aMessage, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
            }
            
        }
    }
}

extension DispatchesVC:UITableViewDataSource,UITableViewDelegate{
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return arrDispatches.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "DispatchesCell", for: indexPath) as! DispatchesCell
        
        let model = arrDispatches[indexPath.row]
        cell.lblDispatchNo.text = "Dispatch No: #\(model.dispatchNo ?? "")"
        cell.lblTotalPrice.text = ""
        if let data = AppConstants.userData{
            if data.showPrice ?? 0 == 1{
                cell.lblTotalPrice.text = String.init(format: "%@%.2f", AppConstants.currencySign, model.dispatchTotal ?? 0)
            }
        }else{
            cell.lblTotalPrice.text = String.init(format: "%@%.2f", AppConstants.currencySign, model.dispatchTotal ?? 0)
        }
        if orderDetail != nil{
            cell.viewDispatchNote.isHidden = true
            if let dispatchDate = model.dispatchDate?.getDateFromString(format: "dd-MM-yyyy"),let dueDate = model.paymentDueDate?.getDateFromString(format: "dd-MM-yyyy"){
                let strDesc = "Dispatch on: \(dispatchDate.getDateInString(format: "dd'\(dispatchDate.getDateSuffix())' MMM, yyyy"))\nPayment due on: \(dueDate.getDateInString(format: "dd'\(dueDate.getDateSuffix())' MMM, yyyy"))\nStatus: \(model.statusText ?? "")"
                let attrDesc = NSMutableAttributedString.init(string: strDesc, attributes: [NSAttributedString.Key.foregroundColor : AppConstants.Colors.kAppGrayThemeColor,NSAttributedString.Key.font:AppConstants.GlobalFontConstants.kRegularFont(size: AppConstants.DeviceType.IS_IPAD ? 16 : 14)])
                attrDesc.addFontAttribute(title: "Dispatch on", fontSize: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
                attrDesc.addFontAttribute(title: "Payment due on", fontSize: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
                attrDesc.addFontAttribute(title: "Status", fontSize: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
                
                cell.lblDescription.attributedText = attrDesc
            }
        }else{
            cell.viewDispatchNote.isHidden = false
            if checkPDFExist(id: model.id ?? 0){
                cell.btnDownload.isSelected = true
            }else{
                cell.btnDownload.isSelected = false
            }
            cell.btnDownload.tag = indexPath.row
            if let dispatchDate = model.dispatchDate?.getDateFromString(format: "dd-MM-yyyy"){
                let strDesc = "Billing person name: \(model.billingName ?? "")\nPincode: \(model.billingPincode ?? "")\nDispatch on: \(dispatchDate.getDateInString(format: "dd'\(dispatchDate.getDateSuffix())' MMM, yyyy"))\nStatus: \(model.statusText ?? "")"
                let attrDesc = NSMutableAttributedString.init(string: strDesc, attributes: [NSAttributedString.Key.foregroundColor : AppConstants.Colors.kAppGrayThemeColor,NSAttributedString.Key.font:AppConstants.GlobalFontConstants.kRegularFont(size: AppConstants.DeviceType.IS_IPAD ? 16 : 14)])
                attrDesc.addFontAttribute(title: "Dispatch on", fontSize: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
                attrDesc.addFontAttribute(title: "Billing person name", fontSize: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
                attrDesc.addFontAttribute(title: "Status", fontSize: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
                attrDesc.addFontAttribute(title: "Pincode", fontSize: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
                cell.lblDescription.attributedText = attrDesc
            }
        }
        
        return cell
    }
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        if let VC = DispatchDetailVC.instance(){
            VC.isFromOrder = (orderDetail != nil)
            VC.dispatchId = arrDispatches[indexPath.row].id ?? 0
            self.navigationController?.pushViewController(VC, animated: true)
        }
    }
}
