//
//  ProfileVC.swift
//  globalfoods
//
//  Created by Apple on 05/01/21.
//

import UIKit

class ProfileVC: UIViewController {

    @IBOutlet weak var lblBasicInfoLine:UILabel!
    @IBOutlet weak var lblPremisesInfoLine:UILabel!
    @IBOutlet weak var btnBasicInfo:UIButton!
    @IBOutlet weak var btnPremisesInfo:UIButton!
    
    @IBOutlet weak var lblPremisesName:UILabel!
    @IBOutlet weak var lblPremisesEmail:UILabel!
    @IBOutlet weak var lblPremisesPhone:UILabel!
    @IBOutlet weak var lblPremisesAddress:UILabel!
    @IBOutlet weak var lblPremisesCity:UILabel!
    @IBOutlet weak var lblPremisesCountry:UILabel!
    
    @IBOutlet weak var txtBusinessName:UITextField!
    @IBOutlet weak var txtBusinessApplicant:UITextField!
    @IBOutlet weak var txtBusinessCity:UITextField!
    @IBOutlet weak var txtBusinessAddress:UITextField!
    @IBOutlet weak var txtBusinessEmail:UITextField!
    @IBOutlet weak var txtBusinessPostCode:UITextField!
    @IBOutlet weak var txtBusinessTel:UITextField!
    @IBOutlet weak var txtBusinessCell:UITextField!
    
    @IBOutlet weak var txtOwnerName:UITextField!
    @IBOutlet weak var txtOwnerDesignation:UITextField!
    @IBOutlet weak var txtOwnerPostCode:UITextField!
    @IBOutlet weak var txtOwnerAddress:UITextField!
    @IBOutlet weak var txtOwnerEmail:UITextField!
    @IBOutlet weak var txtOwnerTel:UITextField!
    @IBOutlet weak var txtOwnerCell:UITextField!
    
    @IBOutlet weak var txtTradeName:UITextField!
    @IBOutlet weak var txtCreditLimit:UITextField!
    @IBOutlet weak var txttradePostCode:UITextField!
    @IBOutlet weak var txtTradeAddress:UITextField!
    @IBOutlet weak var txtCreditLimitDay:UITextField!
    @IBOutlet weak var txtDiscount:UITextField!
    @IBOutlet weak var txtPrefferedTransport:UITextField!
    
    @IBOutlet weak var viewForPremises:UIView!
    @IBOutlet weak var viewForOwner:UIView!
    @IBOutlet weak var viewForBussiness:UIView!
    @IBOutlet weak var viewForTrade:UIView!
    
    var customHeaderView:HeaderView?
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
        
    }
    
    override func viewWillAppear(_ animated: Bool) {
        setHeaderView()
        viewForPremises.isHidden = true
        viewForOwner.isHidden = false
        viewForBussiness.isHidden = false
        viewForTrade.isHidden = false
        lblPremisesInfoLine.isHidden = true
        lblBasicInfoLine.isHidden = false
        btnBasicInfo.titleLabel?.font = AppConstants.GlobalFontConstants.kBoldFont(size: AppConstants.DeviceType.IS_IPAD ? 16 : 13)
        btnPremisesInfo.titleLabel?.font = AppConstants.GlobalFontConstants.kRegularFont(size: AppConstants.DeviceType.IS_IPAD ? 16 : 13)
        setUserData()
    }
    
    //MARK: Create Viewcontrlloer instance
    static func instance()->ProfileVC?{
        return UIStoryboard.init(name: "SideMenu", bundle: nil).instantiateViewController(withIdentifier: "ProfileVC") as? ProfileVC
    }
    
    //MARK: General methods
    func setHeaderView(){
        if customHeaderView != nil{
            customHeaderView!.removeFromSuperview()
            customHeaderView = nil
        }
        customHeaderView = HeaderView.init(controller: self, title: "Profile", isBackEnbaled: false)
    }
    
    func setUserData(){
        txtBusinessName.text = AppConstants.userData?.name ?? ""
        txtBusinessApplicant.text = AppConstants.userData?.applicant ?? ""
        txtBusinessCity.text = AppConstants.userData?.city ?? ""
        txtBusinessAddress.text = AppConstants.userData?.address ?? ""
        txtBusinessEmail.text = AppConstants.userData?.email ?? ""
        txtBusinessPostCode.text = AppConstants.userData?.pincode ?? ""
        txtBusinessTel.text = AppConstants.userData?.telephone ?? ""
        txtBusinessCell.text = AppConstants.userData?.cellphone ?? ""
        
        txtOwnerName.text = AppConstants.userData?.ownerName ?? ""
        txtOwnerDesignation.text = AppConstants.userData?.ownerDesignation ?? ""
        txtOwnerPostCode.text = AppConstants.userData?.ownerPincode ?? ""
        txtOwnerAddress.text = AppConstants.userData?.ownerAddress ?? ""
        txtOwnerEmail.text = AppConstants.userData?.ownerEmail ?? ""
        txtOwnerTel.text = AppConstants.userData?.ownerTelephone ?? ""
        txtOwnerCell.text = AppConstants.userData?.ownerCellphone ?? ""
        
        txtTradeName.text = AppConstants.userData?.tradeName ?? ""
        txtCreditLimit.text = AppConstants.userData?.creditLimit ?? ""
        txttradePostCode.text = AppConstants.userData?.tradePincode ?? ""
        txtTradeAddress.text = AppConstants.userData?.tradeAddress ?? ""
        txtCreditLimitDay.text = AppConstants.userData?.creditLimitDays ?? ""
        txtDiscount.text = AppConstants.userData?.discount ?? ""
        txtPrefferedTransport.text = AppConstants.userData?.transportBy ?? ""
        
        lblPremisesName.setLabelAttributedText(title: "Name", value: AppConstants.selectedBranch?.name ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16)
        lblPremisesEmail.setLabelAttributedText(title: "Email-id", value: AppConstants.selectedBranch?.email ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16)
        lblPremisesPhone.setLabelAttributedText(title: "Phone No", value: AppConstants.selectedBranch?.phone ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16)
        lblPremisesAddress.setLabelAttributedText(title: "Address", value: AppConstants.selectedBranch?.address ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16)
        lblPremisesCity.setLabelAttributedText(title: "City", value: AppConstants.selectedBranch?.city ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16)
        lblPremisesCountry.setLabelAttributedText(title: "Country", value: AppConstants.selectedBranch?.country ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16)
    }
    
    @IBAction func btnTabAction(_ sender:UIButton){
        if sender.tag == 0{
            viewForPremises.isHidden = true
            viewForOwner.isHidden = false
            viewForBussiness.isHidden = false
            viewForTrade.isHidden = false
            lblPremisesInfoLine.isHidden = true
            lblBasicInfoLine.isHidden = false
            btnBasicInfo.titleLabel?.font = AppConstants.GlobalFontConstants.kBoldFont(size: AppConstants.DeviceType.IS_IPAD ? 16 : 13)
            btnPremisesInfo.titleLabel?.font = AppConstants.GlobalFontConstants.kRegularFont(size: AppConstants.DeviceType.IS_IPAD ? 16 : 13)
        }else{
            viewForPremises.isHidden = false
            viewForOwner.isHidden = true
            viewForBussiness.isHidden = true
            viewForTrade.isHidden = true
            lblPremisesInfoLine.isHidden = false
            lblBasicInfoLine.isHidden = true
            btnBasicInfo.titleLabel?.font = AppConstants.GlobalFontConstants.kRegularFont(size: AppConstants.DeviceType.IS_IPAD ? 16 : 13)
            btnPremisesInfo.titleLabel?.font = AppConstants.GlobalFontConstants.kBoldFont(size: AppConstants.DeviceType.IS_IPAD ? 16 : 13)
        }
    }
    
}
