//
//  RepoVisitVC.swift
//  globalfoods
//
//  Created by Apple on 29/12/20.
//

import UIKit
import ActionSheetPicker_3_0

class RepoVisitCell: UITableViewCell {
    
    @IBOutlet weak var lblDescription:UILabel!
    @IBOutlet weak var btnDelete:UIButton!
    @IBOutlet weak var constBtnDeleteWidth:NSLayoutConstraint!
    
    override class func awakeFromNib() {
        
    }
}

class RepoVisitVC: UIViewController {

    @IBOutlet weak var lblFromDate:UILabel!
    @IBOutlet weak var lblToDate:UILabel!
    @IBOutlet weak var tblRepoVisit:UITableView!
    @IBOutlet weak var lblCustomerInfo:UILabel!
    @IBOutlet weak var viewForCustomer:UIView!
    @IBOutlet weak var viewForSelectCustomer:UIView!
    @IBOutlet weak var btnAddRepo:UIButton!
    
    var selectedRow = 0
    var customHeaderView:HeaderView?
    var strToDate = ""
    var strFromDate = ""
    var arrRepoVisit = [RepoVisitModel]()
    var selectedCustomer:UserModel?
    var selectedBranch:branchModel?
    var isBackEnabled = false
    var popRecognizer: InteractivePopRecognizer?
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
        
        self.strFromDate = Date().addingTimeInterval(-7*24*60*60).getDateInString(format: "dd-MM-yyyy")
        self.strToDate = Date().getDateInString(format: "dd-MM-yyyy")
        self.lblFromDate.text = "From - \(Date().addingTimeInterval(-7*24*60*60).getDateInString(format: "dd/MM/yyyy"))"
        self.lblToDate.text = "To - \(Date().getDateInString(format: "dd/MM/yyyy"))"
        if isBackEnabled{
            setInteractiveRecognizer()
        }
    }
    
    override func viewWillAppear(_ animated: Bool) {
        setHeaderView()
        if AppConstants.userData == nil{
            if selectedCustomer == nil{
                if let VC = SelectCustomerVC.showPopup(parentVC: self, branchData: selectedBranch, customerData: selectedCustomer){
                    VC.delegate = self
                }
                viewForSelectCustomer.isHidden = false
            }else{
                callGetRepoVisitAPI()
            }
            if AppConstants.employeeData?.rights?.visit?.insert ?? 0 == 1{
                btnAddRepo.superview?.isHidden = false
            }else{
                btnAddRepo.superview?.isHidden = true
            }
        }else{
            viewForSelectCustomer.isHidden = true
            btnAddRepo.superview?.isHidden = true
            viewForCustomer.isHidden = true
            callGetRepoVisitAPI()
        }
        
    }
    
    //MARK: Create Viewcontrlloer instance
    static func instance()->RepoVisitVC?{
        return UIStoryboard.init(name: "SideMenu", bundle: nil).instantiateViewController(withIdentifier: "RepoVisitVC") as? RepoVisitVC
    }
    
    //MARK: General methods
    func setHeaderView(){
        if customHeaderView != nil{
            customHeaderView!.removeFromSuperview()
            customHeaderView = nil
        }
        customHeaderView = HeaderView.init(controller: self, title: "Repo Visits", isBackEnbaled: isBackEnabled)
    }
    
    private func setInteractiveRecognizer() {
        guard let controller = navigationController else { return }
        popRecognizer = InteractivePopRecognizer(controller: controller)
        controller.interactivePopGestureRecognizer?.delegate = popRecognizer
    }
    
    //MARK: Button Actions
    @IBAction func btnFromDateAction(_ sender:UIButton){
        let date = strFromDate.getDateFromString(format: "dd-MM-yyyy", locale: nil) ?? Date()
        let datePicker = ActionSheetDatePicker(title: "Select from date", datePickerMode: UIDatePicker.Mode.date, selectedDate: date, doneBlock: {
            picker, value, index in
            self.strFromDate = (value as! Date).getDateInString(format: "dd-MM-yyyy")
            self.lblFromDate.text = "From - \((value as! Date).getDateInString(format: "dd/MM/yyyy"))"
            self.callGetRepoVisitAPI()
        }, cancel: { ActionStringCancelBlock in return }, origin: sender)
        datePicker?.maximumDate = strToDate.getDateFromString(format: "dd-MM-yyyy", locale: nil) ?? Date()
        datePicker?.show()
    }
    
    @IBAction func btnToDateAction(_ sender:UIButton){
        let date = strToDate.getDateFromString(format: "dd-MM-yyyy", locale: nil) ?? Date()
        let datePicker = ActionSheetDatePicker(title: "Select to date", datePickerMode: UIDatePicker.Mode.date, selectedDate: date, doneBlock: {
            picker, value, index in
            self.strToDate = (value as! Date).getDateInString(format: "dd-MM-yyyy")
            self.lblToDate.text = "To - \((value as! Date).getDateInString(format: "dd/MM/yyyy"))"
            self.callGetRepoVisitAPI()
        }, cancel: { ActionStringCancelBlock in return }, origin: sender)
        if let fromDate = strFromDate.getDateFromString(format: "dd-MM-yyyy", locale: nil){
            datePicker?.minimumDate = fromDate
        }
        datePicker?.show()
    }
    
    @IBAction func btnChangeCustomerAction(_ sender:UIButton){
        if let VC = SelectCustomerVC.showPopup(parentVC: self, branchData: selectedBranch, customerData: selectedCustomer){
            VC.delegate = self
        }
    }
    
    @IBAction func btnCreateRepoVisitAction(_ sender:UIButton){
        if let VC = AddSalesRepoVC.instance(){
            self.navigationController?.pushViewController(VC, animated: true)
        }
    }
    
    @IBAction func btnDeleteSalesRepoAction(_ sender:UIButton){
        selectedRow = sender.tag
        var settings = AlertSettings()
        settings.alertMsg = "Are you sure you want to delete selected sales repo visit record?"
        settings.alertTitle = "Delete Repo Visit"
        settings.confirmButtonTitle = AppConstants.GlobalAlert.ALERT_BTN_YES
        settings.cancelButtonTitle = AppConstants.GlobalAlert.ALERT_BTN_NO
        if let VC = CustomeAlertVC.showPopup(parentVC: self, settings: settings){
            VC.delegate = self
        }
    }
    
    func callGetRepoVisitAPI(){
        var param = [String:String]()
        param["key"] = AppConstants.commonConstant.kAPIKey
        param["s"] = "57"
        if selectedBranch != nil{
            param["cuid"] = "\(selectedCustomer?.id ?? 0)"
            param["cbid"] = "\(selectedBranch?.id ?? 0)"
        }else{
            param["cuid"] = "\(AppConstants.userData?.id ?? 0)"
            param["cbid"] = "\(AppConstants.selectedBranch?.id ?? 0)"
        }
        param["from_date"] = strFromDate
        param["to_date"] = strToDate
        
        AppCommonMethods.startProgressBar()
        WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: AppConstants.APIURLs.kServiceCustomerURL) { (message, response) in
            DispatchQueue.main.async {
                var aMessage = message
                self.arrRepoVisit.removeAll()
                AppCommonMethods.stopProgressBar()
                if response != nil{
                    if AppConstants.isInDevlopmentMode{
                        print("Repo Visit Data:",response!)
                    }
                    if let result = response!["result"] as? [NSDictionary], response!.getIntValue("ack") ?? 0 == 1{
                        if let data = AppCommonMethods.convertToJson(object: result){
                            let jsonDecoder = JSONDecoder()
                            if let aData = try? jsonDecoder.decode([RepoVisitModel].self, from: data){
                                self.arrRepoVisit = aData
                                self.tblRepoVisit.reloadData()
                                return
                            }
                        }
                    }else{
                        aMessage = response!.getStringValue("ack_msg") ?? ""
                    }
                }
                self.tblRepoVisit.reloadData()
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: aMessage, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
            }
        }
    }
    
    func callDeleteRepoVisitAPI(){
        var param = [String:String]()
        param["key"] = AppConstants.commonConstant.kAPIKey
        param["s"] = "96"
        param["sales_repo_id"] = "\(arrRepoVisit[selectedRow].id ?? 0)"
        
        AppCommonMethods.startProgressBar()
        WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: AppConstants.APIURLs.kServiceEmployeeURL) { (message, response) in
            DispatchQueue.main.async {
                var aMessage = message
                AppCommonMethods.stopProgressBar()
                if response != nil{
                    if AppConstants.isInDevlopmentMode{
                        print("Delete Repo Visit Data:",response!)
                    }
                    aMessage = response!.getStringValue("ack_msg") ?? ""
                    if response!.getIntValue("ack") ?? 0 == 1{
                        self.arrRepoVisit.remove(at: self.selectedRow)
                        var settings = BottomAlertSettings()
                        settings.strMessage = aMessage
                        AppValidation.shared.showBottomAlertView(settings: settings)
                        self.tblRepoVisit.reloadData()
                        return
                    }
                }
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: aMessage, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
            }
        }
    }
}

extension RepoVisitVC:UITableViewDelegate,UITableViewDataSource{
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return arrRepoVisit.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "RepoVisitCell", for: indexPath) as! RepoVisitCell
        let model = arrRepoVisit[indexPath.row]
        if AppConstants.userData == nil{
            if AppConstants.employeeData?.rights?.visit?.delete ?? 0 == 1{
                cell.constBtnDeleteWidth.constant = 40
                cell.btnDelete.tag = indexPath.row
            }else{
                cell.constBtnDeleteWidth.constant = 0
            }
        }else{
            cell.constBtnDeleteWidth.constant = 0
        }
        if let date = model.createdDate?.getDateFromString(format: "dd-MM-yyyy HH:mm:ss"){
            let strDesc = "Sales repo name: \(model.salesRepoName ?? "")\nCustomer name: \(model.customerName ?? "")\nBranch name: \(model.customerBranchName ?? "")\nDate: \(date.getDateInString(format: "dd'\(date.getDateSuffix())' MMM, yyyy 'at' hh:mm a"))\nRemark: \(model.remark ?? "")"
            let attrDesc = NSMutableAttributedString.init(string: strDesc, attributes: [NSAttributedString.Key.foregroundColor : AppConstants.Colors.kAppGrayThemeColor,NSAttributedString.Key.font:AppConstants.GlobalFontConstants.kRegularFont(size: AppConstants.DeviceType.IS_IPAD ? 16 : 14)])
            attrDesc.addFontAttribute(title: "Customer name", fontSize: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
            attrDesc.addFontAttribute(title: "Sales repo name", fontSize: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
            attrDesc.addFontAttribute(title: "Branch name", fontSize: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
            attrDesc.addFontAttribute(title: "Remark", fontSize: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
            attrDesc.addFontAttribute(title: "Date", fontSize: AppConstants.DeviceType.IS_IPAD ? 16 : 14)
            
            cell.lblDescription.attributedText = attrDesc
        }
        return cell
    }
    
    
}

extension RepoVisitVC:customerSelctionDelegate{
    func customerSelected(customerData: UserModel?, branchData: branchModel?,customerName:String?) {
        if branchData?.id ?? 0 == self.selectedBranch?.id ?? 0 && customerData?.id ?? 0 == selectedCustomer?.id ?? 0{
            return
        }
        self.selectedBranch = branchData
        self.selectedCustomer = customerData
        self.viewForCustomer.isHidden = false
        let strCustomer = "Customer name: \(customerData?.name ?? "")\nBranch name: \(branchData?.name ?? "")"
        let attrCustomer = NSMutableAttributedString.init(string: strCustomer, attributes: [NSAttributedString.Key.foregroundColor : AppConstants.Colors.kAppGrayThemeColor,NSAttributedString.Key.font:AppConstants.GlobalFontConstants.kRegularFont(size: AppConstants.DeviceType.IS_IPAD ? 17 : 15)])
        attrCustomer.addFontAttribute(title: "Customer name", fontSize: AppConstants.DeviceType.IS_IPAD ? 17 : 15)
        attrCustomer.addFontAttribute(title: "Branch name", fontSize: AppConstants.DeviceType.IS_IPAD ? 17 : 15)
        lblCustomerInfo.attributedText = attrCustomer
        callGetRepoVisitAPI()
        viewForSelectCustomer.isHidden = true
    }
}

extension RepoVisitVC:alertClickedDelegate{
    func alertButtonClicked(index: Int,value:String) {
        if index == 1{
            callDeleteRepoVisitAPI()
        }
    }
}
