//
//  DispatchDetailVC.swift
//  globalfoods
//
//  Created by Apple on 04/01/21.
//

import UIKit

class DispatchesDetailCell: UITableViewCell {
    
    @IBOutlet weak var lblDispatchNo:UILabel!
    @IBOutlet weak var lblCusotmerName:UILabel!
    @IBOutlet weak var lblCustomerAddress:UILabel!
    @IBOutlet weak var lblCustomerCity:UILabel!
    @IBOutlet weak var lblCustomerPinCode:UILabel!
    @IBOutlet weak var lblCustomerPhone:UILabel!
    @IBOutlet weak var lblStatus:UILabel!
    @IBOutlet weak var lblBillingEmail:UILabel!
    @IBOutlet weak var lblBillingName:UILabel!
    @IBOutlet weak var lblBillingAddress:UILabel!
    @IBOutlet weak var lblBillingCity:UILabel!
    @IBOutlet weak var lblBillingPinCode:UILabel!
    @IBOutlet weak var lblBillingPhone:UILabel!
    @IBOutlet weak var lblDriverEmail:UILabel!
    @IBOutlet weak var lblDriverName:UILabel!
    @IBOutlet weak var lblVehicleName:UILabel!
    @IBOutlet weak var lblVehicleNo:UILabel!
    @IBOutlet weak var lblDriverPhone:UILabel!
    
    @IBOutlet weak var viewForDispatch:UIView!
    @IBOutlet weak var viewForBilling:UIView!
    @IBOutlet weak var viewForVehicle:UIView!
    
    override class func awakeFromNib() {
        
    }
}

class DispatchDetailVC: UIViewController {

    @IBOutlet weak var tblDispatch:UITableView!
    
    var customHeaderView:HeaderView?
    var popRecognizer: InteractivePopRecognizer?
    var dispatchDetail:DispatchDetailModel!
    var dispatchId = 0
    var arrItems = [DispatchItemsModel]()
    var isFromOrder = false
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
        setHeaderView()
        setInteractiveRecognizer()
        callGetDispatchDetailAPI()
    }
    
    //MARK: Create Viewcontrlloer instance
    static func instance()->DispatchDetailVC?{
        return UIStoryboard.init(name: "SubViews", bundle: nil).instantiateViewController(withIdentifier: "DispatchDetailVC") as? DispatchDetailVC
    }
    
    //MARK: General methods
    func setHeaderView(){
        if customHeaderView != nil{
            customHeaderView!.removeFromSuperview()
            customHeaderView = nil
        }
        customHeaderView = HeaderView.init(controller: self, title: "Dispatch Details", isBackEnbaled: true)
    }
    
    private func setInteractiveRecognizer() {
        guard let controller = navigationController else { return }
        popRecognizer = InteractivePopRecognizer(controller: controller)
        controller.interactivePopGestureRecognizer?.delegate = popRecognizer
    }
    
    func callGetDispatchDetailAPI(){
        var param = [String:String]()
        param["key"] = AppConstants.commonConstant.kAPIKey
        param["s"] = "27"
        param["dispatch_id"] = "\(dispatchId)"
        AppCommonMethods.startProgressBar()
        WebServiceManager.shared.requestAPIwithURlEncoding(params: param, urlString: AppConstants.APIURLs.kServiceGeneralURL) { (message, response) in
            DispatchQueue.main.async {
                var aMessage = message
                AppCommonMethods.stopProgressBar()
                if response != nil{
                    if AppConstants.isInDevlopmentMode{
                        print("Dispatch Data:",response!)
                    }
                    if let result = response!["result"] as? NSDictionary, response!.getIntValue("ack") ?? 0 == 1{
                        if let data = AppCommonMethods.convertToJson(object: result){
                            let jsonDecoder = JSONDecoder()
                            if let aData = try? jsonDecoder.decode(DispatchDetailModel.self, from: data){
                                self.dispatchDetail = aData
                                self.arrItems = aData.arrProducts ?? [DispatchItemsModel]()
                                self.tblDispatch.reloadData()
                                return
                            }
                        }
                    }else{
                        aMessage = response!.getStringValue("ack_msg") ?? ""
                    }
                }
                AppValidation.shared.showAlertView(parentVC: self, withAlertTile: AppConstants.GlobalAlert.ALERT_TITLE, withAlertMsg: aMessage, withActionsTitle: [AppConstants.GlobalAlert.ALERT_BTN_OK], withActionsType: [.default]) { (index) in
                    
                }
            }
            
        }
    }
}

extension DispatchDetailVC:UITableViewDataSource,UITableViewDelegate{
    func numberOfSections(in tableView: UITableView) -> Int {
        if dispatchDetail == nil{
            return 0
        }
        return 3
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if section == 1{
            return arrItems.count+1
        }
        return 1
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        if indexPath.section == 2{
            let cell = tableView.dequeueReusableCell(withIdentifier: "OrderPriceDetailCell", for: indexPath) as! OrderPriceDetailCell
            cell.lblDiscount.superview?.isHidden = true
            cell.lblGrandTotal.superview?.isHidden = true
            cell.lblTotalPrice.superview?.isHidden = true
            if let data = AppConstants.userData{
                if data.showPrice ?? 0 == 1{
                    cell.lblTotalPrice.superview?.isHidden = false
                    cell.lblGrandTotal.superview?.isHidden = false
                    cell.lblTotalPrice.text = String.init(format: "%@%.2f", AppConstants.currencySign ,dispatchDetail.subTotal ?? 0)
                    cell.lblGrandTotal.text = String.init(format: "%@%.2f", AppConstants.currencySign ,dispatchDetail.grandTotal ?? 0)
                    if dispatchDetail.discount ?? 0 != 0{
                        cell.lblDiscount.superview?.isHidden = false
                        cell.lblDiscount.text = String.init(format: "%@%.2f", AppConstants.currencySign ,dispatchDetail.discount ?? 0)
                    }
                }
            }else{
                cell.lblTotalPrice.superview?.isHidden = false
                cell.lblGrandTotal.superview?.isHidden = false
                cell.lblTotalPrice.text = String.init(format: "%@%.2f", AppConstants.currencySign ,dispatchDetail.subTotal ?? 0)
                cell.lblGrandTotal.text = String.init(format: "%@%.2f", AppConstants.currencySign ,dispatchDetail.grandTotal ?? 0)
                if dispatchDetail.discount ?? 0 != 0{
                    cell.lblDiscount.superview?.isHidden = false
                    cell.lblDiscount.text = String.init(format: "%@%.2f", AppConstants.currencySign ,dispatchDetail.discount ?? 0)
                }
            }
            
            if dispatchDetail.remarks ?? "" == ""{
                cell.viewForRemark.isHidden = true
            }else{
                cell.viewForRemark.isHidden = false
                cell.lblRemark.text = dispatchDetail.remarks ?? ""
            }
            return cell
        }
        if indexPath.section == 0{
            let cell = tableView.dequeueReusableCell(withIdentifier: "DispatchesDetailCell", for: indexPath) as! DispatchesDetailCell
            if isFromOrder{
                cell.viewForVehicle.isHidden = true
                cell.viewForDispatch.isHidden = true
            }else{
                cell.viewForVehicle.isHidden = false
                cell.viewForDispatch.isHidden = false
                if dispatchDetail.vehicleName ?? "" == "" && dispatchDetail.vehicleNo ?? "" == "" && dispatchDetail.driverName ?? "" == "" && dispatchDetail.driverEmail ?? "" == "" && dispatchDetail.driverPhone ?? "" == ""{
                    cell.viewForVehicle.isHidden = true
                }
                cell.lblDispatchNo.setLabelAttributedText(title: "Dispatch no", value: dispatchDetail.dispatchNo ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16, shoulHideLabel: true)
                cell.lblCusotmerName.setLabelAttributedText(title: "Customer name", value: dispatchDetail.customerName ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16, shoulHideLabel: true)
                cell.lblCustomerAddress.setLabelAttributedText(title: "Customer address", value: dispatchDetail.customerAddress ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16, shoulHideLabel: true)
                cell.lblCustomerCity.setLabelAttributedText(title: "Customer city", value: dispatchDetail.customerCity ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16, shoulHideLabel: true)
                cell.lblCustomerPhone.setLabelAttributedText(title: "Customer phone", value: dispatchDetail.customerPhone ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16, shoulHideLabel: true)
                cell.lblCustomerPinCode.setLabelAttributedText(title: "Customer pincode", value: dispatchDetail.customerPincode ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16, shoulHideLabel: true)
                cell.lblStatus.setLabelAttributedText(title: "Status", value: dispatchDetail.statusSlug ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16, shoulHideLabel: true)
                cell.lblVehicleName.setLabelAttributedText(title: "Vehicle name", value: dispatchDetail.vehicleName ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16, shoulHideLabel: true)
                cell.lblVehicleNo.setLabelAttributedText(title: "Vehicle no", value: dispatchDetail.vehicleNo ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16, shoulHideLabel: true)
                cell.lblDriverName.setLabelAttributedText(title: "Driver name", value: dispatchDetail.driverName ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16, shoulHideLabel: true)
                cell.lblDriverEmail.setLabelAttributedText(title: "Driver email", value: dispatchDetail.driverEmail ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16, shoulHideLabel: true)
                cell.lblDriverPhone.setLabelAttributedText(title: "Driver phone", value: dispatchDetail.driverPhone ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16, shoulHideLabel: true)
            }
            
            cell.lblBillingName.setLabelAttributedText(title: "Billing name", value: dispatchDetail.billingName ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16, shoulHideLabel: true)
            cell.lblBillingAddress.setLabelAttributedText(title: "Billing address", value: dispatchDetail.billingAddress ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16, shoulHideLabel: true)
            cell.lblBillingCity.setLabelAttributedText(title: "Billing city", value: dispatchDetail.billingCity ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16, shoulHideLabel: true)
            cell.lblBillingPinCode.setLabelAttributedText(title: "Billing pincode", value: dispatchDetail.billingPincode ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16, shoulHideLabel: true)
            cell.lblBillingPhone.setLabelAttributedText(title: "Billing phone", value: dispatchDetail.billingPhone ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16, shoulHideLabel: true)
            cell.lblBillingEmail.setLabelAttributedText(title: "Billing email", value: dispatchDetail.billingEmail ?? "", fontSize: AppConstants.DeviceType.IS_IPAD ? 18 : 16, shoulHideLabel: true)
            
            return cell
        }
        if indexPath.row == 0{
            let cell = tableView.dequeueReusableCell(withIdentifier: "ProductHeaderCell", for: indexPath) as! ProductHeaderCell
            return cell
        }
        let cell = tableView.dequeueReusableCell(withIdentifier: "OrderDetailViewCell", for: indexPath) as! OrderDetailViewCell
        let model = arrItems[indexPath.row-1]
        cell.lblName.text = model.itemName ?? ""
        cell.lblQty.text = String.init(format: "%.1f", model.itemQty ?? 0)
        
        cell.lblPrice.text = ""
        if let data = AppConstants.userData{
            if data.showPrice ?? 0 == 1{
                cell.lblPrice.text = String.init(format: "%@%.2f", AppConstants.currencySign ,model.itemTotalPrice ?? 0)
            }
        }else{
            cell.lblPrice.text = String.init(format: "%@%.2f", AppConstants.currencySign ,model.itemTotalPrice ?? 0)
        }
        return cell
    }
}
