//
//  WebViewController.swift
//  globalfoods
//
//  Created by Apple on 19/11/20.
//

import UIKit
import WebKit

class WebViewController: UIViewController {

    @IBOutlet weak var webView: WKWebView?
    var strURL = ""
    var customHeaderView:HeaderView?
    var popRecognizer: InteractivePopRecognizer?
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
        AppCommonMethods.startProgressBar(isInteractive: true)
        if webView != nil{
            webView!.navigationDelegate = self
            if let url = URL(string: strURL.addingPercentEncoding(withAllowedCharacters: CharacterSet.urlQueryAllowed) ?? "") {
                let request = URLRequest(url: url)
                webView!.load(request)
            }
        }
        setHeaderView()
        setInteractiveRecognizer()
    }
    
    deinit {
        webView = nil
    }
    
    //MARK: Create Viewcontrlloer instance
    static func instance()->WebViewController?{
        return UIStoryboard.init(name: "SubViews", bundle: nil).instantiateViewController(withIdentifier: "WebViewController") as? WebViewController
    }
    
    //MARK: General methods
    func setHeaderView(){
        if customHeaderView != nil{
            customHeaderView!.removeFromSuperview()
            customHeaderView = nil
        }
        customHeaderView = HeaderView.init(controller: self, title: "PDF Report", isBackEnbaled: true)
    }

    private func setInteractiveRecognizer() {
        guard let controller = navigationController else { return }
        popRecognizer = InteractivePopRecognizer(controller: controller)
        controller.interactivePopGestureRecognizer?.delegate = popRecognizer
    }
}

//MARK: WebView Methods
extension WebViewController:WKNavigationDelegate{
    func webView(_ webView: WKWebView, didFinish navigation: WKNavigation!) {
        AppCommonMethods.stopProgressBar()
    }
    
    func webView(_ webView: WKWebView, didFail navigation: WKNavigation!, withError error: Error) {
        print(error.localizedDescription)
        AppCommonMethods.stopProgressBar()
    }
}
